; Version 4.51
; Copyright 1995-2001 by Freedom Scientific BLV Group, LLC

Include "HjGlobal.jsh" ; default HJ global variables
Include "hjconst.jsh" ; default HJ constants
Include "HjHelp.jsh" ; Help Topic Constants
Include "common.jsm" ; message file
Include "magic.jsh"
Include "magcodes.jsh"
Include "fhp.jsh"
include "WinStyles.jsh"; Win Style Bits Constants used by the GetWindowStyleBits function
use "magic.jsb"
use "say.jsb"
use"Braille.jsb"
Use"Virtual.jsb"
use"TutorialHelp.jsb"
use "MSNHelper.jsb"
use"VKeyboard.jsb";For the Select Symbol To Print dialog.
Const
;	UT_OutputModes
	UT_SAYTYPEANDTEXT = 0,
	UT_FOCUS = 1,
	UT_CONTROLID = 2,
	UT_CLASS = 3,
	UT_TYPE = 4,
	UT_SUBTYPE = 5,
	UT_REALNAME = 6,
	ut_ObjectName = 0,
	ut_ObjectType = 1,
	ut_ObjectSubType = 2
Globals
	int WindowClosed,
	int ClipboardTextChanged,
	handle hHomeRowPos,
	int iHomeRowSpeakWindowVisibility,
	int iHomeRowAppMainWindowAlert,
; Voice and SayAll globals
	int globalVoiceChanges,
	string globalVoiceName,
	; vars to contain the current setting for each context
	int GlobalPcRate,
	int GlobalPcVolume,
	int GlobalPcPitch,
	int GlobalJawsRate,
	int GlobalJawsVolume,
	int GlobalJawsPitch,
	int GlobalKeyboardRate,
	int GlobalKeyboardVolume,
	int GlobalKeyboardPitch,
	int GlobalMessageRate,
	int GlobalMessageVolume,
	int GlobalMessagePitch,
	int globalVoiceRate,
	int globalVoiceVolume,
	int globalVoicePitch,
	; FHP var, check to see if FHP is on
	; for re-ordering of the way things are spoken when pressing Escape from a Startmenu submenu 
	int iWin95,
	int giSuppressStartMenu,
	;For detection of Windows 2000, possibly XP
	;To handle the Next/PriorCharacter Tutor Event logic which does not appear to allow access keys to be spoken on menu bars
	;Because TutorEvent isn't being called.
	int iWin2K,
	int GlobalHelperFunc,
	;For SelectAFrame and GetAllFramesText scripts
	string gstrFrameText,
	string gstrFrameList


Void Function AutoStartEvent ()
let GlobalMousePixel = 3
FrameClearValues ()
VirtualStart ()
if (DefaultFirstTime == 0) then
	let DefaultFirstTime = 1
	Let iWin95 = IsWinNTOr95 ()
	Let iWin2K = ((!iWin95)&&(GetWindowsOS ()==OS_WIN_NT))
	Let GITblHeaders=TBL_HEADER_BOTH;Default behavior
	If (!IsJFWInstall()) then
		;SayFormattedMessage (ot_app_start, cmsgAppStart1_L, cmsgAppStart1_S)
	endIf
endIf ; DefaultFirstTime == 0
If BrailleInUse () then
	Let GIBrailleActive = on
	BrailleStart ()
EndIf
InitializeMSNSupport();For MSN Messenger Contact speaking.
let BackForward=0
EndFunction

Void Function AutoFinishEvent ()
;Put code here that will be triggered when the application is finished.
;It also gets performed when the application is switched from or looses focus, as with ALT+TAB.
;SayFormattedMessage (ot_debug, cmsgDebugAppFinish1_L)
EndFunction

Script JawsWindow()
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
JawsWindow()
EndScript

Script StartJawsTaskList ()
; 12-11-98 - TGS - Added this script that basically just calls the built in of the same name.
; Bring up the Jaws Task List Dialog.  This function requires that JawsTaskList.dll be in the JAWSdirectory
If UserBufferIsActive () then
	UserBufferDeActivate ()
EndIf
if InHJDialog () then 
	SayFormattedMessage (OT_error, cMSG337_L, cMSG337_S)
	return
endIf
StartJawsTaskList()
EndScript

Script JawsEnd ()
var
	int iWinType
JAWSEnd()
if IsPCCursor() then
	let iWinType = GetWindowSubTypeCode (GetCurrentWindow ())
	If ! iWinType then
		Let iWinType = GetObjectSubTypeCode ()
	EndIf
	if (iWinType == WT_TABCONTROL ||
		iWinType == WT_UPDOWNSLIDER ||
		iWinType == WT_TASKBAR ||
		iWinType == WT_LEFTRIGHTSLIDER) then
		delay(2)
		SayWord()
		return
	endIf
	SayCurrentScriptKeyLabel ()
	return
endIf
SayFormattedMessage (ot_status, cmsg1_L) ; end
EndScript

Script JawsHome ()
var
	int iWinType
JAWSHome()
if IsPCCursor() then
	let iWinType = GetWindowSubTypeCode (GetCurrentWindow ())
	If ! iWinType then
		Let iWinType = GetObjectSubTypeCode ()
	EndIf
	if (iWinType == WT_TABCONTROL ||
	iWinType == WT_TASKBAR ||
	IWinType == WT_UPDOWNSLIDER ||
	iWinType == WT_LEFTRIGHTSLIDER) then
		delay(2)
		SayWord()
		return
	endIf
	SayCurrentScriptKeyLabel ()
	return
endIf
SayFormattedMessage (ot_status, cmsg2_L) ; home
EndScript

;*******
;Accompanying functions for the Windows 2000 Character Navigation
;Ensure that the class name is not a tool bar (MSAA), and that the OS is Windows 2000/XP?

void Function MenuAccessKeyHelper ()
If GlobalMenuMode > 0 then
	If iWin2K then
		If GetWindowClass (GetFocus ()) != cWcNewStartMenu then; This class handled by ActiveItemChangedEvent
			Let GlobalHelperFunc = ScheduleFunction ("TutorHelper", 3)
		EndIf
	EndIf
EndIf
EndFunction

void Function TutorHelper()
;Scheduled from character navigation
TutorMessageEvent(GetFocus (), GlobalMenuMode)
EndFunction

Script SayPriorCharacter ()
var
	int TheTypeCode,
	handle hCurrentWindow,
	string sClass,
	string sMessage
PriorCharacter()
if ((IsLeftButtonDown()) || (IsRightButtonDown())) then
	SelectingText(TRUE)
	pause ()
	SelectingText(false)
	return
endIf
if not IsPCCursor() then
	SayCharacter()
	return
endIf
let hCurrentWindow = GetCurrentWindow()
let TheTypeCode = GetWindowSubTypeCode (hCurrentWindow)
If ! TheTypeCode then
	Let TheTypeCode = GetObjectSubTypeCode ()
EndIf
if (TheTypeCode == WT_TABCONTROL ||
TheTypeCode == WT_TASKBAR ||
TheTypeCode == WT_UPDOWNSLIDER ||
TheTypeCode == WT_LEFTRIGHTSLIDER) then
	SayWord()
	return
endIf
if CaretVisible() then
	SayCharacter()
	Return
else
	If (TheTypeCode == WT_MENU) then
		let sMessage = FormatString (cmsg3_L, GetWindowText (hCurrentWindow, true))
		SayFormattedMessage (ot_control_type, sMessage) ;"Menu"
		MenuAccessKeyHelper()
		return
	endIf
	if (TheTypeCode == WT_STARTMENU) then
	;Win 98 and later handle start menu via MSAA
		Let sClass = GetWindowClass (hCurrentWindow)
		If sClass != cWcNewStartMenu &&
		sClass != cWcListView &&
		sClass != cwc290 then
			SayWindow (hCurrentWindow, READ_HIGHLIGHTED)
		EndIf
		If (MagGetState () > 0)then
			TrackStartMenu(hCurrentWindow, 0)
		endIf
		return
	endIf
	if (TheTypeCode == WT_CONTEXTMENU) then
		let sMessage = FormatString (cmsg5_L, GetWindowText (hCurrentWindow, true))
		SayFormattedMessage (ot_control_type, sMessage) ;"Context Menu"
		return
	endIf
	If (TheTypeCode == WT_TREEVIEW) && !MenusActive () then
		SayTreeViewLevel ()
	endIf
endIf
MenuAccessKeyHelper()
EndScript

Script SayNextCharacter ()
var
	int TheTypeCode,
	handle hCurrentWindow,
	string sClass,
	string sMessage
NextCharacter()
if ((IsLeftButtonDown()) || (IsRightButtonDown())) then
	SelectingText(TRUE)
	pause ()
	SelectingText(false)
	return
endIf
if not IsPCCursor() then
	SayCharacter()
	return
endIf
let hCurrentWindow = GetCurrentWindow()
let TheTypeCode = GetWindowSubTypeCode (hCurrentWindow)
If ! TheTypeCode then
	Let TheTypeCode = GetObjectSubTypeCode ()
EndIf
if (TheTypeCode == WT_TABCONTROL ||
	TheTypeCode == WT_TASKBAR ||
	TheTypeCode == WT_UPDOWNSLIDER ||
	TheTypeCode == WT_LEFTRIGHTSLIDER) then
	SayWord()
	return
endIf
if CaretVisible() then
	SayCharacter()
	Return
else
	If (TheTypeCode == WT_MENU) then
		let sMessage = FormatString (cmsg3_L, GetWindowText (hCurrentWindow, true))
		SayFormattedMessage (ot_control_type, sMessage) ;"Menu"    	
		MenuAccessKeyHelper ()
		return
	endIf
	if (TheTypeCode == WT_STARTMENU) then
	;Win 98 and later handle start menu via MSAA
		Let sClass = GetWindowClass (hCurrentWindow)
		If sClass != cWcNewStartMenu &&
		sClass != cWcListView &&
		sClass != cwc290 then;Button
			SayWindow (hCurrentWindow, READ_HIGHLIGHTED)
		EndIf
		If (MagGetState () > 0)then
			TrackStartMenu(hCurrentWindow, 0)
		endIf
		return
	endIf
	if (TheTypeCode == WT_CONTEXTMENU) then
		let sMessage = FormatString (cmsg5_L, GetWindowText (hCurrentWindow, true))
		SayFormattedMessage (ot_control_type, sMessage) ;"Context Menu"
		return
	endIf
	If (TheTypeCode == WT_TREEVIEW) && !MenusActive () Then
		SayTreeViewLevel ()
	endIf
endIf
MenuAccessKeyHelper()
EndScript

Script SayPriorLine ()
var
	int TheTypeCode
PriorLine()
if (IsLeftButtonDown ()) then
	SelectingText(TRUE)
	pause ()
	SelectingText(false)
	return
endIf
if not IsPCCursor () then
	SayLine()
	return
endIf
let TheTypeCode = GetWindowSubTypeCode (GetCurrentWindow ())
If ! TheTypeCode then
	Let TheTypeCode = GetObjectSubTypeCode ()
EndIf
If (TheTypeCode == WT_TASKBAR) then
	SayWord ()
	Return
endIf
if (TheTypeCode == WT_UPDOWNSLIDER) || (TheTypeCode == WT_LEFTRIGHTSLIDER) then
	SayWord ()
	return
endIf
if (TheTypeCode == WT_TABCONTROL) then
	SayWord()
	return
endIf
if theTypeCode==wt_edit_spinbox then
	Say(GetLine(),OT_LINE)
	return
endIf
if theTypeCode==wt_editCombo then
	;sayWindow(globalFocusWindow,read_everything)
	return
endIf
if CaretVisible() then
	SayLine()
	return
endIf
If ((TheTypeCode == WT_MULTISELECT_LISTBOX) || (TheTypeCode == WT_EXTENDEDSELECT_LISTBOX)) then
	SayLine()
endIf
If TheTypeCode==WT_TreeView Then
	SayTreeViewLevel()
endIf
EndScript

Script SayNextLine()
var
	int TheTypeCode
NextLine()
if (IsLeftButtonDown ()) then
	SelectingText(TRUE)
	pause ()
	SelectingText(false)
	return
endIf
if  not IsPCCursor () then
	SayLine ()
	return
endIf
let TheTypeCode = GetWindowSubTypeCode (GetCurrentWindow ())
If ! TheTypeCode then
	Let TheTypeCode = GetObjectSubTypeCode ()
EndIf
If (TheTypeCode == WT_TASKBAR) then
	SayWord ()
	Return
endIf
if (TheTypeCode == WT_UPDOWNSLIDER) || (TheTypeCode == WT_LEFTRIGHTSLIDER) then
	SayWord ()
	return
endIf
if (TheTypeCode == WT_TABCONTROL) then
	SayWord()
	return
endIf
if theTypeCode==wt_edit_spinbox then
	Say(GetLine(),OT_LINE)
	return
endIf
if theTypeCode==wt_editCombo then
	;sayWindow(globalFocusWindow,read_everything)
	return
endIf
if CaretVisible () then
	SayLine ()
	return
endIf
If ((TheTypeCode == WT_MULTISELECT_LISTBOX) || (TheTypeCode == WT_EXTENDEDSELECT_LISTBOX)) then
 SayLine()
endIf
If TheTypeCode==WT_TreeView Then
	SayTreeViewLevel()
endIf
EndScript

Script ControlUpArrow ()
var
	int TheTypeCode,
	int MenuMode
let MenuMode =  GlobalMenuMode
let TheTypeCode = GetObjectSubTypeCode ()
if IsJAWSCursor () || IsVirtualPCCursor () then
	PerformScript SayPriorParagraph()
	return
endIf
if DialogActive () ||
	((TheTypeCode == WT_TREEVIEW) ||
	(TheTypeCode == WT_TREEVIEWITEM) ||
	(TheTypeCode == 	WT_EDITCOMBO) ||
	(TheTypeCode == WT_Listbox) ||
	(TheTypeCode == WT_LISTBOXITEM) ||
	(TheTypeCode == WT_LISTVIEW) ||
	(TheTypeCode == WT_LISTVIEWITEM) ||
	(TheTypeCode == WT_Combobox) ||
	(TheTypeCode == WT_MULTISELECT_LISTBOX) ||
	(TheTypeCode == WT_EXTENDEDSELECT_LISTBOX))||
	GetWindowClass (GetCurrentWindow ())== cwcMsoCmd then
	TypeKey(cks1) ; move without removing selection
	pause ()
	SayLine()
	return
endIf
if (GetObjectTypeCode() == WT_TABCONTROL) then
	SayWord()
	return
endIf
if (MenuMode > 0) then return
endIf
	PerformScript SayPriorParagraph()
EndScript

Script ControlDownArrow ()
var
	int MenuMode,
	int TheTypeCode
let MenuMode =  GlobalMenuMode
let TheTypeCode = GetObjectSubtypeCode()
if IsJAWSCursor () || IsVirtualPCCursor () then
	PerformScript SayNextParagraph()
	return
endIf
if  DialogActive () ||
((TheTypeCode == WT_TREEVIEW) ||
(TheTypeCode == WT_TREEVIEWITEM) ||
(TheTypeCode == WT_LISTVIEW) ||
(TheTypeCode == WT_LISTVIEWITEM) ||
(TheTypeCode == 	WT_EDITCOMBO) ||
(TheTypeCode == WT_Listbox) ||
(TheTypeCode == WT_LISTBOXITEM) ||
(TheTypeCode == WT_Combobox) ||
(TheTypeCode == WT_MULTISELECT_LISTBOX) ||
(TheTypeCode == WT_EXTENDEDSELECT_LISTBOX)) ||
GetWindowClass (GetCurrentWindow ())==cwcMsoCmd then
	TypeKey(cks2) ; move without removing selection
	pause ()
	SayLine()
	return
endIf
if (GetObjectTypeCode() == WT_TABCONTROL) then
	TypeKey(cks2)
	SayWord()
	return
endIf
if (MenuMode > 0) then TypeKey(cks2)
	return
endIf
PerformScript SayNextParagraph()
EndScript

Script  JawsPageDown()
var
	int iWinType
JAWSPageDown()
if IsVirtualPCCursor () then
	SayCurrentScriptKeyLabel ()
	SayLine ()
	return
endIf
if IsPCCursor() then
	let iWinType = GetWindowSubTypeCode (GetCurrentWindow ())
	If ! iWinType then
		Let iWinType = GetObjectSubTypeCode ()
	EndIf
	if (iWinType == WT_TABCONTROL ||
	iWinType == WT_UPDOWNSLIDER ||
	iWinType == WT_LEFTRIGHTSLIDER) then
		delay(2)
		SayWord()
		return
	endIf
endIf
If (! IsPcCursor () && ! IsVirtualPcCursor ()) then
	SayFormattedMessage (OT_STATUS, cmsg7_L); "Page down"
Else
	SayCurrentScriptKeyLabel ()
endIf
EndScript

Script JawsPageUp()
var
	int iWinType
JAWSPageUp()
if IsVirtualPCCursor () then
	SayCurrentScriptKeyLabel ()
	SayLine ()
	return 
endIf
if IsPCCursor() then
	let iWinType = GetWindowSubTypeCode (GetCurrentWindow ())
	If ! iWinType then
		Let iWinType = GetObjectSubTypeCode ()
	EndIf
	If (iWinType == WT_TABCONTROL ||
	iWinType == WT_UPDOWNSLIDER ||
	iWinType == WT_LEFTRIGHTSLIDER) then
		delay(2)
		SayWord()
		return
	endIf
endIf
If (! IsPcCursor () && ! IsVirtualPcCursor ()) then
	SayFormattedMessage (OT_STATUS, cmsg8_L) ; "Page up"
Else
	SayCurrentScriptKeyLabel ()
endIf
EndScript

Script PCCursor ()
ResetSynth ()
PCCursor ()
If IsVirtualPCCursor () then
	SayFormattedMessage (ot_status, cMSG288_L, cMSG288_S) ; virtual pc cursor
	TurnOffFormsMode()
	BrailleRefresh ()
	return
else
	SayFormattedMessage (ot_status, cmsg9_L, cmsg9_S) ; "PC Cursor"
endIf
if BrailleInUse () then
	RouteBrailleToPC ()
endIf
if IsPCCursor () then
	TurnOffFormsMode()
endIf
BrailleRefresh ()
EndScript

Script  JawsCursor ()
If UserBufferIsActive () then
	SayFormattedMessage (OT_NO_DISABLE, cmsgVirtualViewer)
	Return
EndIf
ResetSynth ()
if (IsSameScript ()) then
	InvisibleCursor()
	SayFormattedMessage (OT_STATUS, cmsg10_L, cmsg10_S) ;"invisible Cursor"
	BrailleRefresh ()
	Return
else
	JAWSCursor ()
	SayFormattedMessage (ot_status, cmsg11_L, cmsg11_S) ;"JAWS Cursor"
	if BrailleInUse () then
		RouteBrailleToJaws ()
	endIf
endIf
BrailleRefresh ()
EndScript

Void Function SetActiveCursor (int nCursor)
if (nCursor == CURSOR_JAWS) then
	JAWSCursor ()
elif (nCursor == CURSOR_INVISIBLE) then
	InvisibleCursor()
else
	PcCursor ()
endIf
EndFunction

Script  GraphicsLabeler()
GraphicsLabeler()
EndScript

Script SayDriveLetter ()
var
	int x
let x=0
InvisibleCursor ()
RouteInvisibleToPc ()
while ((GetCharacter () != "(")	&& (x<5))
	NextWord ()
	let x=x+1
endwhile
if (x != 5) then
	NextCharacter ()
	SayCharacter ()
endIf
PcCursor ()
EndScript

Script  SaySpecialWindowClasses()
var
	handle WinHandle,
	string sMessageShort,
	string sMessageLong,
	string sClass,
	string sSpell
let winHandle = GetCurrentWindow ()
If (winHandle) then ;window handle is not 0
	if (TimesPressedDefault < 4) then
		let TimesPressedDefault = TimesPressedDefault + 1
	else
		let TimesPressedDefault = 1 ; reset it
	endIf ; if times Pressed
if TimesPressedDefault == 1 then
	while (GetParent (WinHandle)) ; loop until 0
		let WinHandle = GetParent (WinHandle)
		let sClass = GetWindowClass (winHandle)
		let sSpell = GetSpellString (sClass)
		let sMessageShort = FormatString (cmsg18_S, sClass, sSpell)
		let sMessageLong = FormatString (cmsg18_L, sClass, sSpell)
		SayFormattedMessage (ot_help, sMessageLong, sMessageShort) ;"Parents class ="
	EndWhile
	SayFormattedMessage (ot_help, cmsg19_L) ; Top level window
	return
endIf ; times pressed =1
if (TimesPressedDefault == 2) then
	let WinHandle = GetPriorWindow (WinHandle)
	let sClass = GetWindowClass (winHandle)
	let sSpell = GetSpellString (sClass)
	let sMessageShort = FormatString (cmsg20_S, sClass, sSpell)
	let sMessageLong = FormatString (cmsg20_L, sClass, sSpell)
	SayFormattedMessage (ot_help, sMessageLong, sMessageShort) ;"Parents class ="
	return
endIf ; times pressed = 2
if (TimesPressedDefault == 3) then
	let WinHandle = GetNextWindow (WinHandle)
	let sClass = GetWindowClass (winHandle)
	let sSpell = GetSpellString (sClass)
	let sMessageShort = FormatString (cmsg21_S, sClass, sSpell)
	let sMessageLong = FormatString (cmsg21_L, sClass, sSpell)
	SayFormattedMessage (ot_help, sMessageLong, sMessageShort) ;"Parents class ="
	return
endIf ; times pressed = 3
if (TimesPressedDefault == 4) then
	let WinHandle = GetFirstChild (WinHandle)
	let sClass = GetWindowClass (winHandle)
	let sSpell = GetSpellString (sClass)
	let sMessageShort = FormatString (cmsg22_S, sClass, sSpell)
	let sMessageLong = FormatString (cmsg22_L, sClass, sSpell)
	SayFormattedMessage (ot_help, sMessageLong, sMessageShort) ;"Parents class ="
	return
endIf ; times pressed = 4
else ; handle = 0
	SayFormattedMessage (ot_help, cmsg23_L, cmsg23_S) ;"the window handle is 0"
endIf
EndScript

Script JawsBackspace()
var
	string strChar,
	int TheTypeCode,
	string sClass
If IsVirtualPcCursor () then
	If UserBufferIsActive () then
		Return; Do not process unless so directed in app-specific script file
	EndIf
EndIf
let TheTypeCode = GetObjectSubtypeCode()
SaveCursor ()
PcCursor ()
If TheTypeCode < 1 then
	let SClass = GetWindowClass (GetFocus ())
	If sClass == cwcTTY || sClass == cwcTTYGrab then
		BackSpaceMSDos ()
		RestoreCursor ()
		Return
	endIf
endIf
If ((TheTypeCode == WT_TREEVIEW) || (TheTypeCode == WT_LISTVIEW)) then
	TypeKey(cks3)
	return
endIf
Let strChar = GetPriorCharacter ()
If strChar == cScNull then
	Let strChar = cMsgBlank1
ElIf strChar == cScSpace then
	let strChar = cMsgSpace1
EndIf
Say (strChar, OT_CHAR)
TypeKey (cKs3)
EndScript

Void Function BackSpaceMSDos () ; Handles special character recognition in dos windows
; The code here does not calculate resolution
; into the mix, because DOS windows appear to be resolution-independent
var
	int iRow,
	int iCol,
	int iNewCol
SaveCursor ()
PcCursor ()
let iRow = getCursorRow ()
let iCol = getCursorCol ()
InvisibleCursor ()
;Fixed calculation works here, because DOS windows appear to be static
MoveTo (iCol-9, iRow+3)
SayCharacter ()
RestoreCursor ()
TypeKey(cks3)
EndFunction

Script JawsDelete()
var
	int TheTypeCode
SaveCursor ()
PCCursor ()
If IsVirtualPcCursor () then
	If UserBufferIsActive () then
		Return; Do not process unless so directed in app-specific script file
	EndIf
EndIf
Let TheTypeCode = GetWindowSubTypeCode (GetFocus ())
If ! TheTypeCode then
	let TheTypeCode = GetObjectSubtypeCode()
EndIf
TypeKey(cks4)
if ((TheTypeCode == WT_LISTBOX) ||
(TheTypeCode == WT_LISTVIEW) ||
(TheTypeCode == WT_LISTBOXITEM) ||
(TheTypeCode == WT_LISTVIEWITEM)||
(TheTypeCode == WT_TREEVIEWITEM) ||
(TheTypeCode == WT_TREEVIEW)) then
	return
endIf
delay (1)
SayCharacter()
RestoreCursor ()
EndScript

Script  RestrictJawsCursor()
;This script is no longer current
;Please use the updated script RestrictCurrentCursor
if ToggleRestriction() then
	SayFormattedMessage (ot_status, cmsg24_L, cmsg24_S) ;"Restriction on Jaws Cursor"
else
	SayFormattedMessage (ot_status, cmsg25_L) ;"restriction off Jaws Cursor"
endIf
EndScript

Script  ShutDownJAWS()
If UserBufferIsActive () then
	UserBufferDeActivate ()
EndIf
SayFormattedMessage (ot_jaws_message, cmsg26_L) ;"Unloading JAWS"
ShutDownJAWS()
EndScript

Script SayWindowTitle()
var
	handle hCurrentWindow,
	handle hRealWindow,
	handle hAppWindow,
	int iTypeCode,
	string sMessageShort,
	string sMessageLong,
	string sPageShort,
	string sPageLong,
	string sText1,
	string sText2,
	string sText3,
	string sFrame,
	string sHeading
let hCurrentWindow = GetCurrentWindow()
if (hCurrentWindow == 0) then ; No focus
	SayFormattedMessage (OT_HELP, cmsg96_L, cmsg96_S) ; speak No Focus message
	Return
endIf
; we use window subtype code as object subtype code doesn't distinguish sys tray from other toolbars
Let iTypeCode = GetWindowSubTypeCode (hCurrentWindow)
; only when window subtype code returns 0 do we check object subtype code
if !iTypeCode then
	let iTypeCode=getObjectSubtypeCode()
endIf
If UserBufferIsActive () then
	If IsVirtualPcCursor () then
		SayMessage (OT_NO_DISABLE, cmsgVirtualViewer)
		Return
	EndIf
EndIf
if IsVirtualPCCursor() then
let sFrame=GetHTMLFrameName()
let sHeading=GetCurrentHeading()
if (sHeading) then
SayFormattedMessage(OT_NO_DISABLE, FormatString(msgHeadingIs_L,sHeading),FormatString(msgHeadingIs_S,sHeading))
endIf
if sFrame then
	SayFormattedMessage(OT_NO_DISABLE, FormatString(msgFrameIs_L,sFrame),FormatString(msgFrameIs_S,sFrame))
endIf
endIf
let hRealWindow = GetRealWindow (hCurrentWindow)
let hAppWindow = GetAppMainWindow (hCurrentWindow)
If (iTypeCode == WT_STARTBUTTON) then 
	let sMessageShort = FormatString (cmsg27_S, cmsg31_L)
	let sMessageLong = FormatString (cmsg27_L, cmsg31_L)
	SayFormattedMessage (ot_no_disable, sMessageLong, sMessageShort)
	Return 
endIf    
If (iTypeCode == WT_STARTMENU) then
	let sText1 = GetWindowText (hCurrentWindow, true)
	let sMessageShort = FormatString (cmsg28_S, cmsg4_L, sText1)
	let sMessageLong = FormatString (cmsg28_L, cmsg4_L, sText1)
	SayFormattedMessage (ot_no_disable, sMessageLong, sMessageShort)
	Return
endIf
If GlobalMenuMode == menubar_Active then
; the menubar is active but the menus haven't dropped down
	let sText1 = GetWindowName (hAppWindow)
	let sText2=getMenuName()
	if sText2==cscNull then
		let sText2=getWord()
	endIf
	let sMessageShort=formatString(cMsgMenubarItem_S,sText1, sText2)
	let sMessageLong=formatString(cMsgMenubarItem_L,sText1, sText2)
	SayFormattedMessage (ot_no_disable, sMessageLong, sMessageShort)
	Return
EndIf
If (iTypeCode == WT_MENU) then
; the menu has dropped down
	let sText1 = getWindowName(hAppWindow)
	let sText2=getWindowText(hCurrentWindow,read_highlighted)
	let sMessageShort = FormatString (cmsgMenuItem_S, sText1, sText2)
	let sMessageLong = FormatString (cmsgMenuItem_L, sText1, sText2)
	SayFormattedMessage (ot_no_disable, sMessageLong, sMessageShort)
	Return
endIf
If (iTypeCode == WT_CONTEXTMENU) then
	let sText1 = GetWindowText (hCurrentWindow, true)
	let sMessageShort = FormatString (cmsg28_S, cmsg5_L, sText1)
	let sMessageLong = FormatString (cmsg28_L, cmsg5_L, sText1)
	SayFormattedMessage (ot_no_disable, sMessageLong, sMessageShort)
	Return
endIf
If (iTypeCode == WT_TASKBAR) then 
	let sMessageShort = FormatString (cmsg27_S, cmsg32_L)
	let sMessageLong = FormatString (cmsg27_L, cmsg32_L)
	SayFormattedMessage (ot_no_disable, sMessageLong, sMessageShort)
	return
endIf    
if iTypeCode==wt_sysTray then
let sMessageShort=formatString(cMsg28_S, cMsgSystray_S, getObjectName())
let sMessageLong=formatString(cMsg28_L, cMsgSysTray_L, getObjectName())
	SayFormattedMessage(ot_no_disable, sMessageLong, sMessageShort)
	return
endIf
if (iTypeCode==wt_button || iTypeCode==wt_toolbar) && getWindowClass(getParent(getParent(hCurrentWindow)))==cwcShellTray then
	let sMessageShort=formatString(cMsg28_S, cMsgDesktopToolbar_S, getObjectName())
	let sMessageLong=formatString(cMsg28_L, cMsgDesktopToolbar_L, getObjectName())
	SayFormattedMessage(ot_no_disable, sMessageLong, sMessageShort)
	return
endIf
let sText1 = GetWindowName (hAppWindow)
If ((hRealWindow != hAppWindow) && (hRealWindow != hCurrentWindow)) then
		let sText2 = GetWindowName (hRealWindow)
endIf
If (IsMultiPageDialog ()) then
	if sText2==cscNull then
	let sText2=sText1
endIf
	let sText3 = GetDialogPageName ()
	let sPageShort = FormatString (cmsg30_S, sText2, sText3)
	let sPageLong = FormatString (cmsg30_L, sText2, sText3)
	SayFormattedMessage(ot_no_disable, sPageLong, sPageShort)
	return
endIf
if stringContains(sText1, sText2) then
; app window title contains document name as well
	let sText2 = cscNull
endIf
Let sMessageShort = FormatString (cMsg29_S, sText1, sText2)
Let sMessageLong = FormatString (cmsg29_L, sText1, sText2)
SayFormattedMessage (ot_no_disable, sMessageLong, sMessageShort)
EndScript

Void Function SpeakWindowInformation (handle hWnd)
var
	handle hNextWindow,
	int iType,; For subtypecode of hWnd, to keep tab controls and other undesirables from speaking.
	int iNextType
If (GetWindowSubTypeCode (hWnd) == WT_COMBOBOX) then
	If (GetWindowSubTypeCode (GetFirstChild (hWnd)) == WT_EDITCOMBO) then
		;The appropriate prompt will get spoken when the child is processed.
		Return
	EndIf
   EndIf
Let hNextWindow = GetNextWindow (hWnd)
If GetWindowSubTypeCode (hWnd) == WT_STATIC then
	If GetWindowSubTypeCode (hNextWindow) == WT_Static ||
	StringLength (GetWindowText (hWnd, false)) > 5 then
		Let iNextType = GetWindowSubTypeCode (hNextWindow)
		If iNextType == WT_EDIT ||
		iNextType == WT_READONLYEDIT ||
		iNextType == WT_EDITCOMBO ||
		iNextType == WT_SLIDER ||
		iNextType == WT_UPDOWNSLIDER ||
		iNextType == WT_UPDOWNSLIDER ||
		iNextType == WT_COMBOBOX then
			;Do nothing, Type and Text on the next window picks this static up.
			SayFormattedMessage (OT_CONTROL_NAME, cscNull)
		Else
			SayWindow (hWnd, READ_EVERYTHING)
		endIf
	endIf
Else; Not static
	If iType == WT_DIALOG ||
	iType == WT_TABCONTROL then
		SayFormattedMessage (OT_CONTROL_NAME, cscNull)
	Else
		SayWindowTypeAndText (hWnd)
	endIf
endIf
EndFunction

Void Function DoChildWindows (handle hWnd)
var
	handle hPos
Let hPos = hWnd
While (hPos)
	If IsWindowVisible (hPos) then
		SpeakWindowInformation (hPos)
	endIf
	Let hPos = GetNextWindow (hPos)
EndWhile
EndFunction

Script ReadBoxInTabOrder()
;Reads thru Dialog Box in Tab order
var
	int safety,
	handle hWnd,
	handle hPos ; for dialog inside a dialog
let safety = 0
let hWnd = GetRealWindow(GetCurrentWindow())
if DialogActive () then
	SayFormattedMessage (OT_ERROR, formatString(cMsg33_L,getWindowName(hwnd)), cMsgSilent);"Reed Box in tab order "
	; work our way through all child windows of the dialog
	if (IsMultiPageDialog ()) then
		let hWnd = GetFocus()
		while ((GetPriorWindow (hWnd)) && (Safety < 100))
			let hWnd = GetPriorWindow (hWnd)
			let Safety = Safety + 1
		endwhile
		while (IsWindowVisible (hWnd) == FALSE)
			let hWnd = GetNextWindow (hWnd)
		endwhile
	else; if not multipage dlg
		let hWnd = GetFirstChild (hWnd)
	endIf
	while (hWnd)
		If IsWindowVisible (hWnd) then
			SpeakWindowInformation (hWnd)
		endIf
		Let hPos = GetFirstChild (hWnd)
		If hPos then
			DoChildWindows (hPos); Check the windows at first child position
		endIf
		let hWnd = GetNextWindow (hWnd)
	EndWhile
	return
endIf
SayMessage (OT_NO_DISABLE, GetWindowTextEx(getAppMainWindow(hwnd),read_everything, TRUE))
EndScript

Void Function ItemNotFoundEvent (int hwnd)
; event indicating that the requested item can't be found in the OSM
;beep();Debug
EndFunction

Void Function KeyPressedEvent (int nKey, string strKeyName, int nIsBrailleKey, int nIsScriptKey)
; Add your code for KeyPressedEvent here.
; Changes made here apply to all applications.
; To make your changes application specific, copy this function to an
; application script file.
; SayInteger (nkey)
let WindowClosed = false;
let ClipboardTextChanged = false
If UserBufferIsActive () && UserBufferIsTrappingKeys() then
	If NKey == KEY_LEFT_WINDOWS || 
	nKey == KEY_RIGHT_WINDOWS || 
	nKey == KEY_CONTEXT ||
	nKey == KEY_ALT_TAB then
		UserBufferDeactivate ()
		;Press the key, as it was previously eaten
		If nKey == KEY_LEFT_WINDOWS || nKey == KEY_RIGHT_WINDOWS then ; StartMenu
			ActivateStartMenu ()
		ElIf NKey == KEY_CONTEXT then
			TypeKey (cKs23)
		EndIf
	EndIf
EndIf
EndFunction

void function ObjStateChangedEvent (handle hObj)
var
	int iObjType,
	int nState
Let iObjType = GetWindowSubTypeCode (GetFocus ())
If ! iObjType then ; Object
	Let iObjType = GetObjectSubTypeCode ()
EndIf
;Exclude non-checkable subtypes
If iObjType == WT_CHECKBOX ||
iObjType == WT_RADIOBUTTON ||
iObjType == WT_3STATE ||
;Items that may or may not be checkable
iObjType == WT_LISTBOX ||
iObjType == WT_LISTVIEW ||
iObjType == WT_TREEVIEW then
	;Handle the IEServer windows separately, i.e. the old-fashoined ControlCanBeChecked blah blah 
	;But otherwise use the Control Attributes as gives access to more controls
	If GetWindowClass (GetFocus ()) == cwcIEServer then ;||
		;Delay (3)
		Let nState = ControlIsChecked()
		If (nState == 1) then
			SayFormattedMessage (ot_ITEM_STATE, cMSG293_L)
		Else 
			SayFormattedMessage (ot_item_state, cmsg294_L) ; not checked
		EndIf
		Return;
	EndIf
	Let nState = GetControlAttributes ()
	;Include trees, lists, etc. whenever possible via attributes.
	;Delay (2)
	If (GetControlAttributes() & CTRL_CHECKED) then
		SayFormattedMessage (ot_ITEM_STATE, cMSG293_L)
	ElIf (GetControlAttributes () & CTRL_UNCHECKED) then
		SayFormattedMessage (ot_item_state, cmsg294_L) ; not checked
	EndIf
ElIf iObjType == WT_BUTTON ||
iObjType == WT_OUTLINEBUTTON then
	If GetControlAttributes () & CTRL_EXPANDED ||
	GetControlAttributes () & CTRL_COLLAPSED then
		;Delay (3)
		SayLine ()
	EndIf
	;SayFormattedMessage (OT_ITEM_STATE, GetObjectState ())
EndIf
EndFunction

Void Function FocusPointMovedEvent (int nX, int nY, int nOldX, int nOldY, int nUnit, int nDir, int nTimeElapsed)
; Add your code for FocusPointMovedEvent here.
; Changes made here apply to all applications.

; To make your changes application specific, copy this function to an
; application script file.
EndFunction

Void Function NewTextEvent (handle hwnd, string buffer, int nAttributes,
int nTextColor, int nBackgroundColor, int nEcho, string sFrameName)
; Handles all newly written text.  If the text is contained in a
; frame, then the frame name is passed as a parameter
; handle MSN conversations wanting attention
CheckForUrgentConversation (hwnd, buffer)
if (ProcessSelectText(nAttributes,buffer)) then
	return
endIf
if (nAttributes& ATTRIB_HIGHLIGHT) then
	SayHighlightedText(hwnd,buffer)
else
	SayNonHighlightedText(hwnd,buffer)
endIf
EndFunction

Void Function SayHighLightedText (handle hwnd, string buffer)
; HighlightedText Function for speaking all newly written highlighted
; text.
var
	int iWinType,
	string strVal,
	string sClass
Let iWinType = GetWindowSubTypeCode (hWnd)
If ! iWin95 then
	Let sClass = GetWindowClass (hWnd)
	If sClass != cWcMenuClass then ; Menu class is context menus in start menu
		If (iWinType == WT_STARTMENU) then
			;In 98/2000/ME, we handle via MSAA so don't speak here
			Return
		EndIf
	EndIf
EndIf
if (GetScreenEcho() > 0) then 
	if (iWinType == WT_TREEVIEW) then
		SayTreeViewLevel ()
		Return
	endIf
	Say (buffer, ot_no_disable) 		
endIf
EndFunction

Void Function SayNonHighlightedText (handle hwnd, string buffer)
; NonHighlightedText  Function for speaking all newly written nonhighlighted
; text.
; Commented code added 09/24/99 by DB
; for use with Dos Boxes and Console apps
var
	string TheClass
let TheClass = GetWindowClass(hwnd)
; for Windows 95, 98 and/or NT
; Just remove the c-style /* */ comments around this block of code
; if you wish Jaws to speak automatically in Dos Windows
; for text output, such as command prompt or command-line apps such as FTP and Ping
/*
If (GetScreenEcho () >= 1) then
	If (TheClass == "tty" || 
	TheClass == "ttygrab" || 
	TheClass == "TelnetWClass" || 
	TheClass == "ConsoleWindowClass") then
		Say (buffer, OT_no_disable);
		Return
	endIf
endIf
*/
;cwn1="#32771"
if ((GetScreenEcho() > 1) ||
(TheClass == cwn1 )) then 
	Say (buffer, ot_no_disable) 
endIf
EndFunction

Void Function SelectingText(int nMode)
; handles setting up for and finishing the process of selecting text
; called by each of the scripts which does text selection
var
	string strHighlightAfterSelect,
	string strUnselected,
	string strNewlySelected,
	int nChanged,
	int nStart,
	int nChars
if (nMode) then
	let g_strHighlightBeforeSelect = GetSelectedText()
	let nSelectingText = nMode
else
	Delay(1) 
	ProcessNewText()
	let nSelectingText = 0 
	if (IsVirtualPCCursor()) then
		return
	endIf
	let strHighlightAfterSelect = GetSelectedText()
	let	strUnselected = StringDiff(g_strHighlightBeforeSelect,strHighlightAfterSelect)
	if (strUnselected) then
		; if there's highlighted text prior to the selection command that
		; doesn't exist after the command, this is either because the command
		; deselected the text or the text scrolled off of the screen.
		; We assume that if the text was at the beginning of the old buffer
		; and it isn't in the new buffer, then it scrolled off.
		; This should be true except when selecting text from bottom to top,
		; and deselecting from top to bottom, 
		;something that most people probably don't do
		if (!StringsOverlap(g_strHighlightBeforeSelect,strHighlightAfterSelect,nStart,nChars) || nStart <2)then
			If nSaySelectAfter then
				SayMessage (OT_WORD, strUnSelected)
				SayMessage (OT_SELECT, cmsg214_L)
			Else
				SayMessage (OT_SELECT, cmsg214_L)
				SayMessage (OT_WORD, strUnSelected)
			EndIf
			let nChanged = nChanged+1
		endIf
	endIf
	let strNewlySelected = StringDiff(strHighlightAfterSelect,g_strHighlightBeforeSelect)
	if (strNewlySelected) then
		If nSaySelectAfter then
			SayMessage (OT_WORD, strNewlySelected)
			SayMessage (OT_SELECT, cmsg215_L)
		Else
			SayMessage (OT_SELECT, cmsg215_L)
			SayMessage (OT_WORD, strNewlySelected)
		EndIf
		let nChanged = nChanged+1
	endIf
	if (!nChanged) then
		if (StringsOverlap(g_strHighlightBeforeSelect,strHighlightAfterSelect,nStart,nChars))then
			let strNewlySelected =  SubString(strHighlightAfterSelect,nChars+1,9999)
			If nSaySelectAfter then
				SayMessage (OT_WORD, strNewlySelected)
				SayMessage (OT_SELECT, cmsg215_L)
			Else
				SayMessage (OT_SELECT, cmsg215_L)
				SayMessage (OT_WORD, strNewlySelected)
			EndIf
		endIf
	endIf
endIf
EndFunction

    void Function ProcessSelectText(int nAttributes,string buffer)
; called at the beginning of the NewTextEvent to check for and
; handle speaking of text being  selected/unselected.  If this function
; returns TRUE, then the NewTextEvent abandons regular processing.
var
	string smyBuf
if (nSelectingText == 1) then
;	return TRUE to indicate that this text requires no further
;	handling in NewTextEvent
	return TRUE
else
	if (nAttributes & ATTRIB_UNSELECTED) then
;	 	only relevant when text is being selected/unselected
;	 	return TRUE to indicate that this text requires no further handling
		return  TRUE
	else
		return false ; allow regular processing
	endIf
endIf
if (nAttributes & ATTRIB_HIGHLIGHT|| nAttributes & ATTRIB_UNSELECTED) then
	let smyBuf = Buffer
	if ((nAttributes & ATTRIB_UNSELECTED) && (nSelectingText != 2)) then
		let nSelectingText = 2
		if (ShouldItemSpeak (ot_select)) then
			let smyBuf = FormatString (cmsg214_L, buffer);unselected
		endIf
	elif ((nAttributes & ATTRIB_HIGHLIGHT) && (nSelectingText != 4)) then
		let nSelectingText = 4
		if (ShouldItemSpeak (ot_select)) then
			let smyBuf = FormatString (cmsg215_L, buffer);selected
		endIf
	endIf
	Say(smyBuf, ot_no_disable)
	return true
else
	return FALSE
endIf
EndFunction

Script TopOfFile()
JAWSTopOfFile()
delay (1)
if IsVirtualPCCursor () then
	SayLine ()
	return
endIf
SayFormattedMessage (ot_jaws_message, cmsg36_L, cmsg36_S) ;"top of file"
SayLine()
EndScript

Script BottomOfFile()
JAWSBottomOfFile()
Delay (1)
if IsVirtualPCCursor () then
	SayLine ()
	return
endIf
SayFormattedMessage (ot_jaws_message, cmsg37_L, cmsg37_S) ;"Bottom of file"
SayLine()
EndScript

Script SayFont ()
; Identify Font
var
	string sFont,
	string sMessageLong
;If IsVirtualPcCursor () then ; No longer needed as we now support font info in Virtual Cursor
let sFont = GetFont ()
If ! sFont then
	SayMessage (OT_NO_DISABLE, cmsg38_S)
	Return
EndIf
let sMessageLong = FormatString (cmsg38_L, sFont)
SayFormattedMessage (ot_no_disable, sMessageLong, sFont) ;"Font is"
EndScript
Script SaySelectedText()
; Read all selected text
var
int bSpell,
	string sSelectedText,
	string sMessageLong
let bSpell=IsSameScript()
if (IsVirtualPCCursor()) then
	let sSelectedText = GetSelectedText ()
else
	let sSelectedText = GetWindowText (GetCurrentWindow (), true)
endIf
if bSpell then
SayFormattedMessage(OT_SPELL,sSelectedText)
return
endIf
let sMessageLong = FormatString (cmsg39_L, sSelectedText)
SayFormattedMessage (ot_no_disable, sMessageLong, sSelectedText)
EndScript



; **/1 Start of Selecting Text
Script SelectToEndOfLine()
Let nSaySelectAfter = FALSE
SelectingText(TRUE)
SelectToEndOfLine ()
SelectingText(FALSE)
EndScript

Script SelectFromStartOfLine()
Let nSaySelectAfter = FALSE
SelectingText(TRUE)
SelectFromStartOfLine ()
SelectingText(FALSE)
EndScript

Script SelectNextLine()
var
	int nSubType
Let nSubType = GetWindowSubTypeCode (GetFocus ())
If ! nSubType then
	Let nSaySelectAfter = FALSE
ElIf nSubType == WT_LISTVIEW then
	Let nSaySelectAfter = TRUE
ElIf nSubType == WT_TREEVIEW then
	Let nSaySelectAfter = TRUE
ElIf nSubType == WT_LISTBOX then
	Let nSaySelectAfter = TRUE
ElIf nSubType == WT_MULTISELECT_LISTBOX then
	Let nSaySelectAfter = TRUE
ElIf nSubType == WT_EXTENDEDSELECT_LISTBOX then
	Let nSaySelectAfter = TRUE
Else
	Let nSaySelectAfter = FALSE
EndIf
SelectingText(TRUE)
SelectNextLine ()
SelectingText(FALSE)
EndScript

Script SelectPriorLine()
var
	int nSubType
Let nSubType = GetWindowSubTypeCode (GetFocus ())
If ! nSubType then
	Let nSaySelectAfter = FALSE
ElIf nSubType == WT_LISTVIEW then
	Let nSaySelectAfter = TRUE
ElIf nSubType == WT_TREEVIEW then
	Let nSaySelectAfter = TRUE
ElIf nSubType == WT_LISTBOX then
	Let nSaySelectAfter = TRUE
ElIf nSubType == WT_MULTISELECT_LISTBOX then
	Let nSaySelectAfter = TRUE
ElIf nSubType == WT_EXTENDEDSELECT_LISTBOX then
	Let nSaySelectAfter = TRUE
Else
	Let nSaySelectAfter = FALSE
EndIf
SelectingText(TRUE)
SelectPriorLine ()
SelectingText(FALSE)
EndScript

Script SelectNextCharacter()
Let nSaySelectAfter = TRUE
SelectingText(TRUE)
SelectNextCharacter ()
SelectingText(FALSE)
Let nSaySelectAfter = FALSE
EndScript

Script SelectPriorCharacter()
Let nSaySelectAfter = TRUE
SelectingText(TRUE)
SelectPriorCharacter ()
SelectingText(FALSE)
Let nSaySelectAfter = FALSE
EndScript

Script SelectNextWord()
Let nSaySelectAfter = TRUE
SelectingText(TRUE)
SelectNextWord ()
SelectingText(FALSE)
Let nSaySelectAfter = FALSE
EndScript

Script SelectPriorWord()
Let nSaySelectAfter = TRUE
SelectingText(TRUE)
SelectPriorWord ()
SelectingText(FALSE)
Let nSaySelectAfter = FALSE
EndScript

Script SelectNextScreen()
Let nSaySelectAfter = FALSE
SelectingText(TRUE)
SelectNextScreen ()
SelectingText(FALSE)
EndScript

Script  SelectPriorScreen()
Let nSaySelectAfter = FALSE
SelectingText(TRUE)
SelectPriorScreen ()
SelectingText(FALSE)
EndScript

Script  SelectToBottom()
Let nSaySelectAfter = FALSE
SelectingText(TRUE)
SelectToBottom ()
SelectingText(FALSE)
EndScript

Script  SelectFromTop()
Let nSaySelectAfter = FALSE
SelectingText(TRUE)
SelectFromTop ()
SelectingText(FALSE)
EndScript

; **/2 End of Selecting Text Scripts

Script CloseDocumentWindow ()
TypeKey(cks5)
If (! DialogActive ()) then
	; Only initialize variable if child window was actually closed
	let WindowClosed = true
endIf
EndScript

Script OpenListBox ()
var int TheTypeCode, int nMagAltMode
;nMagAltMode < 0 ;Magic not running
;nMagAltMode = 0 ;Shift arrow keys used for manual panning
;nMagAltMode = 1 ;Alt arrow keys used for manual panning
let TheTypeCode = GetObjectSubtypeCode()
;If MAGic is running and Manual panning is on the alt keys
if (MagGetState () > 0) then
	let nMagAltMode = MagGetOption (MPK_ALT)
	if (nMagAltMode == 1) then
		;The screen is magnified
		Say (cmag2 /*down*/, OT_jaws_message)
		TypeKey(cks6)
		return
	endIf
endIf
if IsJAWSCursor () || IsVirtualPCCursor () then
	PerformScript SayNextSentence()
	return
endIf
if  DialogActive () ||
((TheTypeCode == WT_TREEVIEW) ||
  (TheTypeCode == WT_Listview) ||
  (TheTypeCode == 	WT_EDITCOMBO) ||
  (TheTypeCode == WT_Listbox) ||
  (TheTypeCode == WT_MULTISELECT_LISTBOX) ||
  (TheTypeCode == WT_EXTENDEDSELECT_LISTBOX))  ||
  (TheTypeCode == WT_Combobox) ||
   GetWindowClass (GetCurrentWindow ()) == cwcMsoCmd then
	TypeKey(cks6)
	; Only say opening listbox if this is a combo box	 or EditCombo
	if (TheTypeCode == 	WT_EDITCOMBO ||
	   TheTypeCode == WT_Combobox) then
	   SayFormattedMessage (ot_jaws_message, cmsg41_L, cmsgSilent)
	   ;open list box
		 EndIf
	return
endIf
PerformScript SayNextSentence()
EndScript

Script CloseListBox()
var	int TheTypeCode,	int nMagAltMode
;nMagAltMode < 0 ;Magic not running
;nMagAltMode = 0 ;Shift arrow keys used for manual panning
;nMagAltMode = 1 ;Alt arrow keys used for manual panning
let TheTypeCode = GetObjectSubtypeCode()
if (MagGetState () > 0) then
	;If MAGic is running and Manual panning is on the alt keys
	let nMagAltMode = MagGetOption (MPK_ALT)
	if (nMagAltMode == 1) then
		;The screen is magnified
		Say (cmag1 /*UP*/, OT_jaws_message)
		TypeKey(cks7)
		return
	endIf
endIf
if IsJAWSCursor () || IsVirtualPCCursor () then
	PerformScript SayPriorSentence()
	return
endIf
if  DialogActive () ||
 ((TheTypeCode == WT_TREEVIEW) ||
  (TheTypeCode == 	WT_EDITCOMBO) ||
  (TheTypeCode == WT_Listbox) ||
  (TheTypeCode == WT_LISTVIEW) ||
  (TheTypeCode == WT_MULTISELECT_LISTBOX) ||
  (TheTypeCode == WT_EXTENDEDSELECT_LISTBOX))  ||
  (TheTypeCode == WT_Combobox) ||
   GetWindowClass (GetCurrentWindow ()) == cwcMsoCmd then
	TypeKey(cks7)
	; Only say closing listbox if this is a combo box	 or EditCombo
	if (TheTypeCode == 	WT_EDITCOMBO ||
	   TheTypeCode == WT_Combobox) then
		SayFormattedMessage (ot_jaws_message, cmsg42_L, cmsgSilent) ;close listbox
		 EndIf
	return
endIf
PerformScript SayPriorSentence()
EndScript

Script SelectAll ()
SelectEntireDocument()
EndScript

Script  PassKeyThrough()
;cmsg43_L = "Enter key to pass thru"
SayFormattedMessage (ot_jaws_message, cmsg43_L, cmsg43_S) 
PassKeyThrough()
EndScript

Void Function TopEdgeEvent (handle WindowHandle)
var
	int iWinType
Let iWinType = GetWindowSubTypeCode (WindowHandle)
If BrailleFHPTopEdge () then
	Return
EndIf
/*
If iWinType == WT_MULTISELECT_LISTBOX ||
iWinType == WT_EXTENDEDSELECT_LISTBOX ||
iWinType == WT_LISTBOX||
iWinType == WT_LISTVIEW ||
iWinType == WT_BUTTONLISTBOX then
	Beep ()
	SayFormattedMessage (ot_jaws_message, cmsg44_L, cmsg44_S) ;"Top of window"
	Return
endIf
*/
EndFunction

Void Function BottomEdgeEvent (handle WinHandle)
var
	int iWinType
Let iWinType = GetWindowSubTypeCode (WinHandle)
If BrailleFhpBottomEdge () then
	Return
EndIf
/*
If iWinType == WT_MULTISELECT_LISTBOX ||
iWinType == WT_EXTENDEDSELECT_LISTBOX ||
iWinType == WT_LISTBOX||
iWinType == WT_LISTVIEW ||
iWinType == WT_BUTTONLISTBOX then
Beep ()
	SayFormattedMessage (ot_jaws_message, cmsg45_L, cmsg45_S) ;"Bottom of Window"
	Return
endIf
*/
EndFunction

Void Function FocusChangedEvent (handle FocusWindow, handle PrevWindow)
var
	handle RealWindow,
	string RealWindowName,
	handle AppWindow
let RealWindow = GetRealWindow (FocusWindow)
let RealWindowName = GetWindowName (RealWindow)
let AppWindow = GetAppMainWindow (FocusWindow)
if (GlobalPrevApp != AppWindow && AppWindow != FocusWindow) then
	; we've switched to a different app main window,
	; and it does not have the focus, so announce it
	If ! GlobalWasHjDialog then
		SayWindowTypeAndText (AppWindow)
	EndIf
endIf
If ((GlobalPrevRealName != RealWindowName) ; name has changed
|| (GlobalPrevReal != RealWindow)) then ; or handle has changed, then
	If ((RealWindow != AppWindow) && (RealWindow != FocusWindow)) then
		If ! GlobalWasHjDialog &&
		! GISuppressStartMenu then
			;GlobalWasHjDialog prevents over chatter, especially when exiting a list box and returning to a client area.
			;Set to FALSE when one HjDialog follows another
			;Example:
			;AddBrailleColors function
			;The GISuppressStartMenu function set to TRUE on account of the Real Window Name in Windows XP
			SayWindowTypeAndText (RealWindow)
		EndIf
	endIf
endIf
let GlobalFocusWindow = FocusWindow
;************
;This branch of code is now legacy.
;*** You can change it in your app-specific code,
;*****or leave it as it is without consequence.
;*********You will still find this block, or its derivatives
;********** in Freedom Scientific Code.
;***We are making the change to accomodate the more expansive use of
;****** the SayWindowTypeAndText function
;********Note that we have not changed the old functionality of 
;******* The SayFocusedWindow function
;if (GlobalPrevFocus != focusWindow &&
;   GetWindowTypeCode(focusWindow) != WT_TOOLBAR &&
;   GetWindowSubTypeCode(focusWindow) != WT_CONTEXTMENU) then
;	If GlobalWasHjDialog && ! InHjDialog () then
;		;Avoid reading titles over and over and over ...
;		If ! UserBufferIsActive () then; Virtual.jsb handles this
;			SayLine ()
;		EndIf
;	ElIf GetWindowSubTypeCode(FocusWindow) == wt_StartMenu  then
;		;	need to handle submenus of start menu and moving from level to level here
;		if not giSuppressStartMenu then
;			SayObjectActiveItem()
;		endIf
;	Else
;		SayFocusedWindow () ; will use global variable GlobalFocusWindow
;	EndIf
;else
;	SayFocusedObject ()
;endIf
;****** End of legacy code*
;
;If in Start Menu,
;And not in Win NT or 95,
; Speak Object Name instead of the whole Object Type And Text information
If GetWindowSubTypeCode (FocusWindow) == WT_STARTMENU ||
;Windows XP, the Type code is ListView, so
RealWindowName == cWnStartMenu then
	If GISuppressStartMenu &&
	! iWin95 then
		Say (GetObjectName (), OT_CONTROL_NAME)
	EndIf
	;Solve Japan problem where
	;Exit Documents menus was not reporting accurate state.
	Let GISuppressStartMenu = TRUE
Else
	;Turn off Start Menu flag,
	;As we are not in the Start Menu, probably launched application or simply exited
	Let GISuppressStartMenu = FALSE; 
	SayFocusedWindow ()
EndIf
;above perform will return here to finish this routine
;now set all the global variables for next time.
let GlobalPrevReal = RealWindow
let GlobalPrevRealName = RealWindowName
let GlobalPrevApp = AppWindow
let GlobalPrevFocus = FocusWindow
Let GlobalWasHjDialog = InHjDialog ()
EndFunction

Void Function ActiveItemChangedEvent (handle curHwnd, int curObjectId, int curChildId,
	handle prevHwnd, int prevObjectId, int prevChildId)
var
	handle hWinSwitch
;Keepp alt+tab from over-talking
let hWinSwitch=findTopLevelWindow(cwn1,cscNull)
if (hWinSwitch && isWindowVisible(hWinSwitch)) then
	Return
EndIf
; tabcontrols are spoken by the sayNext/priorChar scripts so if we're using MSAA we don't want 
;to doublespeak
if GetObjectSubtypeCode()==wt_tabControl then
	return
endIf
SaveCursor ()
PCCursor ()
SayObjectActiveItem()
If GlobalMenuMode == 1 then
	;TutorMessageEvent (CurHwnd, GlobalMenuMode)
EndIf
RestoreCursor ()
EndFunction

Void Function ValueChangedEvent (handle hwnd, int objId, int childId, int nObjType, string sObjName, string sObjValue)
; Enter code here for Application-Specific script files
;to act upon the change of value of the MSAA object
EndFunction

Void Function DocumentLoadedEvent ()
var
	int iElementCount,
	int nFrames,
	int nHeadings,
	int nLinks,
	string sFrames,
	string sHeadings,
	string sLinks,
	string sMessageLong,
	string sMessageShort
TurnOffFormsMode()
if BackForward == 1 then
	SayLine()
	let BackForward=0
	return
endIf
if GetWindowClass (GetFocus ()) == cwcIEServer then
	PCCursor()
	if  (IsVirtualPCCursor()) then
		let nFrames = GetHTMLFrameCount()
		;Get all headings in document
		Let nHeadings = GetHeadingCount (0)
		let nLinks = GetLinkCount()
		;The following section provides the messages to be formatted into the string for each element type:
		;Frames, headings and links.
		If nFrames == 0 then
			Let sFrames = cScNull
		ElIf nFrames == 1 then
			let sFrames = IntToString (nFrames) + cMsgFrame
			Let iElementCount = iElementCount+1
		Else
			let sFrames = IntToString (nFrames) + cMsgFrames
			Let iElementCount = iElementCount+1
		EndIf
		If nHeadings == 0 then
			Let sHeadings = cScNull
		ElIf nHeadings == 1 then
			Let sHeadings = IntToString (nHeadings)+cMsgHeading
			Let iElementCount = iElementCount+1
		Else
			Let sHeadings = IntToString (nHeadings)+cMsgHeadings
			Let iElementCount = iElementCount+1
		EndIf
		If nLinks == 0 then
			;Use specific no link message.
			Let sLinks = cMsgNoLinks
			Let iElementCount = iElementCount+1
		ElIf nLinks == 1 then
			Let sLinks = IntToString (nLinks)+cMsgLink
			Let iElementCount = iElementCount+1
		Else
			Let sLinks = IntToString (nLinks)+cMsgLinks
			Let iElementCount = iElementCount+1
		EndIf
		;The order is:
		;Frames, headings, links
		;Links will always speak, but everything else is conditional if there are any.
		If iElementCount == 3 then
			Let sMessageLong = FormatString (cmsgDocumentLoaded1_L, sFrames, sHeadings, sLinks)
			Let sMessageShort = FormatString (cmsgDocumentLoaded1_S, sFrames, sHeadings, sLinks)
		ElIf iElementCount == 2 then
			;Either frames or headings will be missing.
			; In either case, links come last.
			If nFrames then
				Let sMessageLong = FormatString (cmsgDocumentLoaded2_L, sFrames, sLinks)
				Let sMessageShort = FormatString (cmsgDocumentLoaded2_S, sFrames, sLinks)
			ElIf nHeadings then
				Let sMessageLong = FormatString (cmsgDocumentLoaded2_L, sHeadings, sLinks)
				Let sMessageShort = FormatString (cmsgDocumentLoaded2_S, sHeadings, sLinks)
			EndIf
		ElIf iElementCount == 1 then
				Let sMessageLong = FormatString (cmsgDocumentLoaded3_L, sLinks)
				Let sMessageShort = FormatString (cmsgDocumentLoaded3_S, sLinks)
		EndIf
		SayFormattedMessage (OT_SCREEN_MESSAGE, sMessageLong, sMessageShort) ; page has x frames, y headings and z links
		SayAll()
	endIf
endIf
EndFunction

void function FormsModeEvent(int bEntering)
if (bEntering) then
	let InFormsMode = true
	SayFormattedMessage (OT_status, cmsg286_L)
else
	let InFormsMode = false
	SayFormattedMessage (OT_status, cmsg287_L)
endIf
EndFunction

void function TextSelectedEvent(string strText, int bUnSelecting)
var
	int iStringLength
;First, check to see if we've selected a huge amount of text.
;Without this test, it is possible to overrun speech.
Let iStringLength = StringLength (strText)
if (bUnSelecting) then
	If iStringLength >= 1000 then
		SayFormattedMessage (OT_SELECT,cmsg214_L)
		SayMessage (OT_NO_DISABLE, FormatString (cmsg380, IntToString ((iStringLength-20))))
		SayMessage (OT_WORD, (StringChopRight (strText, (iStringLength-20))))
		Return;
	EndIf
	If nSaySelectAfter then
		SayMessage (OT_WORD, strText)
		SayFormattedMessage (OT_SELECT,cmsg214_L)
		Return
	Else
		SayFormattedMessage (OT_SELECT,cmsg214_L)
		SayMessage (OT_WORD, strText)
		Return
	EndIf
else
	If iStringLength >= 1000 then
		SayFormattedMessage (OT_SELECT,cmsg215_L)
		SayMessage (OT_NO_DISABLE, FormatString (cmsg380, IntToString ((iStringLength-20))))
		SayMessage (OT_WORD, (StringChopLeft (strText, (iStringLength-20))))
		Return;
	EndIf
	If nSaySelectAfter then
		SayMessage (OT_WORD, strText)
		SayFormattedMessage (OT_SELECT,cmsg215_L)
		Return
	Else
		SayFormattedMessage (OT_SELECT,cmsg215_L)
		SayMessage (OT_WORD, strText)
		Return
	EndIf
endIf
EndFunction

Void Function ClipboardChangedEvent ()
If ClipboardTextChanged == CLIPBOARD_COPIED then
	SayFormattedMessage (OT_JAWS_MESSAGE, cmsg52_L, cmsg52_S)
ElIf ClipboardTextChanged == CLIPBOARD_CUT then
	SayFormattedMessage (OT_JAWS_MESSAGE, cmsg51_L, cmsg51_S)
endIf
let ClipBoardTextChanged = false
EndFunction

Void Function SayFocusedWindow ()
var
	handle hWinSwitch
if MenusActive () then
	return
endIf
;Keepp alt+tab from over-talking
let hWinSwitch=findTopLevelWindow(cwn1,cscNull)
if (hWinSwitch && isWindowVisible(hWinSwitch)) then
	Return
EndIf
;SayWindowTypeAndText (GlobalFocusWindow) No longer needed here
SayFocusedObject ()
EndFunction

Void Function SayFocusedObject ()
SaveCursor ()
PCCursor ()
SayObjectTypeAndText ()
RestoreCursor ()
EndFunction

Void Function MenuModeEvent (handle WinHandle, int mode)
;The Mode parameter indicates whether the menuBar has become active, a
;Menu  has become active, or the menus are going away.  These are
;represented by the constants MENUBAR_ACTIVE, MENU_ACTIVE, and
;MENU_INACTIVE.
Var
	handle FocusWindow,
	handle RealWindow,
	string RealWindowName,
	handle AppWindow,
	int PrevMenuMode,
	int TheTypeCode,
	int nSetting,
	int NCurrentMSAAMode
let TheTypeCode = GetObjectSubTypeCode()
let PrevMenuMode = GlobalMenuMode
let GlobalPrevMenuMode = PrevMenuMode
let GlobalMenuMode=mode
let NCurrentMSAAMode=GetJCFOption (	OPT_MSAA_MODE)
If (mode == MENU_INACTIVE) then
	If (PrevMenuMode == MENUBAR_ACTIVE) then
		SayFormattedMessage (ot_jaws_message, cmsg48_L, cmsg48_S) ;"leaving menu bar"
	else
		SayFormattedMessage (ot_jaws_message, cmsg48_S) ;"Leaving menus"
	endIf
	; The following is to assist TutorialHelp
	Let FocusWindow = GetFocus (); 
	If ! TheTypeCode then
		Let TheTypeCode = GetWindowSubTypeCode (FocusWindow)
	EndIf
	;Let GlobalPrevTutorMenuMode = Mode
	return
endIf ; menu inactive
if (GetWindowSubTypeCode (WinHandle) == WT_CONTEXTMENU) then
	SayFormattedMessage (ot_jaws_message, cmsgContextMenu1) ;"Context Menu"
	TypeKey (Cks8); Select first item in menus
	Let FocusWindow = GetFocus ();
	;Let GlobalPrevTutorMenuMode = mode
	MenuModeHook ()
	return
endIf
If (mode == MENUBAR_ACTIVE) then
	SayFormattedMessage (ot_jaws_message, cmsg46_L) ;"	Menu bar"
	MenuModeHook ()
	If (nCurrentMSAAMode >= 1) then
	; Only do this if GetWord does not return a value
	; Because in Windows 2K this is the case
	; even though a menu bar option is selected
		If (GetWord () == cscNull) then
			SayObjectActiveItem ()
			Return
		endIf
		If (GetWindowSubTypeCode (GetCurrentWindow ()) != WT_TOOLBAR) then
			If (! (GetCharacterAttributes () & ATTRIB_HIGHLIGHT)) then
				if (GetWindowClass(GetCurrentWindow())!= "MsoCommandBar")	then
					SayObjectActiveItem ()
				endIf
				Return
			endIf
		endIf
	endIf
	If GetCharacter () == cScNull then ; Fudge it here to make the menu bar sound natural
		Let FocusWindow = GetFocus ();
	EndIf
	Return
endIf ; menu bar active
If (mode == MENU_ACTIVE) then
	If GetWindowSubTypeCode(WinHandle) == WT_STARTMENU then
		SayFormattedMessage (OT_JAWS_MESSAGE, cmsg4_L) ;"Start Menu"
		TypeKey (Cks8); Select Start Menu Item
		BrailleMenuModeHelper ()
		Let GISuppressStartMenu = TRUE;
	else
		SayFormattedMessage (ot_jaws_message, cmsg47_L) ;"Menu active"
	endIf ; if start menu
	MenuModeHook ()
	return
endIf ; menu active
let FocusWindow = GetFocus()
If (FocusWindow == GlobalPrevFocus) then
	let RealWindow = GetRealWindow(FocusWindow)
	let RealWindowName = GetWindowName (RealWindow)
	let AppWindow = GetAppMainWindow(FocusWindow)
	if (RealWindow != FocusWindow) then
		SayWindowTypeAndText(RealWindow)
	endIf ; verbosity beginner
	;no matter what, say the window with focus
	SayWindowTypeAndText(FocusWindow)
endIf ; focus window = global prev focus
MenuModeHook()
EndFunction

Void Function MenuModeHook ()
; This Script can be added to application Script files to add onto menu mode.
EndFunction

;**/3 start of cut/paste Scripts
Script Undo()
TypeKey (cks27)
SayFormattedMessage (OT_JAWS_MESSAGE, cmsg50_L)
EndScript

Script CutToClipboard()
let ClipboardTextChanged = Clipboard_Cut
TypeKey (cks25)
EndScript

Script CopySelectedTextToClipboard ()
let ClipboardTextChanged = CLIPBOARD_COPIED
CopySelectionToClipboard()
EndScript

Script PasteFromClipboard()
TypeKey (cKs24)
SayFormattedMessage (OT_JAWS_MESSAGE, cmsg53_L, cmsg53_S)
EndScript

; **/4 End of cut and paste scripts

Script RefreshScreen ()
;Used to refresh the screen
ReloadSystemColors()
Refresh ()
ResetVoiceSettings ()
if IsVirtualPCCursor ()
then
	SayFormattedMessage (ot_jaws_message, cmsg290_L)
return
endIf
;cmsg54_L = "Screen Refreshed"
SayFormattedMessage (ot_jaws_message, cmsg54_L, cmsg54_S)
EndScript

Int Function IsPointInWindow (handle hwnd, int x, int y)
var
	int top,
	int left,
	int bottom,
	int right
let top = GetWindowTop (hwnd)
let left = GetWindowLeft (hwnd)
let bottom = GetWindowBottom (hwnd)
let right = GetWindowRight (hwnd)
if (left <= x && x <= right && top <= y && y <= bottom) then
	return true
else
	return false
endIf
EndFunction

int Function ReadContextLine ()
var
	int iRestriction,
	handle appWindow,
	handle realWindow,
	handle focusedWindow,
	int iCounter,
	string sMessage
let focusedWindow = GetFocus ()
let RealWindow = GetRealWindow (focusedWindow)
let appWindow = GetAppMainWindow (focusedWindow)
InvisibleCursor ()
; try to find the highlighted word starting at the top of the window
MoveToWindow (appWindow)
let iCounter = 0;
while (FindNextAttribute (attrib_highlight) && 
(iCounter < 20))
	let iCounter = iCounter + 1
	if (!IsPointInWindow (realWindow, getCursorCol (), getCursorRow ()) && 
	(GetCurrentWindow () != appWindow)) then
		RouteJAWSToInvisible ()
		JawsCursor ()
		SayLine ()
;		RestoreCursor ()
		;above "restore" moves the invisible cursor away from the context
		PCCursor ()
;		to read in context turn on the JAWS cursor
		return TRUE; so we don't try to drag a dialog
	endIf
EndWhile
;start of 2nd block, search from bottom
MoveTo (GetWindowRight (appWindow) - 3, GetWindowBottom (appWindow) - 3)
;above move may not go to right spot every time, cause search to fail?
let iCounter = 0;
while (FindPriorAttribute (attrib_highlight) && (iCounter < 10))
	let iCounter = iCounter + 1
	if (!IsPointInWindow (realWindow, getCursorCol (), getCursorRow ()) && (GetCurrentWindow () != appWindow)) then
		RouteJAWSToInvisible ()
		JawsCursor ()
		SayLine () ;found it
		PCCursor ()
		return TRUE; So we won't drag the dialog
	endIf
EndWhile
;start of block 3, search from top, different criteria?
Let iRestriction = GetRestriction ()
SetRestriction (RESTRICTNONE)
JAWSPageUp () ;start at top of app
Let iCounter = 0;
while (FindNextAttribute (attrib_highlight) && (iCounter < 10))
	Let iCounter = iCounter+1
	If GetCurrentWindow () != FocusedWindow &&
	GetCurrentWindow () != RealWindow &&
	GetCurrentWindow () != AppWindow &&
	GetRealWindow(GetCurrentWindow ()) != RealWindow then
		RouteJAWSToInvisible ()
		JawsCursor ()
		SayLine () ;found it
		PCCursor ()
		Return TRUE
	EndIf
EndWhile
;start of block 4, search from bottom
InvisibleCursor ()
RouteInvisibleToPc ()
SetRestriction (RestrictAppWindow)
JawsPageDown () ;go to bottom of spell check window
SetRestriction (RestrictNone)
NextLine () ;go beyond spell check window
NextLine () ;go beyond spell check window 2 lines
SetRestriction (RestrictappWindow)
JawsPageDown() ;go to bottom of app window
JawsEnd() ;go to bottom right corner of app window
Let iCounter = 0;
while (FindPriorAttribute (attrib_highlight) && (iCounter < 10))
	Let iCounter = iCounter+1
	If GetCurrentWindow () != FocusedWindow &&
	GetCurrentWindow () != RealWindow &&
	GetRealWindow (GetCurrentWindow ()) != RealWindow && ;added this, T.H.
	GetCurrentWindow () != AppWindow then
		RouteJAWSToInvisible ()
		JawsCursor ()
		SayLine ()
		PcCursor ()
		Return TRUE;
	EndIf
EndWhile
PcCursor ()
Return FALSE;
EndFunction

void function DragDialogWindow ()
var
	int DragFromX,
	int DragFromY,
	int iJAWSCol,
	int iJAWSRow,
	string DragObject,
	int x,
	int y,
	String strObject
JawsCursor ()
Let iJAWSCol = GetCursorCol ();For JAWSCursor 
Let iJawsRow = GetCursorRow ()
MoveToWindow (GetRealWindow (GetFocus ()))
;SayWord () ;testing
let DragFromX = getCursorCol ()
let DragFromY = getCursorRow () ;save position of spell dialog
let DragObject = GetWord ()
;now move to the top of the app
MoveToWindow (GetAppMainWindow (GetFocus ()))
;SayString ("top of app = ") ;testing
;SayLine () ;testing
let x = getCursorCol ()
let y = getCursorRow () ;save position to move to
; make sure that the left mouse button is unlocked
If IsLeftButtonDown () then
	LeftMouseButtonLock ()
	pause ()
endIf
MoveTo (DragFromX, DragFromY) ;go back to spell dialog
Pause ()
;SayString ("back to dialog = ") ;testing
;SayLine () ;testing
let strObject = GetWord()
LeftMouseButtonLock () ; lock it down
pause ()
MoveTo (x,y) ;drag it
Pause ()
pause ()
pause ()
;cmsg172_L = "dragging "
;let sMessage = FormatString (cmsg172_L, strObject, GetWord ())
;SayFormattedMessage (ot_jaws_message, sMessage); dragging x to y
;SayString ("top of app = ") ;testing
;SayLine ()
LeftMouseButtonLock () ;unlock
;RestoreCursor ()
MoveTo (iJAWSCol, iJAWSRow);Put the JAWSCursor back where it was, 
;so the mouse isn't visually unpleasant
PCCursor ()
EndFunction

Script ReadWordInContext ()
; read word in context, for spell check, find, replace, etc.
If ! DialogActive () then
	SayFormattedMessage (ot_error, cmsg216_L, cmsg216_S) ; "Word in context not found "
	Return;Not available outside of dialog windows.
EndIf
If ReadContextLine () then
	Return;Found
EndIf
;now the word has not been found, move the spell dialog
PcCursor ()
DragDialogWindow ()
If ! ReadContextLine () then
	SayFormattedMessage (ot_error, cmsg216_L, cmsg216_S) ; "Word in context not found "
EndIf
EndScript

Script UpALevel()
var   
	handle hwnd,
	int TheTypeCode,
	string sMessage
SayCurrentScriptKeyLabel ()
if UserBufferIsActive() then
	UserBufferDeactivate()
	;sayFocusedWindow()
	Delay (2)
	If GetWindowSubTypeCode (GetCurrentWindow ()) != WT_TASKBAR &&
	! (GetCharacterAttributes () & ATTRIB_HIGHLIGHT) then
		SayLine ()
	EndIf
	; don't want to pass the Esc key on to the app.
	return
endIf
TypeCurrentScriptKey ()
If GIBrailleActive then
	BrailleRefresh()
endIf
SaveCursor()
PCCursor()
let hwnd = GetCurrentWindow ()
let TheTypeCode = GetWindowSubtypeCode(hwnd)
If (TheTypeCode == WT_MENU) then
	let sMessage =   FormatString (cmsg3_L, GetWindowText (hwnd, true))
	SayFormattedMessage (ot_control_name, sMessage)
	return
endIf
if (TheTypeCode == WT_STARTMENU) then
	let sMessage =   FormatString (cmsg4_L, GetWindowText (hwnd, true))
	SayFormattedMessage (ot_control_name, sMessage)
	return
endIf
if (TheTypeCode == WT_CONTEXTMENU) then
	let sMessage =   FormatString (cmsg5_L, GetWindowText (hwnd, true))
	SayFormattedMessage (ot_control_name, sMessage)
endIf
EndScript

script SayDefaultButton ()
var
	string DefaultButtonName,
	string sMessage
if (DialogActive ()) then
	let DefaultButtonName = GetDefaultButtonName ()
	if (DefaultButtonName != cscNull) then
		let sMessage =   FormatString (cmsg55_L, DefaultButtonName)
		SayFormattedMessage (ot_no_disable, sMessage, DefaultButtonName)
	else
		SayFormattedMessage (ot_error, cmsg192_L, cmsg192_S) ; "Can not determine default button in this dialog box "
	endIf
else
	SayFormattedMessage (ot_error, cmsg56_L, cmsg56_S) ;"not in a dialog box"
endIf
EndScript

;**/5  MOUSE FUNCTIONS

Script  MouseLeft()
;MouseLeft Script
MouseLeft (GlobalMousePixel)
SayFormattedMessage (ot_status, cmsg57_L, cmsg57_S) ;"Mouse Left"
EndScript

Script  MouseRight()
;MouseRight Script
MouseRight (GlobalMousePixel)
SayFormattedMessage (ot_status, cmsg58_L, cmsg58_S) ;"Mouse Right"
EndScript

Script  MouseDown()
;MouseDown Script
MouseDown (GlobalMousePixel)
SayFormattedMessage (ot_status, cmsg59_L, cmsg59_S) ;"Mouse Down"
EndScript

Script  MouseUp()
;MouseUp Script
MouseUp (GlobalMousePixel)
SayFormattedMessage (ot_status, cmsg60_L, cmsg60_S) ;"Mouse Up"
EndScript

Script  ControlLeftMouseClick()
;Control Left Mouse Click
ControlLeftMouseClick ()
SayFormattedMessage (ot_status, cmsg61_L) ;"Control Mouse Click"
EndScript

Script  ShiftLeftMouseClick()
;Shift Left Mouse Click
ShiftLeftMouseClick ()
SayFormattedMessage (ot_status, cmsg62_L) ;"Shift Mouse Click"
EndScript

Script  AltLeftMouseClick()
AltLeftMouseClick ()
SayFormattedMessage (ot_status, cmsg63_L) ;"Alt Mouse Click"
EndScript
; **/6 End of Mouse Functions

Script JAWSFind ()
var
	int bIsVirtualPCCursor
let InJAWSFind = TRUE ;flag that can be observed by other scripts
;We need to check for the virtual PC cursor before we put up the
; Find dialog, because if we check after the dialog is closed, the focus may
; not have returned to the browser window and we'd get the wrong answer
let bIsVirtualPCCursor = IsVirtualPCCursor()
if JAWSFind ()  then
	Delay(2) ;make sure the screen has redrawn 
	if (bIsVirtualPCCursor) then
		SayLine ()
	else
		SayWord()
	endIf
endIf
let InJAWSFind = FALSE
EndScript

Script JAWSFindNext ()
var
	int found
let found = JAWSFindNext ()
if (found==FALSE) then
	SayFormattedMessage (ot_error, cmsg64_L, cmsg64_S)
else
	;SayFormattedMessage (ot_jaws_message, cmsg65_L)
	SayLine()
endIf  ; ["Found", "search string NOT found"]
EndScript

Script JAWSFindPrior()
var
	int found
let found = JAWSFindNext (TRUE)
if (found==FALSE) then
	SayFormattedMessage (ot_error, cmsg64_L, cmsg64_S)
else
	;SayFormattedMessage (ot_jaws_message, cmsg65_L)
	SayLine()
endIf  ; ["Found", "search string NOT found"]
EndScript

Script  HomeRowToggle()
If (ToggleHomeRow () == OFF) then 
	SayFormattedMessage (ot_status, cmsg66_L, cmsg66_S) ; home row off
Else 
	let hHomeRowPos = GetCurrentWindow ()
	let iHomeRowAppMainWindowAlert = 0
	SayFormattedMessage (ot_status, cmsg67_L, cmsg67_S)  ; home row on
endIf 
EndScript

Script  MouseMovementDefault()
var
	string sMessageLong,
	string sMessageShort,
	string sPixel
let GlobalMousePixel = 3
let sPixel = IntToString (GlobalMousePixel)
let sMessageShort = FormatString (cmsg176_S, sPixel)
let sMessageLong = FormatString (cmsg176_L, sPixel)
SayFormattedMessage (ot_status, sMessageLong, sMessageShort)
EndScript

Script MouseMovementDecrement ()
If (GlobalMousePixel == 1) then
	let GlobalMousePixel = 50
Else
	Let GlobalMousePixel = GlobalMousePixel - 1
endIf
SayInteger (GlobalMousePixel)
EndScript

Script  MouseMovementIncrement()
If (GlobalMousePixel == 50) then
	let GlobalMousePixel = 1
Else
	Let GlobalMousePIxel = GlobalMousePixel + 1
endIf
SayInteger (GlobalMousePixel)
EndScript

Script SayMouseAndAnsiSettings()
var   
	int SpeakAnsi,
	string sMessageShort,
	string sMessageLong,
	string sPixel
let sPixel = IntToString (GlobalMousePixel)
let sMessageShort = FormatString (cmsg74_S, sPixel)
let sMessageLong = FormatString (cmsg74_L, sPixel)
SayFormattedMessage (ot_no_disable, sMessageLong, sMessageShort)
let SpeakAnsi = GetJcfOption (OPT_SPEAK_ANSI_CHARS)
If SpeakAnsi == 0 then ;no anci
	let sMessageShort = FormatString (cmsg75_S, cmsg70_S)
	let sMessageLong = FormatString (cmsg75_L, cmsg70_L)
endIf
If SpeakAnsi == 1 then 
	let sMessageShort = FormatString (cmsg75_S, cmsg71_S)
	let sMessageLong = FormatString (cmsg75_L, cmsg71_L)
endIf   ;"Some Ansi"
If SpeakAnsi == 2 then 
	let sMessageShort = FormatString (cmsg75_S, cmsg72_S)
	let sMessageLong = FormatString (cmsg75_L, cmsg72_L)
endIf  ;"More Ansi"
If SpeakAnsi == 3 then
	let sMessageShort = FormatString (cmsg75_S, cmsg73_S)
	let sMessageLong = FormatString (cmsg75_L, cmsg73_L)
endIf   ;"Most Ansi"
If SpeakAnsi == 4 then 
	let sMessageShort = FormatString (cmsg75_S, cmsg68_S)
	let sMessageLong = FormatString (cmsg75_L, cmsg68_L)
endIf   ;"All Ansi"
SayFormattedMessage (ot_no_disable, sMessageLong, sMessageShort)
EndScript

Script GraphicsMode ()
var
	int GraphicsMode
let GraphicsMode = GetJcfOption (OPT_GRAPHICS_MODE)
If (GraphicsMode == 0) then
	If (SetJcfOption (OPT_GRAPHICS_MODE, 1) == WAS_SUCCESSFUL)  then
		SayFormattedMessage (ot_status, cmsg76_L, cmsg76_S) ;"Active Graphics Mode"
	Else
		SayFormattedMessage (ot_error, cmsg77_L) ;"Active Graphics Mode could not be set"
	endIf ; WAS_SUCCESSFUL
Else
	If (SetJcfOption (OPT_GRAPHICS_MODE, 0) == WAS_SUCCESSFUL)  then
		SayFormattedMessage (ot_status, cmsg78_L, cmsg78_S) ;"Standard Graphics Mode"
	Else
		SayFormattedMessage (ot_error, cmsg79_L) ;"Standard Graphics Mode could not be set"
	endIf ; WAS_SUCCESSFUL
endIf  ; GraphicsMode == 0
EndScript

Script  SayColor()
SayColor ()
EndScript

Script MinimizeAllApps ()
MinimizeAllApps ()
SayFormattedMessage (ot_jaws_message, cmsg80_L, cmsgSilent) ;"minimize all apps"
EndScript

Script MenuBar ()
ActivateMenuBar ()
Refresh ()
EndScript

Script StartMenu ()
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
ActivateStartMenu ()
EndScript

; Keep JAWS from saying "space" in an extended select list box
Script SelectCurrentItem ()
var
	int TheTypeCode
SayCurrentScriptKeyLabel ()
TypeCurrentScriptKey ()
let TheTypeCode = GetObjectSubtypeCode()
if (TheTypeCode ==  WT_EXTENDEDSELECT_LISTBOX) then
	SayLine()
endIf
EndScript

Int Function IsSelectScriptDlg()
var
	HANDLE hExecute
If InHjDialog () then
	If (GetControlID(GetFirstChild(GetRealWindow(GetFocus()))) == ID_SELECT_DLG_LIST) then
	;cwn10 = "JAWS"
	;If (GetWindowName (GetAppMainWindow (GetCurrentWindow ())) == cwn10) then
		let hExecute = FindDescendantWindow (GetParent (GetCurrentWindow ()), ID_SELECT_DLG_EXECUTE)
		return (IsWindowVisible (hExecute))
	endIf
endIf
return FALSE
EndFunction

Int Function IsSelectItemDlg ()
var
	HANDLE hExecute
If (GetControlID(GetFirstChild(GetRealWindow(GetFocus()))) == ID_SELECT_DLG_LIST) then
	;cwn10 = "JAWS"
	If (GetWindowName (GetAppMainWindow (GetCurrentWindow ())) == cwn10) then
		let hExecute = FindDescendantWindow (GetParent (GetCurrentWindow ()), ID_SELECT_DLG_EXECUTE)
		return !(IsWindowVisible (hExecute))
	endIf
endIf
return FALSE
EndFunction

Void Function AddHotKeyLinks ()
;This is just intended to make adding a link to HotKeyHelp and WindowKeysHelp simpler
UserBufferAddText (cScBufferNewLine); Put a blank line in to ensure accurate spacing in the buffer
UserBufferAddText (cMsgHotKeysLink, cFuncHotKey, cMsgHotKeysFunc, cFont_Aerial, 12, ATTRIB_UNDERLINE, rgbStringToColor(cColor_BLUE), rgbStringToColor(cColor_White))
If IsWinKeyHelp () then ; Only do this if WindowKeysHelp is appropriate
	UserBufferAddText (cMsgWindowKeysLink, cFuncWinHotKey, cMsgWindowKeysFunc, cFont_Aerial, 12, ATTRIB_UNDERLINE, rgbStringToColor(cColor_BLUE), rgbStringToColor(cColor_White))
EndIf
UserBufferAddText (cMsgBuffExit, cScNull, cScNull, cFont_Aerial, 12, 0, rgbStringToColor(cColor_BLACK), rgbStringToColor(cColor_White))
EndFunction

Void Function ScreenSensitiveHelpVirtualCursor (int iWinType)
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
If (iWinType == WT_BUTTON) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp1_L, cmsgScreenSensitiveHelp1_S)
	Return
endIf
; for controls with state
If (iWinType == WT_CHECKBOX) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp2_L, cmsgScreenSensitiveHelp2_S)
	return
ElIf (iWinType == WT_RADIOBUTTON) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp3_L, cmsgScreenSensitiveHelp3_S)
	return
endIf
; for editable controls
If (iWinType == WT_EDIT) ||
(iWinType == WT_MULTILINE_EDIT) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp4_L, cmsgScreenSensitiveHelp4_S)
	return
ElIf (iWinType == WT_EDITCOMBO) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp5_L, cmsgScreenSensitiveHelp5_S)
	return
ElIf (iWinType == WT_COMBOBOX) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp6_L, cmsgScreenSensitiveHelp6_S)
	return
ElIf (iWinType == WT_SPINBOX) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp7_L, cmsgScreenSensitiveHelp7_S)
	return
ElIf (iWinType == WT_UPLOAD_EDIT) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp61_L, cmsgScreenSensitiveHelp61_S)
	return
endIf
; for link and graphic window types
If (iWinType == WT_MAILTO_LINK) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp8_L, cmsgScreenSensitiveHelp8_S)
	Return
ElIf (iWinType == wt_ImageMap_link) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp9_L, cmsgScreenSensitiveHelp9_S)
	return
ElIf (iWinType == 	WT_BITMAP) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp10_L, cmsgScreenSensitiveHelp10_S)
	return
ElIf (iWinType == WT_LINK) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp11_L, cmsgScreenSensitiveHelp11_S)
	return
ElIf (iWinType == WT_THISPAGE_LINK) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp12_L, cmsgScreenSensitiveHelp12_S)
	return
ElIf (iWinType == wt_ftp) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp13_L, cmsgScreenSensitiveHelp13_S)
	return
ElIf (iWinType >= WT_HTML_HEADING1) &&
(iWinType <= WT_HTML_HEADING6) then
	SayMessage (OT_USER_BUFFER, FormatString (cMsgHtmlHeading, IntToString (GetCurrentHeadingLevel ())))
	Return
endIf
;Unknown Type Code
SayNumOfPageElements ()
EndFunction

Void Function ScreenSensitiveHelpForKnownClasses (int nSubTypeCode)
var
	int TheTypeCode,
	string RealName,
	string sMessageLong,
	string sMessageShort,
	string sTreeLevel
let theTypeCode = nSubTypeCode
If (IsVirtualPCCursor ()) then
	If ( ! IsJavaWindow (GetCurrentWindow ())) then
		If (TheTypeCode > 0) then
			ScreenSensitiveHelpVirtualCursor (TheTypeCode)
			;As ScreenSensitiveHelpVirtualCursor has already deactivated the buffer
			AddHotKeyLinks ()
			Return
		endIf
	endIf
endIf
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
if (TheTypeCode == WT_BUTTON) then ;#1
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp14_L)
	AddHotKeyLinks ()
	Return
ElIf (TheTypeCode == WT_COMBOBOX) then ;#2
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp15_L)
	AddHotKeyLinks ()
	Return
Elif (TheTypeCode == WT_EDIT) ||;#3
TheTypeCode == WT_MULTILINE_EDIT then ; #66
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp16_L)
	AddHotKeyLinks ()
	Return
endIf
if (TheTypeCode == WT_LISTBOX) then ;#4
	if (IsSelectScriptDlg()) then
		SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp17_L)
	elif (IsSelectItemDlg()) then
		SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp18_L)
	else
		SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp19_L)
	endIf
	AddHotKeyLinks ()
	Return
endIf
if (TheTypeCode == WT_SCROLLBAR) || (TheTypeCode ==WT_LEFTRIGHTSCROLLBAR) then ;#5
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp20_L)
	AddHotKeyLinks ()
	Return
elif  (TheTypeCode ==WT_UPDOWNSCROLLBAR) Then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp21_L)
	AddHotKeyLinks ()
	return
endIf
if (TheTypeCode == WT_STATIC) then ;#6
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp22_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_TOOLBAR) then ;#7
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp23_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_STATUSBAR) then ;#8
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp24_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_HEADERBAR) then ;#9
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp25_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_SPINBOX) then ;#12
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp26_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_MENU) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp27_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_DESKTOP) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp28_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_ICONTITLE) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp29_L)
	AddHotKeyLinks ()
	return
elif (TheTypeCode == WT_MDICLIENT) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp30_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_DIALOG) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp31_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_RADIOBUTTON) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp32_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_CHECKBOX) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp33_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_GROUPBOX) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp34_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_SDM) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp35_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_GENERALPICTURE) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp36_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_HOTKEY) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp37_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_TABCONTROL) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp38_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_LISTVIEW) then
	let RealName = GetWindowName (GetRealWindow (GetCurrentWindow()))
;cwn4="Desktop"
	if RealName == cwn4 then
		SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp39_L)
		AddHotKeyLinks ()
		Return
	else
		SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp40_L)
		AddHotKeyLinks ()
		Return
	endIf
elif (TheTypeCode == WT_TREEVIEW) then
	let sTreeLevel = IntToString (GetTreeViewLevel ())
	let sMessageLong = FormatString (cmsgScreenSensitiveHelp41_L, sTreeLevel)
	let sMessageShort = FormatString (cmsgScreenSensitiveHelp41_S, sTreeLevel)
	SayFormattedMessage (OT_USER_BUFFER, sMessageLong)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_STARTBUTTON) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp42_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_STARTMENU) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp43_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_CONTEXTMENU) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp44_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_TASKBAR) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp45_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_MULTISELECT_LISTBOX) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp46_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_EXTENDEDSELECT_LISTBOX) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp47_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_LEFTRIGHTSLIDER) then ;#39
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp48_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_UPDOWNSLIDER) then ;#40
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp49_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_EDITCOMBO) then ;#41
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp50_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_PASSWORDEDIT) then ;#42
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp51_L)
	AddHotKeyLinks ()
	Return
elif (TheTypeCode == WT_READONLYEDIT) then ;#43
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp52_L)
	AddHotKeyLinks ()
	Return
elif (theTypeCode == WT_COMMANDBAR) then ;#44
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp53_L)
	AddHotKeyLinks ()
	return
elif TheTypeCode==WT_SYSTray then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp54_L)
	AddHotKeyLinks ()
	return
elif (GlobalMenuMode == MENUBAR_ACTIVE) then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp55_L)
	AddHotKeyLinks ()
	return
elIf (TheTypeCode == WT_EDIT_SPINBOX) then ; #62
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp56_L)
	AddHotKeyLinks ()
	Return
elIf (TheTypeCode == WT_UPLOAD_EDIT) then
	if (CaretVisible()) then
		SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp59_L)
	else
		SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp60_L)
	EndIf
	AddHotKeyLinks ()
	Return
ElIf TheTypeCode == WT_LINK then
	SayFormattedMessage (OT_USER_BUFFER, cMsgScreenSensitiveHelp63)
	AddHotKeyLinks ()
	Return
ElIf TheTypeCode == WT_OUTLINEBUTTON then
	SayFormattedMessage (OT_USER_BUFFER, cmsgScreenSensitiveHelp62);
	AddHotKeyLinks ();
	Return
endIf
;if it gets this far it did not recognize the type code.
let sMessageLong = FormatString (cmsgScreenSensitiveHelp57_L, IntToString (theTypeCode))
let sMessageShort = FormatString (cmsgScreenSensitiveHelp57_S, IntToString (theTypeCode))
SayFormattedMessage (OT_USER_BUFFER, sMessageLong)
ScreenSensitiveHelpForUnknownClasses (); catch everything not yet handled
EndFunction

Script ScreenSensitiveHelp ()
var
	handle WinHandle,
	int TheTypeCode,
	String TheClass
if (IsSameScript ()) then
	AppFileTopic(0) ; Don't display a topic
	return
endIf
If UserBufferIsActive () then
	UserBufferDeactivate ()
	SayFormattedMessage (OT_USER_BUFFER, cMsgScreenSensitiveHelpBuf)
	Return
EndIf
let WinHandle = GetCurrentWindow ()
let TheTypeCode = GetWindowSubTypeCode (WinHandle)
If ! TheTypeCode then
	If UserBufferIsActive () then
		If IsVirtualPcCursor () then
			SayMessage (OT_NO_DISABLE, cmsgVirtualViewer)
			Return
		EndIf
	ElIf IsVirtualPcCursor () then
		SayFormattedMessage (OT_USER_BUFFER, GetNumOfPageElements ())
		AddIENavigationKeystrokes()
		Return
	EndIf
EndIf
If (GlobalMenuMode == 1) then
	ScreenSensitiveHelpForKnownClasses (wt_MenuBar);
	return
endIf
if !ScreenSensitiveHelpForJawsDialogs() then
;for window list
If GetWindowName(GetRealWindow(WinHandle )) == cwn14 then
		ScreenSensitiveHelpWindowList()
		return 
EndIf
if (TheTypeCode < 1) then
	let TheClass = GetWindowClass (WinHandle)
	if (theClass == cwcTTY || theClass == cwcTTYGrab) then
		If UserBufferIsActive () then
			UserBufferDeactivate()
		EndIf
		SayFormattedMessage (OT_USER_BUFFER, cmsg175_L) ;"This is a DOS Window"
		return
	endIf
	ScreenSensitiveHelpForUnknownClasses()  ; handle unknown window types and classes
else
	ScreenSensitiveHelpForKnownClasses (theTypeCode); known types
endIf
EndIf
EndScript

int Function ScreenSensitiveHelpForJawsDialogs()
var
	handle hWnd,
	int id,
	int SubType,
	string sRealName
let hWnd = GetCurrentWindow()
let sRealName = GetWindowName(GetRealWindow(hWnd))
If InHjDialog () then 
	if sRealName == cwn11 then 
		ScreenSensitiveHelpForColorsDialog()
		return TRUE
	Elif sRealName == cwn12 then 
		ScreenSensitiveHelpForSysTray()
		return TRUE
	ElIf sRealName == cwn13  then
		ScreenSensitiveHelpForJawsManager()
		return TRUE
	ElIf sRealName == cwn15 then
		ScreenSensitiveHelpForFramesListDialog ()
		Return TRUE;
	ElIf sRealName == cWn16 then
		ScreenSensitiveHelpForHeadingListDialog ()
		Return TRUE;
	EndIf
Else
	return FALSE
EndIf
EndFunction

Void Function ScreenSensitiveHelpForUnknownClasses ()
var
	handle hwnd,
	string sMessage
let TimesPressedDefault = 0
let hwnd = GetCurrentWindow ()
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
If (hwnd) then ;window handle is not 0
	let sMessage = cmsg84_L
	SayFormattedMessage (OT_USER_BUFFER, sMessage) ;"This is a custom window type"
else ; handle = 0
	SayFormattedMessage (OT_USER_BUFFER, cmsg96) ;"there is currently no item with focus"
endIf
EndFunction

Script  ScreenSensitiveHelpTechnical()
var
	handle hwnd,
	String TheClass,
	string sControl,
	string sMessage
let hwnd = GetCurrentWindow ()
let TheClass = GetWindowClass (hwnd)
let sControl = IntToString (GetControlID (hwnd))
let sMessage = FormatString (cmsg85_L, sControl, theClass, IntToString (hwnd))
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
SayFormattedMessage (OT_USER_BUFFER, sMessage) ;"This is a custom window type"
EndScript

Void Function ScreenSensitiveHelpForColorsDialog()
var
	handle hWnd,
	int id,
	int SubType
let hWnd = GetCurrentWindow()
let SubType = GetWindowSubtypeCode (hWnd)
let id = GetControlId(hWnd)
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
if SubType == WT_LISTBOX  then
	if id == id_ListBox_colorDlg then
		SayFormattedMessage(OT_USER_BUFFER, cmsg367_L)
		return
	Else
		ScreenSensitiveHelpForKnownClasses(SubType) 
		return
	EndIf
ElIf SubType == WT_BUTTON then
	if id == id_OK then
		SayFormattedMessage(OT_USER_BUFFER, cmsg365_L)
		return
	ElIf id == id_CANCEL then
		SayFormattedMessage(OT_USER_BUFFER, cmsg366_L)
		return
	ELSE
		ScreenSensitiveHelpForKnownClasses(SubType) 
		return
	ENDIF
Else
		PerFormScript ScreenSensitiveHelp()
		return		
EndIf
EndFunction
void Function ScreenSensitiveHelpForSysTray()
var
	handle hWnd,
	int id,
	int SubType
let hWnd = GetCurrentWindow()
let SubType = GetWindowSubtypeCode (hWnd)
let id = GetControlId(hWnd)
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
if SubType == WT_LISTBOX 						 then
	if id == id_listBox_systemTray  then
		SayFormattedMessage(OT_USER_BUFFER, cmsg368_L)
		return
	Else
		ScreenSensitiveHelpForKnownClasses(SubType) 
		return
	EndIf
ElIf SubType == WT_BUTTON then
	if id == iD_RightSingleClick then
	SayFormattedMessage(OT_USER_BUFFER, cmsg369_L)
		return
   ElIf id == iD_LeftSingleClick then
		SayFormattedMessage(OT_USER_BUFFER,cmsg370_L)
		return
	ElIf id == iD_LeftDoubleClick then
		SayFormattedMessage(OT_USER_BUFFER, cmsg371_L)
		return
	ElIf id == id_CANCEL   then
		SayFormattedMessage(OT_USER_BUFFER, cmsg366_L)
		return
	Else
		ScreenSensitiveHelpForKnownClasses(SubType) 
		return
EndIf
Else
	PerformScript ScreenSensitiveHelp()
	return
EndIf
EndFunction

void Function ScreenSensitiveHelpForJawsManager()
var
	handle hWnd,
	int id,
	int SubType
let hWnd = GetCurrentWindow()
let SubType = GetWindowSubtypeCode (hWnd)
let id = GetControlId(hWnd)
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
	if SubType == WT_LISTBOX 						 then
		if id ==  id_lisbox_JawsManager  then
			SayFormattedMessage(OT_USER_BUFFER, cmsg372_L)
			return
		Else
			ScreenSensitiveHelpForKnownClasses(SubType) 
			return
		EndIf
	ElIf SubType == WT_BUTTON then
		if Id == id_ok then
			SayFormattedMessage(OT_USER_BUFFER, cmsg365_L)
			return
		ElIf id == id_cancel then
			SayFormattedMessage(OT_USER_BUFFER, cmsg366_L)
			return
		Else
			ScreenSensitiveHelpForKnownClasses(SubType)
			return
		EndIf
	Else
		PerformScript ScreenSensitiveHelp()
		return
	EndIf
EndFunction

Void Function ScreenSensitiveHelpWindowList()
var
	handle hWnd,
	int id,
	int SubType
let hWnd = GetCurrentWindow()
let SubType = GetWindowSubtypeCode (hWnd)
let id = GetControlId(hWnd)
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
If SubType == WT_LISTBOX then
	if id == id_ListBoxWindowList then
		SayFormattedMessage(OT_USER_BUFFER, cmsg373_L)
		return
	Else
		ScreenSensitiveHelpForKnownClasses(SubType) 
		return
	EndIf
ElIf SubType == WT_BUTTON then
	if id == id_SwitchTo_btn  then
		SayFormattedMessage(OT_USER_BUFFER, cmsg374_L)
		return
	ElIf id == id_About_btn  then
		SayFormattedMessage(OT_USER_BUFFER,cmsg375_L)
		return
	ElIf id == id_cancel then
			SayFormattedMessage(OT_USER_BUFFER, cmsg366_L)
			return
	Else
		ScreenSensitiveHelpForKnownClasses(SubType)
		return
	EndIf
Else
	PerformScript ScreenSensitiveHelp()
	return
EndIf
EndFunction

void Function ScreenSensitiveHelpForFramesListDialog ()
var
	handle hWnd,
	int id,
	int SubType
let hWnd = GetCurrentWindow()
let SubType = GetWindowSubtypeCode (hWnd)
let id = GetControlId(hWnd)
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
if SubType == WT_LISTBOX 						 then
	if id ==  id_lisbox_JawsManager  then
		SayFormattedMessage(OT_USER_BUFFER, cMsg377_L)
		return
	Else
		ScreenSensitiveHelpForKnownClasses(SubType) 
		return
	EndIf
ElIf SubType == WT_BUTTON then
	if Id == id_ok then
		SayFormattedMessage(OT_USER_BUFFER, cmsg378_L)
		return
	ElIf id == id_cancel then
		SayFormattedMessage(OT_USER_BUFFER, cmsg379_L)
		return
	Else
		ScreenSensitiveHelpForKnownClasses(SubType)
		return
	EndIf
Else
	PerformScript ScreenSensitiveHelp()
	return
EndIf
EndFunction

void function ScreenSensitiveHelpForHeadingListDialog ()
var
	handle hWnd,
	int iControl,
	int iTypeCode,
	string strGroupName;Handle radio button groups, especially for the display of headings 1 through 6
Let hWnd = GetCurrentWindow ()
Let iTypeCode = GetWindowSubTypeCode (hWnd)
If iTypeCode == WT_LISTVIEW then
	SayFormattedMessage (OT_USER_BUFFER, cmsgHtmlHeadingsList)
	Return
EndIf
If iTypeCode == WT_RADIOBUTTON then
	Let strGroupName = GetGroupBoxName ()
	If strGroupName == cWnGroup1 then
		SayFormattedMessage (OT_USER_BUFFER, cmsgHtmlHeadingOrder)
		Return
	ElIf strGroupName == cWnGroup2 then
		SayFormattedMessage (OT_USER_BUFFER, cmsgHtmlHeadingLevels)
		Return
	EndIf
	Return
ElIf iTypeCode == WT_BUTTON then
	Let iControl = GetControlID (hWnd)
	If (iControl == ID_HEADING_MOVE_TO) then
		SayFormattedMessage (OT_USER_BUFFER, cmsgHtmlHeadingMoveToButton)
		Return
	ElIf iControl ==ID_CANCEL then
		SayFormattedMessage (OT_USER_BUFFER, cmsgHtmlHeadingCancelButton)
		Return
	EndIf
Else
	PerformScript ScreenSensitiveHelp ()
EndIf
EndFunction

int Function IsWinKeyHelp ()
var
	int iShouldHelp,
	int iTypeCode,
	handle hWnd,
	string sClass
Let hWnd = GetCurrentWindow ()
Let iTypeCode = GetWindowSubTypeCode (hWnd)
If iTypeCode == WT_TASKBAR ||
iTypeCode == WT_DESKTOP ||
GetWindowName (GetRealWindow (hWnd)) == cwn4 || ; Desktop RealName
iTypeCode == WT_STARTBUTTON ||
iTypeCode == WT_STARTMENU ||
iTypeCode == WT_SYSTRAY then
	Let iShouldHelp = TRUE
Else
	Let iShouldHelp = FALSE
EndIf
Return iShouldHelp
EndFunction

Script WindowKeysHelp ()
WindowKeysHelpDefault ()
EndScript

; List of some basic Windows keyboard commands
Void Function WindowKeysHelpDefault ()
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
SayFormattedMessage (OT_USER_BUFFER, cmsgWindowKeysHelp1_L)
EndFunction

Void Function CursorShapeChangedEvent (string CursorType)
let GlobalCursorType = CursorType
PerformScript SayCursorType ()
EndFunction

String Function ConvertCursorShape (string CursorType)
let GlobalCursorType = CursorType
If (GlobalCursorType == cscNormal) then
	SayUsingVoice (VCTX_MESSAGE, cmsg97_L, ot_no_disable) ;"Arrow Cursor"
	Return
endIf
If (GlobalCursorType == cscEditCursor) then
	SayUsingVoice (VCTX_MESSAGE, cmsg98_L, ot_no_disable) ;"I beam cursor"
	Return
endIf
If (GlobalCursorType ==cscWAIT) then
	SayUsingVoice (VCTX_MESSAGE, cmsg99_L, ot_no_disable)
	Return
endIf
If (GlobalCursorType ==cscCROSS) then
	SayUsingVoice (VCTX_MESSAGE, cmsg100_L, ot_no_disable) ;"cross hair cursor"
	Return
endIf
SayUsingVoice (VCTX_MESSAGE, GlobalCursorType, ot_no_disable) ;"Cursor Changed"
EndFunction

Script SayCursorType()
convertCursorShape(getCursorShape())
EndScript

String function HotKeyHelpDefaultLoopHelper (handle hwnd, int iBool)
var
	handle hNull,
	int WinTypeCode,
	string sPrompt,
	string sHotKey,
	string sMessageLong,
	string sMessageShort,
	string strText,
	int FoundHotKey
While (hwnd != hNull)
	If (IsWindowVisible (hwnd)) then
	let WinTypeCode = GetWindowSubTypeCode (hwnd)
		If ((WinTypeCode == WT_BUTTON) ||
			(WinTypeCode == WT_STATIC) ||
			(WinTypeCode == WT_RADIOBUTTON) ||
			(WinTypeCode == WT_CHECKBOX) ||
			(WinTypeCode == WT_GROUPBOX) ||
			(WinTypeCode == WT_3STATE) ||
			(WinTypeCode == WT_TABCONTROL)) then
			let sHotKey = GetHotKey (hwnd)
			;cscNull =""
			if (sHotKey != cscNull) then
				if (FoundHotKey == 0) then
					if (iBool == true) then
						;SayFormattedMessage (OT_USER_BUFFER, cmsg101_L) ;"Hot keys are as follows"
						Let strText = FormatString (cmsg101_L, GetWindowName (GetRealWindow (GetFocus ())))+cScBufferNewLine
					endIf
					let FoundHotKey = 1
				endIf
				let sPrompt = GetWindowTextEx (hwnd, false, false)
				let strText = strText + FormatString (cmsgHotKeyDefaultHelpLoopPrompt1_L, sPrompt, sHotKey)+cScBufferNewLine
				let sMessageShort = FormatString (cmsgHotKeyDefaultHelpLoopPrompt1_S, sPrompt, sHotKey)
				;SayFormattedMessage (OT_USER_BUFFER, sMessageLong)
			endIf
		endIf ; condition for static text or button
	endIf ; Window visible
	let hwnd = GetNextWindow (hwnd)
EndWhile
If (FoundHotKey == 0) then
	;SayFormattedMessage (OT_USER_BUFFER, cmsg198_L);"unable to determine hot keys in this dialog"
	Let strText = strText + cmsg198_L
endIf
Return strText
EndFunction

Void Function HotKeyHelpDefaultLoop ()
var
	handle hwnd,
	handle hTemp,
	int iSpeakIntro,
	string strHotKeys
let hwnd = GetRealWindow (GetFocus ())
let hwnd = GetFirstChild (hwnd)
let iSpeakIntro = true
Let strHotKeys = cScNull;
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
If (IsMultiPageDialog ()) then
	let hTemp = GetFirstChild (hwnd)
	Let strHotKeys = strHotKeys+ HotKeyHelpDefaultLoopHelper (hTemp, iSpeakIntro)
	let iSpeakIntro = false
endIf
Let strHotKeys = strHotKeys + HotKeyHelpDefaultLoopHelper (hwnd, iSpeakIntro)
SayFormattedMessage (OT_USER_BUFFER, strHotKeys)
EndFunction

Void Function GeneralJAWSHotKeys ()
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
SayFormattedMessage (OT_USER_BUFFER, cmsgHotKeyHelp1_L, cmsgHotKeyHelp1_S)
EndFunction

int Function JAWSHotKeys ()
if (IsSelectScriptDlg ()) then
	If UserBufferIsActive () then
		UserBufferDeactivate ()
	EndIf
	SayFormattedMessage (OT_USER_BUFFER, cMsg207)
	return TRUE
elif (IsSelectItemDlg ()) then
	If UserBufferIsActive () then
		UserBufferDeactivate ()
	EndIf
	SayFormattedMessage (OT_USER_BUFFER, cmsg212)
	return TRUE
endIf
return FALSE
EndFunction

; Insert H help messages
Script HotKeyHelp()
if (! JAWSHotKeys()) then
	GeneralJawsHotKeys ()
endIf
EndScript

Script SayCurrentHotKey()
var
	handle hwnd,
	int iWinType,
	string sHotKey,
	string sPrompt,
	string sMessageLong,
	string sMessageShort
If (GlobalMenuMode > 0) then
	SayCharacter ()
	Return
endIf
let hwnd = GetCurrentWindow ()
let iWinType = GetWindowSubTypeCode (hwnd)
If iWinType == WT_EDITCOMBO then
	let sHotKey = GetHotKey (hwnd)
	;cscNull =""
	If (sHotKey != cscNull) then
		let sPrompt = GetWindowName (hwnd)
			let sMessageLong = FormatString (cmsgHotKeyDefaultHelpLoopPrompt1_L, sPrompt, sHotKey)
			let sMessageShort = FormatString (cmsgHotKeyDefaultHelpLoopPrompt1_S, sPrompt, sHotKey)
			SayFormattedMessage (ot_help, sMessageLong, sMessageShort)
			return
		else
			SayFormattedMessage (ot_error, cmsg124_L) ;"no hot key"
			return
	EndIf
EndIf
If (iWinType == wt_combobox ||
iWinType == wt_spinbox ||
iWinType == wt_edit ||
iWinType == wt_listbox ||
iWinType == wt_scrollbar ||
iWinType == wt_slider ||
iWinType == wt_listview ||
iWinType == wt_treeview ||
iWinType == wt_multiselect_listbox ||
iWinType == wt_extendedselect_listbox ||
iWinType == wt_leftrightslider ||
iWinType == wt_updownslider ||
iWinType == wt_editcombo ||
iWinType == wt_passwordedit ||
iWinType == wt_readonlyedit ||
iWinType == wt_edit_spinbox) then
	let hwnd = GetPriorWindow (hwnd)
	let iWinType = GetWindowSubTypeCode (hwnd)
	if (iWinType == wt_static) then
		let sHotKey = GetHotKey (hwnd)
;cscNull =""
		If (sHotKey != cscNull) then
				let sPrompt = GetWindowTextEx (hwnd, false, false)
				let sMessageLong = FormatString (cmsgHotKeyDefaultHelpLoopPrompt1_L, sPrompt, sHotKey)
				let sMessageShort = FormatString (cmsgHotKeyDefaultHelpLoopPrompt1_S, sPrompt, sHotKey)
				SayFormattedMessage (ot_help, sMessageLong, sMessageShort)
				return
			else
				SayFormattedMessage (ot_error, cmsg124_L) ;"no hot key"
				return
		endIf
		else
			SayFormattedMessage (ot_error, cmsg124_L) ;"no hot key"
			return
	endIf
ElIf (iWinType == WT_BUTTON ||
			iWinType == WT_RADIOBUTTON ||
			iWinType == WT_CHECKBOX ||
			iWinType == WT_GROUPBOX ||
			iWinType == WT_3STATE ||
			iWinType == WT_MENUBAR ||
			iWinType == WT_MENU ||
			iWinType == WT_TABCONTROL) then
	let sHotKey = GetHotKey (hwnd)
;cscNull =""
	If (sHotKey != cscNull) then
		let sPrompt = GetWindowTextEx (hwnd, false, false)
		let sMessageLong = FormatString (cmsgHotKeyDefaultHelpLoopPrompt1_L, sPrompt, sHotKey)
		let sMessageShort = FormatString (cmsgHotKeyDefaultHelpLoopPrompt1_S, sPrompt, sHotKey)
		SayFormattedMessage (ot_help, sMessageLong, sMessageShort)
		return
	else
		SayFormattedMessage (ot_error, cmsg124_L) ;"no hot key"
		return
	endIf
else
	SayFormattedMessage (ot_error, cmsg124_L) ;"no hot key"	
endIf
EndScript

Void Function MoveToFirstSdmControl ()
var
	int SDMControl,
	handle winhandle
let winhandle = GetRealWindow (GetFocus())
let SDMControl = SDMGetFirstControl (winhandle)
MoveToControl (winhandle, SDMControl)
let GlobalSDMControl = SDMControl
EndFunction

Void Function MoveToNextSdmControl ()
var
	int SDMControl,
	handle winhandle
let winhandle = GetRealWindow (GetFocus())
let SDMControl = SDMGetNextControl (GetCurrentWindow(), GlobalSDMControl)
MoveToControl (GetCurrentWindow(), SDMControl)
let GlobalSDMControl = SDMControl
EndFunction

;Copyright 1996 by Freedom Scientific BLV Group, LLC

;default Script file for desk tops
; 2/12/95, added SDM windows, focus change & insert+f1 Scripts.
; 4/27, added PassKeyThrough
; & separated to use include file.
; added hjglobal.jmh header file
;and new Focus Change,8/8/95, th.

Script ScriptFileName()
ScriptAndAppNames(cmsg238_L) ;"default"
EndScript

Script SayLine()
var
	int TheTypeCode,
	string strVal
;If not PCCursor, let internal processing speak.
If IsSameScript () then
	SpellLine ()
	Return;
EndIf
If ((! IsPcCursor ()) ||
(IsVirtualPcCursor ())) then
	SayLine ()
	Return;
EndIf
If GlobalMenuMode then
	SayLine ()
	Return
EndIf
Let TheTypeCode = GetWindowSubTypeCode (GetFocus ())
;If ! IsVirtualPcCursor () &&
If ! TheTypeCode then
	Let TheTypeCode = GetObjectSubTypeCode ()
EndIf
If ((TheTypeCode == WT_MULTISELECT_LISTBOX) || 
(TheTypeCode == WT_EXTENDEDSELECT_LISTBOX) ||
(TheTypeCode == WT_LISTVIEW	) ||
(TheTypeCode == WT_LISTBOX)) then
	Let strVal = GetObjectValue ()
	If ! strVal then
		Let strVal = GetObjectName ()
	EndIf
SayMessage (OT_LINE, strVal)
	SayMessage (OT_POSITION, PositionInGroup ())
	Return
EndIf
If CaretVisible () then
	If TheTypeCode != WT_EDITCOMBO then;Edit combos should not speak FormatAndText info.
		let globalSayingCurrentItem = 1
	EndIf
EndIf
SayLine ()
let globalSayingCurrentItem = 0
EndScript

Script  SayCharacter()
if IsPCCursor() then
	if (GetObjectTypeCode() == WT_SLIDER) then
		SayWord() ; says the current setting
		return
	endIf
endIf
if (IsSameScript ()) then
	SayCharacterPhonetic ()
	AddHook (HK_SCRIPT, "PhoneticSpellHook")
else
	let globalSayingCurrentItem = 1
	SayCharacter()
	let globalSayingCurrentItem = 0
endIf
EndScript

Void Function PhoneticSpellHook (string ScriptName)
if (ScriptName == "SayNextCharacter") then
	NextCharacter ()
	SayCharacterPhonetic ()
	return False
endIf
if (ScriptName == "SayPriorCharacter") then
	PriorCharacter ()
	SayCharacterPhonetic ()
	return False
endIf
RemoveHook (HK_SCRIPT, "PhoneticSpellHook")
return True
EndFunction

Script SayWord()
If (IsSameScript ()) Then
	SpellWord()
	AddHook (HK_SCRIPT, "SpellWordHook")
Else
	let globalSayingCurrentItem = 1
	SayWord()
	let globalSayingCurrentItem = 0
endIf
EndScript

Void Function SpellWordHook (string ScriptName)
if (ScriptName == "SayNextWord") then
	NextWord ()
	SpellWord ()
	return false
endIf
if (ScriptName == "SayPriorWord") then
	PriorWord ()
	SpellWord ()
	return false
endIf
RemoveHook (HK_SCRIPT, "SpellWordHook")
return true
EndFunction

string function GetRestrictionName(int nRestriction)
var
	string strName
if (nRestriction == RestrictAppWindow) then
	SayFormattedMessage (OT_status, cmsg315_L, cmsg315_S) ;Application window restriction
elif (nRestriction == RestrictRealWindow) then
	SayFormattedMessage (OT_status, cMSG316_L, cMSG316_S) ;"Real window restriction" 
elif (nRestriction == RestrictWindow) then
	SayFormattedMessage (OT_status, cmsg317_L, cmsg317_S) ;"Current window restriction" 
elif (nRestriction == RestrictNone)  then
	SayFormattedMessage (OT_status, cmsg318_L) ;"unrestricted"
elif (nRestriction == RestrictRect)  then
	SayFormattedMessage (OT_status, cmsg319_L, cmsg319_S) ;"Frame restriction"
endIf
EndFunction

Script SayNextWord()
NextWord()
if ((IsLeftButtonDown()) || (IsRightButtonDown())) then
	SelectingText(TRUE)
	pause ()
	SelectingText(false)
	return
endIf
SayWord()
EndScript

Script SayPriorWord()
PriorWord()
if ((IsLeftButtonDown()) || (IsRightButtonDown())) then
	SelectingText(TRUE)
	pause ()
	SelectingText(false)
	return
endIf
SayWord()
EndScript

Script  SayActiveCursor()
if (IsLeftButtonDown ()) then
	SayFormattedMessage (ot_no_disable, cmsg178_L, cmsg178_S) ; "the left mouse button is locked"
endIf
If (IsRightButtonDown ()) then
	SayFormattedMessage (ot_no_disable, cmsg179_L, cmsg179_S) ; "the right mouse button  is locked"
endIf
SayActiveCursor()
SayCursorPos(GetActiveCursor())
if (GetRestriction() != RestrictAppWindow) then
	Say(GetRestrictionName(getRestriction()),ot_no_disable)
endIf
EndScript

Script TetherJawsToPC ()
var
	int iTetherOption,
	int iNewChoice
let iTetherOption = GetDefaultJCFOption (OPT_TETHER_JAWS_TO_PC)
If iTetherOption == 0 then
	let iNewChoice = (iTetherOption + 1)
Else
	let iNewChoice = 0
endIf
SetDefaultJCFOption (	OPT_TETHER_JAWS_TO_PC, iNewChoice)
If (iNewChoice == 0) then
	SayFormattedMessage (OT_STATUS, cmsgNoFollowPC1_L, cmsgNoFollowPC1_S); "The Jaws cursor will not follow the PC Cursor"
Else
	SayFormattedMessage (OT_STATUS, cmsgFollowPC1_L, cmsgFollowPC1_S); "The Jaws cursor will follow the PC Cursor"
endIf
If (IsSameScript ()) then
	; Make sure the setting the user last heard got saved
	; Thus letting the reset logic process first
	If (! IniWriteInteger (SECTION_OPTIONS, hKEY_TETHER, iNewChoice, DefaultJCFFile)) then
		SayFormattedMessage (OT_ERROR, cmsgSettingError1_L, cmsgSettingError1_S); "Error saving setting\bJaws will not remember this setting next time you restart"
		Return
	endIf
	SayFormattedMessage (OT_JAWS_MESSAGE, cmsgSettingSaved1_L, cmsgSettingSaved1_S); "Jaws will remember this setting until you decide to re save it"
	Return
endIf
EndScript

Script RouteJawsCursorToPc()
if  IsVirtualPCCursor () then
	If UserBufferIsActive () then
		SayFormattedMessage (OT_NO_DISABLE, cmsgVirtualViewer)
		Return
	EndIf
	Refresh ()  
	RouteJAWSToPc ()
	JAWSCursor ()
	BrailleRefresh ()
	SayFormattedMessage (OT_STATUS, cMSG289_L, cMSG289_S)
	return
elif (IsInvisibleCursor ()) then
	RouteInvisibleToPc ()
	BrailleRefresh ()
	SayFormattedMessage (OT_STATUS, cmsg146_L, cmsg146_S) ;"Route invisible to p c"
else
	RouteJawsToPc()
	JAWSCursor()
	BrailleRefresh ()
	SayFormattedMessage (OT_STATUS, cmsg147_L, cmsg147_S) ;"Route jaws to p c"
endIf
EndScript

Script  RoutePCCursorToJaws()
if  IsVirtualPCCursor () then 
	If UserBufferIsActive () then
		SayFormattedMessage (OT_NO_DISABLE, cmsgVirtualViewer)
		Return
	EndIf
	SayFormattedMessage (ot_status, cMSG288_L, cMSG288_S) ; "Virtual PC Cursor"
	return
endIf
if (IsInvisibleCursor ()) then
	RoutePCToInvisible ()
	BrailleRefresh ()
	SayFormattedMessage (ot_status, cmsg149_L, cmsg149_S) ;"Route p c to invisible"
else
	RoutePcToJaws()
	BrailleRefresh ()
	SayFormattedMessage (ot_status, cmsg148_L, cmsg148_S) ;"Route p c to jaws"
endIf
PCCursor()
EndScript

Script  LeftMouseButton()
SayFormattedMessage (ot_status, cmsg150_L, cmsg150_S) ;"left mouse button"
LeftMouseButton()
EndScript

Script  RightMouseButton()
SayFormattedMessage (ot_status, cmsg151_L, cmsg151_S) ;"right mouse button"
RightMouseButton()
EndScript

; toggle the pressed/released state of the left mouse button
Script  LeftMouseButtonLock()
if LeftMouseButtonLock () then
	SayFormattedMessage (ot_status, cmsg152_L, cmsg152_S) ;"left button locked"
else
	SayFormattedMessage (ot_status, cmsg153_L, cmsg153_S) ;"Left button unlocked"
endIf
EndScript

Globals
	int DragAndDropSet,
	int DragFromX,
	int DragFromY,
	string DragObject

Script DragAndDrop ()
var
	int x,
	int y,
	String strObject,
	string sMessage
if (DragAndDropSet == false) then
	let DragFromX = getCursorCol ()
	let DragFromY = getCursorRow ()
	let DragObject = GetWord ()
	let DragAndDropSet = true
	; cmsg170_L = "place the JAWS or PC cursor in the drop location and press "
	let sMessage = FormatString (cmsg170_L, GetCurrentScriptKeyName ())
	SayFormattedMessage (ot_jaws_message, sMessage, cmsg170_S)
	return
endIf
SaveCursor ()
let x = getCursorCol ()
let y = getCursorRow ()
JawsCursor ()
; make sure that the left mouse button is unlocked
If IsLeftButtonDown () then
	LeftMouseButtonLock ()
	pause ()
endIf
MoveTo (DragFromX, DragFromY)
Pause ()
let strObject = GetWord()
if strObject != DragObject then
	let DragAndDropSet = false
	SayFormattedMessage (ot_error, cmsg171_L, cmsg171_S) ; "Object to be dragged not found"
	return
endIf
LeftMouseButtonLock () ; lock it down
pause ()
MoveTo (x,y)
Pause ()
;cmsg172_L = "dragging "
let sMessage = FormatString (cmsg172_L, strObject, GetWord ())
SayFormattedMessage (ot_jaws_message, sMessage); dragging x to y
LeftMouseButtonLock ()
RestoreCursor ()
let DragAndDropSet = false
EndScript

Function DragAndDropClearValues ()
let DragAndDropSet = false
EndFunction

; toggle the pressed/released state of the right mouse button
Script RightMouseButtonLock ()
if RightMouseButtonLock () then
	SayFormattedMessage (ot_status, cmsg154_L, cmsg154_S) ;"right button locked"
else
	SayFormattedMessage (ot_status, cmsg155_L, cmsg155_S) ;"right button unlocked"
endIf
EndScript

Script SayTopLineOfWindow()
var
	int iVPC
Let iVPC = GetJcfOption (OPT_VIRTUAL_PC_CURSOR)
If IsVirtualPcCursor () then
	If UserBufferIsActive () then
		SayFormattedMessage (OT_NO_DISABLE, cmsgVirtualViewer)
		Return
	EndIf
EndIf
SaveCursor()
InvisibleCursor()
MoveToWindow (GetFocus ())
JawsPageUp()
SayLine()
RestoreCursor()
EndScript

Script SayBottomLineOfWindow()
var
	int iRestriction,
	int iVPC
Let iVPC = GetJcfOption (OPT_VIRTUAL_PC_CURSOR)
If IsVirtualPcCursor () then
	If UserBufferIsActive () then
		SayFormattedMessage (OT_NO_DISABLE, cmsgVirtualViewer)
		Return
	EndIf
EndIf
let iRestriction = GetRestriction ()
SaveCursor()
InvisibleCursor()
let iRestriction = GetRestriction ()
MoveToWindow (GetFocus ())
If GlobalMenuMode == 2 then
	If GetObjectSubTypeCode () == WT_MENU then
		SetRestriction (RestrictNone)
		JawsPageDown ()
		PriorLine ()
		SayLine ()
		SetRestriction (iRestriction)
		Return
	EndIf
EndIf
SetRestriction (RestrictAppWindow)
JawsPageDown()
SayLine()
RestoreCursor()
SetJcfOption (OPT_VIRTUAL_PC_CURSOR, iVPC)
EndScript

Script SayToCursor()
If IsSameScript () then
	SpellToCursor ()
	Return
EndIf
SayToCursor()
EndScript

Script  SayFromCursor()
If IsSameScript () then
	SpellFromCursor ()
	Return
EndIf
SayFromCursor()
EndScript

Script SayWindowPromptAndText()
var
	handle hWnd,
	int iSubType
Let hWnd = GetCurrentWindow ()
Let iSubType = GetWindowSubTypeCode (hWnd)
If ! iSubType then
	Let iSubType = GetObjectSubTypeCode ()
EndIf
If UserBufferIsActive () then
	If ! iSubType then
		SayFormattedMessage (OT_NO_DISABLE, cmsgVirtualViewer)
		Return
	EndIf
EndIf
;SayWindowTypeAndText(hWnd) Is now legacy
; As the SayObjectTypeAndText function will fall back on 
; SayWindowTypeAndText whenever possible
SayObjectTypeAndText ()
SayTutorialHelp (iSubType, TRUE)
SayTutorialHelpHotKey (hWnd, TRUE)
EndScript

Function Unknown (string TheName, int IsScript)
If (StringContains (TheName, "magsetfocus") != 0) then
	Return
endIf
If (StringContains (TheName, "getlinerect") != 0) then
	Return
endIf
if IsScript &&
GetAppFileName ()=="JFW.exe" then
	 SayFormattedMessage (OT_error, cMSG285_L)
ElIf (IsScript) then
	SayFormattedMessage (ot_error, cmsg180_L + TheName) ; "unknown script call to "
else
	If TheName > cScNull then
		SayFormattedMessage (ot_error, cmsg181_L + TheName) ; "unknown function call to "
	EndIf
endIf
EndFunction

;*************************
;     Utility Scripts         *
;*************************
Script  UtilityHelp()
;{homerow + insert+ h}
	SayFormattedMessage (ot_help, cmsgUtilityHotKeys1_L, cmsgUtilityHotKeys1_S)
EndScript

; Find the next requested attribute after the caret
Script UtilityInitializeHomeRowPosition ()
;HomeRow+F5
let hHomeRowPos = GetCurrentWindow ()
let iHomeRowAppMainWindowAlert = 0
SayFormattedMessage (ot_status, cmsg340_L, cmsg340_S) ; "Route HomeRow to current window"
EndScript

Script UtilityToggleSpeakWindowVisibility ()
If (iHomeRowSpeakWindowVisibility == off) then
	SayFormattedMessage (ot_status, cmsg341_L) ; "SpeakWindowVisibility on"
	let iHomeRowSpeakWindowVisibility = on
else
	SayFormattedMessage (ot_status, cmsg342_L) ; "SpeakWindowVisibility off"
	let iHomeRowSpeakWindowVisibility = off
endIf
EndScript

Script UtilitySpeakWindowVisibility ()
If (IsWindowVisible (hHomeRowPos) || !IsWindowObscured (hHomeRowPos)) then
	SayFormattedMessage (ot_help, cmsg343_L) ; "Visible"
else
	SayFormattedMessage (ot_help, cmsg344_L) ; "not visible"
endIf
EndScript

Script  UtilityNextAttribute()
;{homerow+grave accent}
If (UT_FontMode == 0) then
	let UT_FontMode = ATTRIB_BOLD
endIf
If (FindNextAttribute (UT_FontMode)) then
	SayField ()
	return
endIf
if (FindFirstAttribute (UT_FontMode)) then
	beep()
	SayField ()
	return
endIf
SayFormattedMessage (ot_jaws_message, cmsg125_L) ;"next attribute not found"
EndScript

; Find the prior requested attribute before the caret
Script  UtilityPriorAttribute()
;{homerow+shift+grave accent}
If (UT_FontMode == 0) then
	let UT_FontMode = ATTRIB_BOLD
endIf
If (FindPriorAttribute (UT_FontMode)) then
	SayField ()
	return
endIf
If (FindLastAttribute (UT_FontMode)) then
	beep()
	SayField()
	return
endIf
SayFormattedMessage (ot_jaws_message, cmsg126_L) ;"prior attribute not found"
EndScript

; Find the first requested attribute
Script  UtilityFindFirstAttribute()
;{homerow + control + grave accent}
If (UT_FontMode == 0) then
	let UT_FontMode = ATTRIB_BOLD
endIf
If (FindFirstAttribute (UT_FontMode)) then
	SayWord ()
Else
	SayFormattedMessage (ot_jaws_message, cmsg127_L) ;"First Attribute not found"
endIf
EndScript

; Find the last requested attribute
Script  UtilityFindLastAttribute()
;{homerow + shift+control + grave accent}
If (UT_FontMode == 0) then
	let UT_FontMode = ATTRIB_BOLD
endIf
If (FindLastAttribute (UT_FontMode)) then
	SayWord ()
Else
	SayFormattedMessage (ot_error, cmsg128_L, cmsg128_S) ;"Last Attribute not found"
endIf
EndScript

; produces the requested ouput on the current window
Script  UtilitySayInfoAccess()
;{homerow+f1}
var
	Int bSpellMode
If (IsSameScript ()) then
	let bSpellMode = ON
Else
	let bSpellMode = OFF
endIf
UtilitySayInfo(bSpellMode)
EndScript

Script UtilitySayMSAAObjectInfoAccess ()
;{homerow+f9}
var
	Int bSpellMode
If (IsSameScript ()) then
	let bSpellMode = ON
Else
	let bSpellMode = OFF
endIf
UtilitySayMSAAObjectInfo(bSpellMode)
EndScript

Script  UtilityPutInfoInBox()
;{homerow + Insert + f1}
var
	string sTemp
If (UT_OutputMode == UT_FOCUS ||
   UT_OutputMode == UT_CONTROLID ||
   UT_OutputMode == UT_SUBTYPE	) then
	SayFormattedMessage (ot_error, cmsg129_L, cmsg129_S) ;"Message box not available for Focus or ControlID"
	return
endIf
If UT_OutputMode == UT_CLASS then
	let sTemp = GetWindowClass (hHomeRowPos)
	Say (sTemp, ot_help)
	MessageBox (sTemp)
endIf
If UT_OutputMode == UT_TYPE then
	let sTemp = GetWindowType (hHomeRowPos)
	Say (sTemp, ot_help)
	MessageBox (sTemp)
endIf
If UT_OutputMode == UT_REALNAME then
	let sTemp = GetWindowName (GetRealWindow (hHomeRowPos))
	Say (sTemp, ot_help)
	MessageBox (sTemp)
endIf
EndScript

Script UtilityPutMSAAObjectInfoInBox ()
;{homerow + Insert + f9}
var
	string sTemp,
	int iMSAA_JCFOpt
If (ut_MSAAObjectOutputMode == ut_ObjectSubType) then
	SayFormattedMessage (ot_error, cmsg350_L, cmsg350_S) ;"Message box not available for object sub type codes"
	return
endIf
let iMSAA_JCFOpt = GetJCFOption (opt_MSAA_mode)
SetJCFOption (opt_MSAA_mode, 2)
If (ut_MSAAObjectOutputMode == ut_ObjectName) then
	let sTemp = GetObjectName ()
	Say (sTemp, ot_help)
	MessageBox (sTemp)
endIf
If (ut_MSAAObjectOutputMode == ut_ObjectType) then
	let sTemp = GetObjectType ()
	Say (sTemp, ot_help)
	MessageBox (sTemp)
endIf
SetJCFOption (opt_MSAA_mode, iMSAA_JCFOpt)
EndScript

Script  UtilityMoveToNextWindow()
;{homerow+tab}
var
	handle hTemp
let hTemp = hHomeRowPos
let hHomeRowPos = GetNextWindow (hHomeRowPos)
if  (hHomeRowPos) then
	UtilitySayInfo(FALSE) ;produces the requested output
	If (iHomeRowSpeakWindowVisibility == on) then
		If (IsWindowVisible (hHomeRowPos) ||
			!IsWindowObscured (hHomeRowPos)) then
			SayFormattedMessage (ot_help, cmsg343_L) ; "Visible"
		else
			SayFormattedMessage (ot_help, cmsg344_L) ; "not visible"
		endIf
	endIf
	If (GetAppMainWindow (hHomeRowPos) != GetAppMainWindow (GlobalFocusWindow)) then
		If (iHomeRowAppMainWindowAlert == 0) Then
			let iHomeRowAppMainWindowAlert = 1
			SayFormattedMessage (ot_jaws_message, cmsg345_L, cmsg345_S) ; "Exiting the window tree for the currently active application"
		endIf	
	else
		If (iHomeRowAppMainWindowAlert == 1) Then
			let iHomeRowAppMainWindowAlert = 0
			SayFormattedMessage (ot_jaws_message, cmsg346_L, cmsg346_S) ; "Entering the window tree for the currently active application"
		endIf	
	endIf
else
	let hHomeRowPos = hTemp
	SayFormattedMessage (ot_jaws_message, cmsg217_L) ; "no next window"
endIf
EndScript

;Cycle backword through windows at the same level
Script  UtilityMoveToPriorWindow()
;{homerow+shift+tab}
var
	handle hTemp
let hTemp = hHomeRowPos
let hHomeRowPos = GetPriorWindow (hHomeRowPos)
if  (hHomeRowPos) then
	UtilitySayInfo(FALSE) ;produces the requested output
	If (iHomeRowSpeakWindowVisibility == on) then
		If (IsWindowVisible (hHomeRowPos) ||
			!IsWindowObscured (hHomeRowPos)) then
			SayFormattedMessage (ot_help, cmsg343_L) ; "Visible"
		else
			SayFormattedMessage (ot_help, cmsg344_L) ; "not visible"
		endIf
	endIf
	If (GetAppMainWindow (hHomeRowPos) != GetAppMainWindow (GlobalFocusWindow)) then
		If (iHomeRowAppMainWindowAlert == 0) Then
			let iHomeRowAppMainWindowAlert = 1
			SayFormattedMessage (ot_jaws_message, cmsg345_L, cmsg345_S) ; "Exiting the window tree for the currently active application"
		endIf	
	else
		If (iHomeRowAppMainWindowAlert == 1) Then
			let iHomeRowAppMainWindowAlert = 0
			SayFormattedMessage (ot_jaws_message, cmsg346_L, cmsg346_S) ; "Entering the window tree for the currently active application"
		endIf	
	endIf
else
	let hHomeRowPos = hTemp
	SayFormattedMessage (ot_jaws_message, cmsg218_L) ; "no prior window"
endIf
EndScript

;Move down one level
Script  UtilityMoveToChild()
;{homerow+f2}
var
	handle hTemp
let hTemp = hHomeRowPos
let hHomeRowPos = GetFirstChild (hHomeRowPos)
if  (hHomeRowPos) then
	UtilitySayInfo(FALSE) ;produces the requested output
	If (iHomeRowSpeakWindowVisibility == on) then
		If (IsWindowVisible (hHomeRowPos) ||
			!IsWindowObscured (hHomeRowPos)) then
			SayFormattedMessage (ot_help, cmsg343_L) ; "Visible"
		else
			SayFormattedMessage (ot_help, cmsg344_L) ; "not visible"
		endIf
	endIf
	If (GetAppMainWindow (hHomeRowPos) != GetAppMainWindow (GlobalFocusWindow)) then
		If (iHomeRowAppMainWindowAlert == 0) Then
			let iHomeRowAppMainWindowAlert = 1
			SayFormattedMessage (ot_jaws_message, cmsg345_L, cmsg345_S) ; "Exiting the window tree for the currently active application"
		endIf	
	else
		If (iHomeRowAppMainWindowAlert == 1) Then
			let iHomeRowAppMainWindowAlert = 0
			SayFormattedMessage (ot_jaws_message, cmsg346_L, cmsg346_S) ; "Entering the window tree for the currently active application"
		endIf	
	endIf
else
	let hHomeRowPos = hTemp
	SayFormattedMessage (ot_jaws_message, cmsg130_L) ;"Child window not found"
endIf
EndScript

;Move up one level
Script  UtilityMoveToParent()
;{homerow+shift+f2}
var
	handle hTemp
let hTemp = hHomeRowPos
let hHomeRowPos = GetParent (hHomeRowPos)
if  (hHomeRowPos) then
	UtilitySayInfo(FALSE) ;produces the requested output
	If (iHomeRowSpeakWindowVisibility == on) then
		If (IsWindowVisible (hHomeRowPos) ||
			!IsWindowObscured (hHomeRowPos)) then
			SayFormattedMessage (ot_help, cmsg343_L) ; "Visible"
		else
			SayFormattedMessage (ot_help, cmsg344_L) ; "not visible"
		endIf
	endIf
	If (GetAppMainWindow (hHomeRowPos) != GetAppMainWindow (GlobalFocusWindow)) then
		If (iHomeRowAppMainWindowAlert == 0) Then
			let iHomeRowAppMainWindowAlert = 1
			SayFormattedMessage (ot_jaws_message, cmsg345_L, cmsg345_S) ; "Exiting the window tree for the currently active application"
		endIf	
	else
		If (iHomeRowAppMainWindowAlert == 1) Then
			let iHomeRowAppMainWindowAlert = 0
			SayFormattedMessage (ot_jaws_message, cmsg346_L, cmsg346_S) ; "Entering the window tree for the currently active application"
		endIf	
	endIf
else
	let hHomeRowPos = hTemp
	SayFormattedMessage (ot_jaws_message, cmsg131_L) ;"Parent window not found"
endIf
EndScript

;Adjust UT_OutputMode
Script UtilitySetOutputMode ()
;{homerow+f3}
If UT_OutputMode == UT_REALNAME then
	let UT_OutputMode = UT_SAYTYPEANDTEXT
Else
	let UT_OutputMode = UT_OutputMode + 1
endIf
PerformScript UtilitySayOutputMode ()
EndScript

Script UtilitySetOutputModeReverseOrder ()
;{Homerow+Shift+F3}
If UT_OutputMode == UT_SAYTYPEANDTEXT then
	let UT_OutputMode = UT_REALNAME
Else
	let UT_OutputMode = UT_OutputMode - 1
endIf
PerformScript UtilitySayOutputMode ()
EndScript

Script UtilitySayOutputMode ()
If UT_OutputMode == UT_SAYTYPEANDTEXT then
	SayFormattedMessage (ot_status, cmsg133_L, cmsg133_S) ;"Say Type and Text"
endIf
If UT_OutputMode == UT_FOCUS then
	SayFormattedMessage (ot_status, cmsg132_L) ;"focus"
endIf
If UT_OutputMode == UT_CONTROLID then
	SayFormattedMessage (ot_status, cmsg134_L, cmsg134_S) ;"control i d"
endIf
If UT_OutputMode == UT_CLASS then
	SayFormattedMessage (ot_status, cmsg135_L) ;"Class"
endIf
If UT_OutputMode == UT_TYPE then
	SayFormattedMessage (ot_status, cmsg136_L) ;"Type"
endIf
If UT_OutputMode == UT_SUBTYPE then
	SayFormattedMessage (ot_status, cmsg137_L, cmsg137_S) ;"Sub type code"
endIf
If UT_OutputMode == UT_REALNAME then
	SayFormattedMessage (ot_status, cmsg138_L) ;"Real name"
endIf
EndScript

Script UtilitySetMSAAObjectOutputMode ()
;{homerow+f10}
If (ut_MSAAObjectOutputMode == ut_ObjectSubType) then
	let ut_MSAAObjectOutputMode = ut_ObjectName
Else
	let ut_MSAAObjectOutputMode = ut_MSAAObjectOutputMode + 1
endIf
PerformScript UtilitySayMSAAObjectOutputMode ()
EndScript

Script UtilitySetMSAAObjectOutputModeReverseOrder ()
;{Homerow+Shift+F10}
If (ut_MSAAObjectOutputMode == ut_ObjectName) then
	let ut_MSAAObjectOutputMode = ut_ObjectSubType
Else
	let ut_MSAAObjectOutputMode = ut_MSAAObjectOutputMode - 1
endIf
PerformScript UtilitySayMSAAObjectOutputMode ()
EndScript

Script UtilitySayMSAAObjectOutputMode ()
;HomeRow+F12
If (ut_MSAAObjectOutputMode == ut_ObjectName) then
	SayFormattedMessage (ot_status, cmsg347_L) ; "Name"
endIf
If (ut_MSAAObjectOutputMode == ut_ObjectType) then
	SayFormattedMessage (ot_status, cmsg348_L) ; "Type"
endIf
If (ut_MSAAObjectOutputMode == ut_ObjectSubType) then
	SayFormattedMessage (ot_status, cmsg349_L) ; "SubType"
endIf
EndScript

;Adjust UT_FontMode
Script  UtilitySetFontMode()
;{homerow+f4}
If (UT_FontMode == 0 ) then
	let UT_FontMode = ATTRIB_HIGHLIGHT
endIf
If UT_FontMode == ATTRIB_HIGHLIGHT then
	let UT_FontMode = ATTRIB_BOLD
Else
	If UT_FontMode == ATTRIB_STRIKEOUT then
		let UT_FontMode = UT_FontMode * 4
	Else
		let UT_FontMode = UT_FontMode * 2
	endIf
endIf
If UT_FontMode == ATTRIB_BOLD then
	SayFormattedMessage (ot_status, cmsg139_L) ;"Bold"
endIf
If UT_FontMode == ATTRIB_ITALIC then
	SayFormattedMessage (ot_status, cmsg140_L) ;"Italic"
endIf
If UT_FontMode == ATTRIB_UNDERLINE then
	SayFormattedMessage (ot_status, cmsg141_L) ;"Underline"
endIf
If UT_FontMode == ATTRIB_HIGHLIGHT then
	SayFormattedMessage (ot_status, cmsg142_L) ;"Highlight"
endIf
If UT_FontMode == ATTRIB_STRIKEOUT then
	SayFormattedMessage (ot_status, cmsg143_L) ;"Strikeout"
endIf
EndScript

;Called by utilities to speak the requested information
Void Function UtilitySayInfo (int bSpellMode)
If (UT_OutputMode == UT_SAYTYPEANDTEXT) then
	SayWindowTypeAndText (hHomeRowPos)
endIf
If (UT_OutputMode == UT_FOCUS) then
	SayInteger (hHomeRowPos)
endIf
If (UT_OutputMode == UT_CONTROLID) then
	SayInteger (GetControlID (hHomeRowPos))
endIf
If (UT_OutputMode == UT_CLASS) then
	If (bSpellMode) then
		SpellString (GetWindowClass (hHomeRowPos))
	Else
		Say (GetWindowClass (hHomeRowPos), ot_help)
	endIf
endIf
If (UT_OutputMode == UT_TYPE) then
	If (bSpellMode) then
		SpellString (GetWindowType (hHomeRowPos))
	Else
		Say (GetWindowType (hHomeRowPos), ot_help)
	endIf
endIf
If (UT_OutputMode == UT_SUBTYPE) then
		SayInteger (GetWindowSubTypeCode (hHomeRowPos))
endIf
If (UT_OutputMode == UT_REALNAME) then
	If (bSpellMode) then
		SpellString (GetWindowName (GetRealWindow (hHomeRowPos)))
	Else
		Say (GetWindowName (GetRealWindow (hHomeRowPos)), ot_help)
	endIf
endIf
EndFunction

Script UtilityCopyInfo ()
;HomeRow+Control+F1
var 
	int iTemp,
	string sTemp
If (UT_OutputMode == UT_SAYTYPEANDTEXT) then
	let ClipboardTextChanged = true
	CopyToClipboard (GetWindowType (hHomeRowPos)+" "+GetWindowText (hHomeRowPos, false))
	SayWindowTypeAndText (hHomeRowPos)
endIf
If (UT_OutputMode == UT_FOCUS) then
	let ClipboardTextChanged = true
	CopyToClipboard (IntToString (hHomeRowPos))
	SayInteger (hHomeRowPos)
endIf
If (UT_OutputMode == UT_CONTROLID) then
	let iTemp = GetControlID (hHomeRowPos)
	let ClipboardTextChanged = true
	CopyToClipboard (IntToString (iTemp))
	SayInteger (iTemp)
endIf
If (UT_OutputMode == UT_CLASS) then
	let sTemp = GetWindowClass (hHomeRowPos)
	let ClipboardTextChanged = true
	CopyToClipboard (sTemp)
		Say (sTemp, ot_help)
endIf
If (UT_OutputMode == UT_TYPE) then
	let sTemp = GetWindowType (hHomeRowPos)
	let ClipboardTextChanged = true
	CopyToClipboard (sTemp)
		Say (sTemp, ot_help)
endIf
If (UT_OutputMode == UT_SUBTYPE) then
	let iTemp = GetWindowSubTypeCode (hHomeRowPos)
	let ClipboardTextChanged = true
	CopyToClipboard (IntToString (iTemp))
		SayInteger (iTemp)
endIf
If (UT_OutputMode == UT_REALNAME) then
	let sTemp = GetWindowName (GetRealWindow (hHomeRowPos))
	let ClipboardTextChanged = true
	CopyToClipboard (sTemp)
		Say (sTemp, ot_help)
endIf
EndScript

Void Function UtilitySayMSAAObjectInfo (int bSpellMode)
;HomeRow+F9
var
	string sTemp,
	int iMSAA_JCFOpt
let iMSAA_JCFOpt = GetJCFOption (opt_MSAA_mode)
SetJCFOption (opt_MSAA_mode, 2)
If (ut_MSAAObjectOutputMode == ut_ObjectName) then
	If (bSpellMode) then
		SpellString (GetObjectName ())
	Else
		Say (GetObjectName (), ot_help)
	endIf	
endIf
If (ut_MSAAObjectOutputMode == ut_ObjectType) then
	If (bSpellMode) then
		SpellString (GetObjectType ())
	Else
		let sTemp = GetObjectType ()
		If (sTemp) then
			Say (sTemp, ot_help)
		else
			SayFormattedMessage (ot_help, cmsg351_L) ; "Unknown"
		endIf
	endIf	
endIf
If (ut_MSAAObjectOutputMode == ut_ObjectSubType) then
	SayInteger (GetObjectTypeCode ())
endIf
SetJCFOption (opt_MSAA_mode, iMSAA_JCFOpt)
EndFunction

Script UtilityCopyMSAAObjectInfo ()
;HomeRow+Control+F9
Var
	string sTemp,
	int iTemp,
	int iMSAA_JCFOpt
let iMSAA_JCFOpt = GetJCFOption (opt_MSAA_mode)
SetJCFOption (opt_MSAA_mode, 2)
If (ut_MSAAObjectOutputMode == ut_ObjectName) then
	let sTemp = GetObjectName ()
	let ClipboardTextChanged = true
	CopyToClipboard (sTemp)
		Say (sTemp, ot_help)
endIf
If (ut_MSAAObjectOutputMode == ut_ObjectType) then
	let sTemp = GetObjectType ()
	let ClipboardTextChanged = true
	CopyToClipboard (sTemp)
		Say (sTemp, ot_help)
endIf
If (ut_MSAAObjectOutputMode == ut_ObjectSubType) then
	let iTemp = GetObjectTypeCode ()
	let ClipboardTextChanged = true
	CopyToClipboard (IntToString (iTemp))
		SayInteger (iTemp)
endIf
SetJCFOption (opt_MSAA_mode, iMSAA_JCFOpt)
EndScript

Script UtilitySayWindow ()
SayWindow (hHomeRowPos, read_everything)
EndScript

Script UtilityResetOutputMode ()
SayFormattedMessage (ot_jaws_message, cmsg182_L, cmsgSilent) ; "output mode is"
let UT_OutputMode = UT_SAYTYPEANDTEXT
SayFormattedMessage (ot_status, cmsg133_L, cmsg133_S) ;"Say Type and Text"
EndScript

Script UtilitySayWindowPromptAndText ()
SayWindowTypeAndText(hHomeRowPos)
EndScript

Script UtilityRouteJawsCursorToPc ()
If (IsInvisibleCursor ()) then
	MoveToWindow (hHomeRowPos)
	SayFormattedMessage (ot_status, cmsg353_L, cmsg353_S) ;"Route invisible to Home Row"
else
	JAWSCursor()
	MoveToWindow (hHomeRowPos)
	SayFormattedMessage (ot_status, cmsg352_L, cmsg352_S) ;"Route jaws to HomeRow"
endIf
EndScript

Script UtilityWindowClassReassign ()
var
	string TheApp,
	string TheClass,
	string RunIt
let TheApp = GetAppFileName ()
let TheClass = GetWindowClass (hHomeRowPos)
ToggleHomeRow ()
;cwn2="Invalid Window Handle"
If (TheClass == cwn2) then
	;cwn3="Invalid"
	let TheClass = cwn3
endIf
;RunIt = JConfig.exe -a[Application] + -c[Class Name] + d[Dialog mode]
let RunIt = "\"" + GetJawsDirectory () + "\\" + MGR_CONFIG + "\"" + " " + FLAG_APP + "\"" + TheApp + "\" " + FLAG_CLASS + "\"" + TheClass + "\"" + " " + FLAG_CLASS_MODE
Run (RunIt)
EndScript

;***End of Utility scripts

Script  SayFrame(string FrameName)
SayFrame (FrameName)
EndScript

Script  SayFrameAtCursor()
SayFrameAtCursor ()
EndScript

Void Function ScriptAndAppNames (string sFileName)
var
	string sMessageShort,
	string sMessageLong,
	string sApp
let sApp = GetAppFileName ()
If UserBufferIsActive ()then
	SayFormattedMessage (OT_NO_DISABLE, cMsgVirtualViewerSettings)
	Return
EndIf
let sMessageLong = FormatString (cmsg145_L, sFileName, sApp, GetSpellString (sApp))
let sMessageShort = FormatString (cmsg145_S, sFileName, sApp, GetSpellString (sApp))
SayFormattedMessage (ot_no_disable, sMessageLong, sMessageShort)
EndFunction

Script ClearValues()
FrameClearValues ()
DragAndDropClearValues ()
BrailleSelectTextClearValues ()
SayFormattedMessage (ot_status, cmsg185_L, cmsg185_S) ; "Values Cleared"
EndScript

;**********************************
;     Extended Key Scripts  *
;**********************************

Script  SayNextCharacterPCCursor()
If ( ! GetDefaultJcfOption (OPT_TETHER_JAWS_TO_PC)) then
	SaveCursor ()
endIf
PcCursor ()
PerformScript SayNextCharacter()
EndScript

Script  SayPriorCharacterPCCursor()
If ( ! GetDefaultJcfOption (OPT_TETHER_JAWS_TO_PC)) then
	SaveCursor ()
endIf
PcCursor ()
PerformScript SayPriorCharacter()
EndScript

Script  SayNextLinePCCursor()
If ( ! GetDefaultJcfOption (OPT_TETHER_JAWS_TO_PC)) then
	SaveCursor ()
endIf
PcCursor ()
PerformScript SayNextLine()
EndScript

Script  SayPriorLinePCCursor()
If ( ! GetDefaultJcfOption (OPT_TETHER_JAWS_TO_PC)) then
	SaveCursor ()
endIf
PcCursor ()
PerformScript SayPriorLine()
EndScript

Script  SayNextWordPCCursor()
If ( ! GetDefaultJcfOption (OPT_TETHER_JAWS_TO_PC)) then
	SaveCursor ()
endIf
PcCursor ()
PerformScript SayNextWord()
EndScript

Script  SayPriorWordPCCursor()
If ( ! GetDefaultJcfOption (OPT_TETHER_JAWS_TO_PC)) then
	SaveCursor ()
endIf
PcCursor ()
PerformScript SayPriorWord()
EndScript

Script  ControlDownArrowPCCursor()
If ( ! GetDefaultJcfOption (OPT_TETHER_JAWS_TO_PC)) then
	SaveCursor ()
endIf
PcCursor ()
PerformScript ControlDownArrow()
EndScript

Script  ControlUpArrowPCCursor()
If ( ! GetDefaultJcfOption (OPT_TETHER_JAWS_TO_PC)) then
	SaveCursor ()
endIf
PcCursor ()
PerformScript ControlUpArrow()
EndScript

;*************************
;     Braille Scripts         *
;*************************

Script BrailleToggleMode ()
SetActiveBrailleMode ()
EndScript

Script BrailleGrade2Translation ()
SetBrailleGradeTwoMode ()
EndScript

Script BrailleGrade2ExpandCurrentWord ()
SetBrailleExpandCurrentWord ()
EndScript

Script BrailleMovesActive ()
SetBrailleMovesActive ()
EndScript

Script ActiveMovesBraille ()
; Determins wether or not the braille display follows the active cursor
SetActiveMovesBraille ()
EndScript

Script BrailleToggleSpeechInterrupt ()
SetBrailleSpeechInterrupt ()
EndScript

Script BrailleToggleCharactersAndAttributes()
SetBrailleCharactersOrAttributes ()
EndScript

Script BrailleTab()
BrailleTabKey ()
EndScript

Script BrailleShiftTab ()
BrailleShiftTabKey ()
EndScript

Script BrailleEnter()
BrailleEnterKey ()
EndScript

Script BrailleEscape()
BrailleEscapeKey ()
EndScript

Script BrailleToggleCursor()
; Toggle between the JAWS and PC cursor
if (IsPCCursor ()) then
	PerformScript JawsCursor ()
else
	PerformScript PCCursor ()
endIf
EndScript

Script BrailleAltTab ()
BrailleAltTabKey ()
EndScript

Script BraillePriorLine ()
BrailleNavPriorLine ()
EndScript

Script BrailleNextLine ()
BrailleNavNextLine ()
EndScript

Script BraillePanLeft()
; If there is more text to the left on the current line, display it.
; If not, display the final segment of the previous line.
var
	int moved
BrailleNavPanLeft ()
EndScript

Script BraillePanRight ()
; If there is more text on the current line, then display it.
; Otherwise, display the first segment of the next line.
BrailleNavPanRight ()
EndScript

Script BrailleMoveLeft ()
BrailleNavMoveLeft ()
EndScript

Script BrailleMoveRight ()
BrailleNavMoveRight ()
EndScript

Script BrailleToggle8PixelsPerSpace ()
BrailleSet8OrUnlimitedPixels ()
EndScript

Script BrailleRouting()
var
	int nCell,
	int nState
let nCell = GetLastBrailleRoutingKey ()
if not GetFocus() then
	MinimizeAllApps ()
	return
endIf
BrailleRoutingButton(nCell)
if IsJAWSCursor () then
	LeftMouseButton()
endIf
;Following code blocked out because
;No longer necessary.
;ObjStateChangedEvent now handles it properly.
/*
If GetObjectSubtypeCode()== WT_CHECKBOX ||
	GetObjectSubtypeCode()==WT_3STATE then
	Delay(1)
	If (ControlIsChecked ()) then
		SayFormattedMessage (ot_ITEM_STATE, cMSG293_L)
	else
		SayFormattedMessage (ot_item_state, cMSG294_L) ; not checked
	endIf
ElIf (GetObjectTypeCode()==WT_LISTBOX) then
	Delay(1)
	let nState = GetControlAttributes()
	If (nState& CTRL_CHECKED) then
		SayFormattedMessage (ot_ITEM_STATE, cMSG293_L)
	ElIf (nState& CTRL_UNCHECKED) then
		SayFormattedMessage (ot_item_state, cMSG294_L) ; not checked
	endIf
	EndComment*/
If getObjectTypeCode()==wt_tabControl then
	delay(1)
	sayObjectActiveItem()
endIf
EndScript

int Function BrailleBuildLine ()
;Note this is only here for backward compatibility.
;JAWS 4.0 no longer uses it but it will still be called before other Braille 
;functions. If this function returns true then the new functionality will not 
;be used.
return false
EndFunction

Script BrailleTop ()
if not BrailleIsStructuredLine () then
	SaveCursor ()
	BrailleCursor ()
	RouteBrailleToPC ()
	JAWSPageUp ()
	JAWSHome ()
	SayFormattedMessage (ot_jaws_message, cmsg44_L, cmsg44_S) ; "top of window"
else
	while (BraillePanLeft ())
	EndWhile
	SayFormattedMessage (ot_jaws_message, cmsg220_L, cmsg220_S) ; "Beginning of line"
endIf
EndScript

Script BrailleBottom ()
if not BrailleIsStructuredLine () then
	SaveCursor ()
	BrailleCursor ()
	RouteBrailleToPC ()
	JAWSPageDown ()
	JAWSEnd ()
	SayFormattedMessage (ot_jaws_message, cmsg45_L, cmsg45_S) ; "bottom of window"
else
	while (BraillePanright ())
	EndWhile
	SayFormattedMessage (ot_jaws_message, cmsg221_L, cmsg221_S) ; "End of line"
endIf
EndScript

Script BrailleSet8PixelsPerSpace()
SetBraille8PixelsPerSpace ()
EndScript

Script BrailleSetUnlimittedPixelsPerSpace()
BrailleSetUnlimitedPixelsPerSpace ()
EndScript

Script BrailleToggleMarking()
MarkingList()
EndScript

Script  BrailleTurnMarkingOff()
TurnOffBrailleMarking ()
EndScript

script BrailleDescribeFont()
BrailleDescribeFontAtCursor ()
EndScript

Script  BrailleToggle8Dots()
Set6Or8Dots ()
EndScript

Script  BrailleSet6Dots()
SetSixDotBraille ()
EndScript

Script BrailleSet8Dots()
SetEightDotBraille ()
EndScript

Script RouteBrailleToPC ()
RouteBrailleToPC ()
EndScript

Script RouteBrailleToJaws ()
RouteBrailleToJaws ()
EndScript

Script RouteBrailleToActiveCursor ()
var
	int ActiveCursor
let activeCursor = GetActiveCursor ()
if (ActiveCursor == cursor_jaws) then
	RouteBrailleToJaws ()
ElIf (ActiveCursor == cursor_pc) then
	RouteBrailleToPC ()
endIf
EndScript

Script BrailleSelectText ()
SelectTextWithBraille ()
EndScript

script BrailleControlLeftMouseClick()
BrailleControlLeftMouseClick()
endScript

Script BrailleToggleSpeechBox ()
ToggleSpeechBoxMode ()
EndScript

Script BrailleToggleBrailleLineMode ()
BrailleSetToLineMode ()
EndScript

Script BrailleDescribeItem ()
BrailleDescribeItemAtCursor ()
EndScript

Script BrailleRightMouseClick ()
RightClickWithBraille ()
EndScript

Script BrailleChangeCursorShape ()
ToggleShapeOfCursors ()
EndScript

Script BrailleLineCursorShapeOff ()
BrailleToggleCursorBlinking ()
EndScript

; The following set of scripts are intended for Papenmeier  Braille Displays

;  Announcement for Switches and Toggles

Script FHPBraille2DTogglePCMode ()
	FHPBraille2DTogglePCMode ()
EndScript

Script FHPBraille2DToggleReadingMode ()
	FHPBraille2DToggleReadingMode ()
EndScript

Script FHPBrailleKeyPCMode ()
	FHPBrailleKeyPCMode ()
EndScript

Script FHPBrailleKeyNavigationMode ()
	FHPBrailleKeyNavigationMode ()
EndScript

Script FHPBrailleKeyReadingMode ()
	FHPBrailleKeyReadingMode ()
EndScript

Script FHPBrailleKeySpeechMode ()
	FHPBrailleKeySpeechMode ()
EndScript

Script FHPBrailleKeyBrailleMode ()
	FHPBrailleKeyBrailleMode ()
EndScript

Script FHPBrailleKeyBrailleSpeechMode ()
	FHPBrailleKeyBrailleSpeechMode ()
EndScript


; PC key simulation
; Braillex EL right switch in rear position = PC Mode
Script  FHPcursorup()
	FHPcursorup()
EndScript

Script  FHPcursordown()
	FHPcursordown()
EndScript

Script  FHPcursorright()
	FHPcursorright()
EndScript

Script  FHPcursorleft()
	FHPcursorleft()
EndScript

Script FHPBrailleTab()
	FHPBrailleTab()
EndScript

Script FHPBrailleShiftTab()
	FHPBrailleShiftTab()
EndScript

Script FHPBrailleEscape()
	FHPBrailleEscape()
EndScript

Script FHPBrailleEnter()
	FHPBrailleEnter()
EndScript


; Navigation Mode
; Braillex EL right switch in central position
Script FHPBraillePriorLine()
	FHPBraillePriorLine()
EndScript

Script FHPBrailleNextLine()
	FHPBrailleNextLine()
EndScript

Script FHPBraillePanLeft()
	FHPBraillePanLeft()
EndScript

Script FHPBraillePanRight()
	FHPBraillePanRight()
EndScript


; Combined Mode
; Braillex EL right key in front position
Script FHPBrailleSpeechPriorLine ()
	FHPBrailleSpeechPriorLine ()
EndScript

Script FHPBrailleSpeechNextLine ()
	FHPBrailleSpeechNextLine ()
EndScript

Script FHPBrailleSpeechPanLeft()
	FHPBrailleSpeechPanLeft()
EndScript

Script FHPBrailleSpeechPanRight()
	FHPBrailleSpeechPanRight()
EndScript


; routing 
;
Script FHPRouting()
	FHPRouting()
EndScript

Script FHPLineRouting()
	FHPLineRouting()
EndScript

Script FHPRoutingAux ()
	FHPRoutingAux ()
EndScript

; Attribute handling
;
Script FHPBrailleTurnMarkingOff()
	FHPBrailleTurnMarkingOff()
EndScript

Script FHPBrailleShowBoldMarking()
	FHPBrailleShowBoldMarking()
EndScript

Script FHPBrailleShowHighlightMarking()
	FHPBrailleShowHighlightMarking()
EndScript

Script FHPBrailleShowItalicMarking()
	FHPBrailleShowItalicMarking()
EndScript

Script FHPBrailleShowUnderlineMarking()
	FHPBrailleShowUnderlineMarking()
EndScript

Script FHPBrailleShowAllMarking ()
	FHPBrailleShowAllMarking ()
EndScript

Script FHPBrailleToggleCharactersAndAttributes ()
	FHPBrailleToggleCharactersAndAttributes ()
EndScript

Script FHPBrailleToggleAttributeUp ()
	FHPBrailleToggleAttributeUp ()
EndScript

Script FHPBrailleToggleAttributeDown ()
	FHPBrailleToggleAttributeDown ()
EndScript

; 
;
Script FHPBrailleShowWindowsTop ()
	FHPBrailleShowWindowsTop ()
EndScript

Script FHPBrailleShowWindowsBottom ()
	FHPBrailleShowWindowsBottom ()
EndScript

Script FHPBrailleToggle68Dots ()
	FHPBrailleToggle68Dots ()
EndScript

Script FHPToggleCursorMode ()
	FHPToggleCursorMode ()
EndScript

Script FHPBrailleToggleCursorShape ()
	FHPBrailleToggleCursorShape ()
EndScript

Script FHPBrailleActiveCursorTracking ()
	FHPBrailleActiveCursorTracking ()
EndScript

Script FHPBrailleSelectText ()
	FHPBrailleSelectText ()
EndScript

Script FHPBrailleToggleVertical ()
	FHPBrailleToggleVertical ()
EndScript

Script FHPBrailleLineMode ()
	FHPBrailleLineMode ()
EndScript

Script FHPBrailleStructuredMode ()
	FHPBrailleStructuredMode ()
EndScript

Script FHPActivateTaskList ()
	FHPActivateTaskList ()
EndScript

Script FHPBrailleManager ()
	FHPBrailleManager ()
EndScript

Script FHP_RunJAWSManager ()
	FHP_RunJAWSManager ()
EndScript

; EndPapenmeier


;*******
; Keyboard Help section
globals
	int nKeyboardHelpSavedTypingEcho,
	int nKeyboardHelpSavePunctuation

Script KeyboardHelp()
SayFormattedMessage (ot_status, cmsg167_L, cmsg167_S) ; "Keyboard Help on"
let nKeyboardHelpSavedTypingEcho = GetJCFOption(OPT_TYPING_ECHO)
Let nKeyboardHelpSavePunctuation = GetJcfOption (OPT_PUNCTUATION)
SetJcfOption(OPT_TYPING_ECHO,1) ; echo characters
SetJcfOption (OPT_PUNCTUATION, 1); Almost no punctuation spoken but normal inflection
AddHook (HK_SCRIPT, "KeyboardHelpHook")
; ignore any keys not attached to scripts
TrapKeys(TRUE)
EndScript

Void Function KeyboardHelpHook (string ScriptName, string FrameName)
var
	string sMessageLong,
	string sMessageShort,
	string sText1
if (ScriptName == "KeyboardHelp") then
	SayFormattedMessage (ot_status, cmsg168_L, cmsg168_S) ; "Keyboard Help off"
	RemoveHook (HK_SCRIPT, "KeyboardHelpHook")
	TrapKeys(FALSE)
	SetJcfOption(OPT_TYPING_ECHO,nKeyboardHelpSavedTypingEcho)
	SetJcfOption (OPT_PUNCTUATION, nKeyboardHelpSavePunctuation)
	return FALSE
endIf
if IsSameScript () then
	if ((FrameName != cscNull) && (GetFrameDescription (FrameName) != cscNull)) then
		let sText1 = GetFrameDescription (FrameName)
	let sMessageLong = FormatString (cmsg173_L, sText1)
		SayFormattedMessage (ot_help, sMessageLong, sText1) ; "This frame "
	endIf
	if (FrameName == cscNull) then
		Say (GetScriptDescription(ScriptName), ot_help)
	endIf
else
	Say (GetCurrentScriptKeyName (), ot_help) ; says key name, "insert+up arrow"
	if (FrameName != cscNull) then
		let sMessageLong = FormatString (cmsg174_L, FrameName)
		SayFormattedMessage (ot_help, sMessageLong) ; "says the content of the frame "
		Say (GetFrameSynopsis (FrameName), ot_help)
	else
		Say (GetScriptSynopsis(ScriptName), ot_help)
	endIf
endIf
; by returning  FALSE, a hook function can prevent a script from being run
return FALSE
EndFunction

Int Function RoutePCToInvisible ()
var
	int Row,
	int Column,
	int nSuccess
InvisibleCursor()
let Row = getCursorRow ()
let Column = getCursorCol ()
PCCursor()
let nSuccess = MoveTo (Column, Row)
return nSuccess
EndFunction

Script SayAppVersion ()
var
	string sProduct,
	string sVersion,
	string sMessage
let sProduct = GetVersionInfoString (GetAppFilePath (), cmsg282_L)
let sVersion = GetVersionInfoString (GetAppFilePath (), cmsg283_L)
let sMessage = FormatString (cmsg239_L, sProduct, sVersion)
SayFormattedMessage (ot_help, sMessage)
EndScript

Script SayProgramComments ()
SayFormattedMessage (ot_help, GetVersionInfoString (GetAppFilePath (), cmsg284_L))
EndScript

Void Function RestrictCursor (int nStatus)
if (nStatus == on) then
	SetRestriction(RestrictWindow)
else
	SetRestriction(RestrictAppWindow)
endIf
EndFunction

Script SayTaskBar ()
var
	handle hWnd
let hWnd = FindTopLevelWindow (cwcShellTray, cscNull)
let hWnd = GetFirstChild(hWnd)
if (hWnd) then
	while (hWnd && GetWindowClass (hWnd) != cwcMSTask)
		if GetWindowClass (hWnd) == cwcRebarWnd then ; Win_98
			let hWnd = GetFirstChild(hWnd)
		else
			let hWnd = GetNextWindow(hWnd)
		endIf
	EndWhile
	let hWnd = GetFirstChild(hWnd)
	while (hWnd && GetWindowClass (hWnd) != cwcSysTabCtrl32)
		let hWnd = GetNextWindow(hWnd)
	EndWhile
	if (GetWindowClass(hWnd) == cwcSysTabCtrl32 && !IsWindowObscured (hWnd)) then
		SayWindow(hWnd, READ_EVERYTHING)
		return
	endIf
endIf
SayFormattedMessage (OT_error, cmsg190_L, cmsg190_S) ; "Task bar is not visible"
EndScript

Script SaySystemTray ()
var
	handle hWnd
let hWnd = FindTopLevelWindow (cwcShellTray, cscNull)
let hWnd = FindDescendantWindow (hWnd, 303)
if (hWnd) then
	SayWindow(hWnd, READ_EVERYTHING)
else
	SayFormattedMessage (ot_error, cmsg191_L, cmsg191_S) ; "system tray is not visible"
endIf
EndScript

string function FormatAndText (int iRetCurVal)
var
int iMode

let iMode=GetJCFOption (OPT_FORMAT_AND_TEXT)
if not iRetCurVal then 
;update it
	let iMode=not iMode
	SetJcfOption (OPT_FORMAT_AND_TEXT, iMode)
endIf
if iMode then
	return cmsg252_L
else
	return cmsg251_L
endIf
		  EndFunction

Script AttributesChanges ()
if GetJCFOption (OPT_FORMAT_ATTRIBUTES) == 1 then
	SetDefaultJcfOption (OPT_FORMAT_ATTRIBUTES, 0)
	SayFormattedMessage (ot_status, cmsg251_L)
else
	SetDefaultJcfOption (OPT_FORMAT_ATTRIBUTES, 1)
	SayFormattedMessage (ot_status, cmsg252_L)
endIf
EndScript

Script FontChanges ()
if GetJCFOption (OPT_FORMAT_FONT) == 1 then
	SetDefaultJcfOption (OPT_FORMAT_FONT, 0)
	SayFormattedMessage (ot_status, cmsg251_L)
else
	SetDefaultJcfOption (OPT_FORMAT_FONT, 1)
	SayFormattedMessage (ot_status, cmsg252_L)
endIf
EndScript

Script PointSizeChanges ()
if GetJCFOption (OPT_FORMAT_POINTSIZE) == 1 then
	SetDefaultJcfOption (OPT_FORMAT_POINTSIZE, 0)
	SayFormattedMessage (ot_status, cmsg251_L)
else
	SetDefaultJcfOption (OPT_FORMAT_POINTSIZE, 1)
	SayFormattedMessage (ot_status, cmsg252_L)
endIf
EndScript

Script TextColorChanges ()
if GetJCFOption (OPT_FORMAT_TEXTCOLOR) == 1 then
	SetDefaultJcfOption (OPT_FORMAT_TEXTCOLOR, 0)
	SayFormattedMessage (ot_status, cmsg251_L)
else
	SetDefaultJcfOption (OPT_FORMAT_TEXTCOLOR, 1)
	SayFormattedMessage (ot_status, cmsg252_L)
endIf
EndScript

Script BackgroundColorChanges ()
if GetJCFOption (OPT_FORMAT_BACKGROUNDCOLOR) == 1 then
	SetDefaultJcfOption (OPT_FORMAT_BACKGROUNDCOLOR, 0)
	SayFormattedMessage (ot_status, cmsg252_L)
else
	SetDefaultJcfOption (OPT_FORMAT_BACKGROUNDCOLOR, 1)
	SayFormattedMessage (ot_status, cmsg251_L)
endIf
EndScript

String Function IntToAttribName (int attrib)
if (attrib == attrib_bold) then
	return cmsg139_L ;"Bold"
endIf
if (attrib == attrib_italic) then
	return cmsg140_L ;"Italic"
endIf
if (attrib == attrib_underline) then
	return cmsg141_L ;"Underline"
endIf
if (attrib == attrib_highlight) then
	return cmsg142_L ;"Highlight"
endIf
if (attrib == attrib_strikeout) then
	return cmsg143_L ;"Strikeout"
endIf
if (attrib == attrib_graphic) then
	return cmsg144_L ;"Graphic"
endIf
return cscNull
EndFunction

Void Function SayFormatAndText (string buffer, ; text to be spoken
	int attributes, ; attributes for this segment of text
	int attributesFound, ; attributes present in previous segments of text since the last normal text
	string fontName, ; name of the font of this segment of text
	int points, ; point size of this segment of text
	int textColor, int backgroundColor, ; colors of the segment
	int repetitions, ; number of times this segment is repeated
	int capType, ; type of capitalization present on this segment, it can be
;				one of the CAPITALIZATION_ constants define in hjconst
	int indentation, ; when reading by lines indicates the number of pixels between
;				the left edge of the window and the first character in the line
	int outputType, ; indicates the type of reading operation that is being performed,
;				it can be one of the OT_ constants defined in hjconst
	int formatDifferences) ; indicates which aspects of the format
;	information have changed from the previous segment.
if formatDifferences & FORMAT_FIRSTSEGMENT then
	if globalSayingCurrentItem then ; speaks all the formatting that is turned on
		let formatDifferences = FORMAT_ALL
	endIf
endIf
if outputType == OT_LINE then
	if formatDifferences & FORMAT_INDENTATION then
		if GetJCFOption (OPT_FORMAT_INDENTATION) == 1 then
			if indentation >= 0 then
				SayUsingVoice (VCTX_MESSAGE, IntToString(indentation) + cmsg275_L, OT_no_disable)
			endIf
		endIf
	endIf
endIf
if formatDifferences & FORMAT_ATTRIBS then
	if GetJCFOption (OPT_FORMAT_ATTRIBUTES) == 1 then
		AttributesChanged (attributes, attributesFound)
	endIf
endIf
if attributes > 0 && !(attributes & ATTRIB_GRAPHIC) then
; this is text
	if formatDifferences & FORMAT_FONT then
		if GetJCFOption (OPT_FORMAT_FONT) == 1 then
			SayUsingVoice (VCTX_MESSAGE, fontName, OT_no_disable)
		endIf
	endIf
	if formatDifferences & FORMAT_POINTS then
		if GetJCFOption (OPT_FORMAT_POINTSIZE) == 1 then
			SayUsingVoice (VCTX_MESSAGE, IntToString (points) + cmsg245_L, OT_no_disable) ;" point"
		endIf
	endIf
	if formatDifferences & FORMAT_TEXTCOLOR then
		if GetJCFOption (OPT_FORMAT_TEXTCOLOR) == 1 then
			SayUsingVoice (VCTX_MESSAGE, GetColorName (textColor), OT_no_disable)
		endIf
	endIf
	if formatDifferences & FORMAT_BACKGROUNDCOLOR then
		if GetJCFOption (OPT_FORMAT_BACKGROUNDCOLOR) == 1 then
			SayUsingVoice (VCTX_MESSAGE, GetColorName (backgroundColor), OT_no_disable)
		endIf
	endIf
endIf
if GetJCFOption (OPT_FORMAT_REPETITIONS) == 1 then
	if ProcessRepetitions (buffer, repetitions, outputType, formatDifferences) then
		return
	endIf
endIf
if GetJCFOption (OPT_FORMAT_CAPITALIZATION) == 1 then
	if capType == CAPITALIZATION_CAP then
	;&& GetJCFOption(OPT_SAY_CAPS)==0 then
		If outputType != OT_Char then
			;To keep from repeating by word,
			;When Word is set for both
			If !(GetJCFOption(OPT_SAY_CAPS) == 2 &&
			outputType == OT_WORD) then
				SayUsingVoice (VCTX_MESSAGE, cmsg246_L, OT_no_disable) ;"cap "
			EndIf
		EndIf
	elif capType == CAPITALIZATION_ALLCAPS THEN
		If !(GetJCFOption(OPT_SAY_CAPS) == 2 &&
		outputType == OT_WORD) then
			SayUsingVoice (VCTX_MESSAGE, cmsg247_L, OT_no_disable) ;"all caps "
		EndIf
	endIf
endIf
;ResetSynth ()
if outputType == OT_LINE then
	If StringIsBlank(buffer) && (formatDifferences & FORMAT_FIRSTSEGMENT) then
		Say (cmsgBlank1, OT_LINE)
	Else
		Say (buffer, OT_no_disable)
	EndIf
else
	Say (buffer, outputType)
endIf
EndFunction

Void Function AttributesChanged (int attributes, int attributesFound)
var
	int attrib
if attributes == 1 then ; this is normal text
	if attributesFound >= ATTRIB_BOLD then
		SayUsingVoice (VCTX_MESSAGE, cmsg244_L, OT_no_disable) ;" Normal "
	endIf
	return
endIf
let attrib = attrib_bold
while (attrib <= attrib_highlight)
	if attributes & attrib then
		SayUsingVoice (VCTX_MESSAGE, IntToAttribName (attrib), OT_no_disable)
	endIf
	let attrib = attrib * 2
EndWhile
EndFunction

int Function ProcessRepetitions (string buffer, int repetitions, int outputType, int formatDifferences)
if repetitions > 1 then
	SayUsingVoice (VCTX_MESSAGE, IntToString (repetitions)+" ",
	OT_no_disable)
	If buffer == cScNull ||
	buffer == cScSpace then
		Say (cMsgSpace1, OT_NO_DISABLE)
		Return 1
	EndIf
	Say(buffer, OT_WORD)
	return 1
endIf
return 0
EndFunction

Script SayTextAndAttributes ()
var
	int x,
	int y,
	handle WinHandle,
	int prevAttrib,
	int curAttrib
let WinHandle = GetFocus ()
SaveCursor ()
InvisibleCursor ()
MoveToWindow (WinHandle)
SetRestriction(RestrictAppWindow)
let prevAttrib = 1
let curAttrib = GetCharacterAttributes ()
while ((x != getCursorCol ()) || (y != getCursorRow ()))
	let x = getCursorCol ()
	let y = getCursorRow ()
	SayAttributesChanges (prevAttrib, curAttrib)
	SayField ()
	NextChunk ()
	let prevAttrib = curAttrib
	let curAttrib = GetCharacterAttributes ()
	delay (1)
EndWhile
RestoreCursor ()
EndScript

Void Function SayAttributesChanges (int prevAttrib, int curAttrib)
var
	int attrib,
	string sAttrib
let attrib = attrib_bold
while (attrib <= attrib_highlight)
	if ((prevAttrib & attrib) != (curAttrib & attrib)) then
		if (curAttrib & attrib) then
			let sAttrib = IntToAttribName (attrib) 
			let sAttrib = FormatString (cmsg240_L, sAttrib)
			SayFormattedMessage (ot_no_disable, sAttrib)
		else
			let sAttrib = IntToAttribName (attrib) 
			let sAttrib = FormatString (cmsg241_L, sAttrib)
			SayFormattedMessage (ot_no_disable, sAttrib)
		endIf
	endIf
	let attrib = attrib * 2
EndWhile
EndFunction

Function MouseMovedEvent (int x, int y)
; Add your code for KeyPressedEvent here.
; Changes made here apply to all applications.
; To make your changes application specific, copy this function to an
; application script file.
EndFunction

Int Function GetWordWidth ()
var
	int nLength,
	int nPixels,
	int nSafety
let nSafety = 0
let nPixels = 0
let nLength = StringLength (GetWord())
if (nLength == 0) then
	return  0
endIf
SaveCursor()
InvisibleCursor()
RouteInvisibleToPc ()
while (nSafety < nLength)
	let nPixels = nPixels + GetCharacterWidth()
	if (IsWordDelimiter(GetCharacter())) then
		return nPixels
	endIf
	NextCharacter()
	let nSafety = nSafety + 1
endwhile
return nPixels
EndFunction

Int Function IsWordDelimiter (string strChar)
if (StringLength(strChar) > 1) then
	return 0
endIf
return (StringContains (WORD_DELIMITERS, strChar) != 0)
EndFunction

Int Function GetBrailleMode ()
return GetJCFOption(OPT_BRL_MODE)
EndFunction

Void Function SetBrailleMode (int nMode)
SetDefaultJcfOption(OPT_BRL_MODE,nMode)
EndFunction

; ***
; Run Manager section
; ***

Script WindowClassReassign ()
	var
		string TheApp,
		string TheClass,
		string RunIt
	Let TheApp = GetActiveConfiguration ()
	let TheClass = GetWindowClass( GetCurrentWindow() )
	;cwn2="Invalid Window Handle"
	If (TheClass == cwn2) then
		;cwn3="Invalid"
		let TheClass = cwn3
	endIf
	;RunIt = JConfig.exe -a[Application] + -c[Class Name] + d[Dialog mode]
	Let RunIt = FormatString (JConfig_Run, GetJawsDirectory (), MGR_CONFIG, FLAG_APP, TheApp, FLAG_CLASS, TheClass, FLAG_CLASS_MODE)
	Run (RunIt)
EndScript

Void Function DoCustomHighlightColors (string strForeground, string strBackground, string sApp)
	var
		int nIndex,
		string RunIt
	;Protect the FocusChangedEvent from misinterpreting the two successive HJ Dialogs
	Let GlobalWasHjDialog = FALSE
	let nIndex = DlgSelectItemInList (cmsgCustomHighlight1, cmsgCustomHighlight2, false)
	If (nIndex == 0) then
		return
	endIf
	If (nIndex == 1) then
		;let RunIt = "\"" + GetJawsDirectory() + "\\" + MGR_CONFIG + "\" " + FLAG_APP + "\"" + sApp + "\" " +  "-b" + strBackground + " -f" + strForeground + " -dHIGHLIGHTS"
		Let RunIt = FormatString (JConfig_Color_Run, 
			GetJawsDirectory (), MGR_CONFIG,
			FLAG_APP, sApp, 
			FLAG_FOREGROUND_COLOR, strForeground, 
			FLAG_BACKGROUND_COLOR, strBackground, 
			FLAG_HIGHLIGHTS_MODE)
	ElIf (nIndex == 2) then
		;let RunIt = "\"" + GetJawsDirectory() + "\\" + MGR_CONFIG + "\" " + FLAG_APP + "\"" + sApp + "\" " + " -f" + strForeground + " -dHIGHLIGHTS"
		Let RunIt = FormatString (JConfig_Color_Run, 
			GetJawsDirectory (), MGR_CONFIG, 
			FLAG_APP, sApp, 
			FLAG_FOREGROUND_COLOR, strForeground, 
			cScNull, cScNull, 
			FLAG_HIGHLIGHTS_MODE)
	ElIf (nIndex == 3) then
		;let RunIt = "\"" + GetJawsDirectory() + "\\" + MGR_CONFIG + "\" " + FLAG_APP + "\"" + sApp + "\" " +  "-b" + strBackground + " -dHIGHLIGHTS"
		Let RunIt = FormatString (JConfig_Color_Run, 
			GetJawsDirectory (), MGR_CONFIG, 
			FLAG_APP, sApp, 
			cScNull, cScNull, 
			FLAG_BACKGROUND_COLOR, strBackground, 
			FLAG_HIGHLIGHTS_MODE)
	endIf
	Run(RunIt)
EndFunction

Void Function AddBrailleColors (string strForeground, string strBackground, string sApp)
	var
		int nIndex,
		string RunIt
	;Protect the FocusChangedEvent from misinterpreting the two successive HJ Dialogs
	Let GlobalWasHjDialog = FALSE
	let nIndex = DlgSelectItemInList (cmsgCustomHighlight1, cmsgCustomHighlight2, false)
	If (nIndex == 0) then
		return
	endIf
	If (nIndex == 1) then
		Let RunIt = FormatString (JConfig_Color_Run, 
			GetJawsDirectory (), MGR_CONFIG,
			FLAG_APP, sApp, 
			FLAG_BRL_FOREGROUND_COLOR, strForeground, 
			FLAG_BRL_BACKGROUND_COLOR, strBackground, 
			FLAG_BRAILLE_COLORS_MODE)
	ElIf (nIndex == 2) then
		Let RunIt = FormatString (JConfig_Color_Run, 
			GetJawsDirectory (), MGR_CONFIG,
			FLAG_APP, sApp, 
			FLAG_BRL_FOREGROUND_COLOR, strForeground, 
			cScNull, cScNull, 
			FLAG_BRAILLE_COLORS_MODE)
	ElIf (nIndex == 3) then
		Let RunIt = FormatString (JConfig_Color_Run, 
			GetJawsDirectory (), MGR_CONFIG,
			FLAG_APP, sApp, 
			cScNull, cScNull, 
			FLAG_BRL_BACKGROUND_COLOR, strBackground, 
			FLAG_BRAILLE_COLORS_MODE)
	endIf
	Run(RunIt)
EndFunction

Script CustomHighlightAssign ()
	var
		string TheApp,
		string strForeground, 
		string strBackground
	Let TheApp = GetActiveConfiguration ()
	let strForeground = ColorToRGBString(GetColorText())
	let strBackground = ColorToRGBString(GetColorBackground())
	DoCustomHighlightColors (strForeground, strBackground, TheApp)
EndScript

Script BrailleColorMarkingAssign ()
	var
		string TheApp,
		string strForeground, 
		string strBackground
	Let TheApp = GetActiveConfiguration ()
	SaveCursor ()
	BrailleCursor ()
	let strForeground = ColorToRGBString(GetColorText())
	let strBackground = ColorToRGBString(GetColorBackground())
	RestoreCursor ()
	AddBrailleColors (strForeground, strBackground, TheApp)
EndScript

Script ConfigManager ()
	var
		string TheApp,
		string TheClass,
		string RunIt
	;let TheApp = GetAppFileName ()
	Let TheApp = GetActiveConfiguration ()
	let TheClass = GetWindowClass (GetCurrentWindow())
	;cwn2="Invalid Window Handle"
	If (TheClass == cwn2) then
		;cwn3="Invalid"
		let TheClass = cwn3
	endIf
	;RunIt = JConfig.exe -a[Application] + -c[Class Name]
	;let RunIt = "\"" + GetJawsDirectory () + "\\" + MGR_CONFIG + "\"" + " " + FLAG_APP + "\"" + TheApp + "\"" + " " + FLAG_CLASS + "\"" + TheClass + "\""
	Let RunIt = FormatString (JConfig_Run, 
		GetJawsDirectory (), MGR_CONFIG, 
		FLAG_APP, TheApp, 
		FLAG_CLASS, TheClass, cScNull)
	Run (RunIt)
EndScript

String Function CreateDictionaryCommandLine (int bDoAddDialog)
	var
		string theword,
		int HighlightFound,
		string TheApp,
		string Runit,
		HANDLE CurrentWindow
	let theword = GetWord()
	Let TheApp = GetActiveConfiguration ()
	let CurrentWindow = GetCurrentWindow()
	if (GetCharacterAttributes() & ATTRIB_GRAPHIC) then
		SayFormattedMessage (ot_error, cmsg177_L) ; "Use the Graphics Labeler to label graphics"
		return cscNull
	endIf
	;See if there is highlighted text
	if (IsPCCursor()) then
		SaveCursor()
		InvisibleCursor ()
		RouteInvisibleToPc ()
		if (GetCharacterAttributes () & ATTRIB_HIGHLIGHT) then
			let theWord = "\""+GetField()+"\""
		else
			PriorCharacter ()
			if (GetCharacterAttributes () & ATTRIB_HIGHLIGHT) then
				let theWord = "\""+GetField()+"\""
			endIf
		endIf
		RestoreCursor()
	endIf
	if (theword != cscNull) then
		;RunIt = "JDiction.exe -a[Application] -r[Rule]
		let Runit = "\"" + GetJawsDirectory () + "\\" + MGR_DICTION + "\"" + "  " + FLAG_APP + "\"" + TheApp + "\"  " +  FLAG_RULE + theword
		if (bDoAddDialog == TRUE) then
			let Runit = Runit + " -d"
		endIf
	else
		;RunIt = "JDiction.exe -a[Application]
		let Runit = "\"" + GetJawsDirectory () + "\\" + MGR_DICTION + "\"" + "  " + FLAG_APP + "\"" + TheApp + "\""
		if (bDoAddDialog == TRUE) then
			let Runit = Runit + " -d"
		endIf
	endIf
	return RunIt
EndFunction

Script DictionaryManager ()
	var
		String RunIt
	;Start dictionary Manager
	let RunIt = CreateDictionaryCommandLine (FALSE)
	if (RunIt != cscNull) then
		Run (RunIt)
	endIf
EndScript

Void Function FrameClearValues ()
let GlobalFrameTop = VALUE_NOT_READY
let GlobalFrameLeft = VALUE_NOT_READY
let GlobalFrameBottom = VALUE_NOT_READY
let GlobalFrameRight = VALUE_NOT_READY
let GlobalFrameParentTop = VALUE_NOT_READY
let GlobalFrameParentLeft = VALUE_NOT_READY
let GlobalFrameParentBottom = VALUE_NOT_READY
let GlobalFrameParentRight = VALUE_NOT_READY
EndFunction

void function CreateFrameOrPromptForRegion()
var
	int iChoice,
	int iTask,
	int nMode,
	int iHasPrompt,
	handle hMenu,
	string sMenuClass
let iHasPrompt=(GetFramePrompt()!=cscNull || BrailleGetFramePrompt()!=cscNull ||
	GetFrameTutorMessage()!=cscNull)
Let nMode = GlobalMenuMode
If nMode > 1 then
	Let hMenu = GetCurrentWindow ()
EndIf
If hMenu then
	Let sMenuClass = GetWindowClass (hMenu)
EndIf
if iHasPrompt then
	let iTask = FRAMEVIEW_ModifyPrompt
	let iChoice=dlgSelectItemInList(cModifyFrameOrPromptMenu,cCreateFrameOrPromptTitle,FALSE)
else
	let iTask = FRAMEVIEW_CreatePrompt
	let iChoice=dlgSelectItemInList(cCreateFrameOrPromptMenu,cCreateFrameOrPromptTitle,false)
endIf

if iChoice==1 then
	frameManagerRun(FRAMEVIEW_ShowActiveFrames|FRAMEVIEW_CreateFrame,nMode,hMenu,sMenuClass)
elif iChoice==2 then
	FrameManagerRun(iTask)
endIf
endFunction

Script FrameGetTopLeft ()
if (IsSameScript ()) then
	FrameSetOnWindow (GetCurrentWindow())
else
	;JAWSCursor ()
	let GlobalFrameLeft = getCursorCol ()
	let GlobalFrameTop = GetLineTop ()
	if (!GlobalFrameTop) then
		let GlobalFrameTop = getCursorRow()
	endIf
	SayFormattedMessage (ot_status, cmsg183_L, cmsg183_S) ; "Setting Frame top left corner "
endIf
SetParentDims()
if ((GlobalFrameBottom != VALUE_NOT_READY) && (GlobalFrameRight != VALUE_NOT_READY)) then
	CreateFrameOrPromptForRegion()
	; reset GlobalVariables
	FrameClearValues()
endIf
EndScript

Script FrameGetBottomRight ()
;JAWSCursor ()
let GlobalFrameRight = getCursorCol () + GetCharacterWidth ()
let GlobalFrameBottom = GetLineBottom ()+1;Fudge by 1 pixel to ensure accuracy
;  format Top Left Dimensions to a string
SayFormattedMessage (ot_status, cmsg184_L, cmsg184_S) ; "Setting Frame bottom right corner "
SetParentDims()
if ((GlobalFrameTop != VALUE_NOT_READY) && (GlobalFrameLeft != VALUE_NOT_READY)) then
	CreateFrameOrPromptForRegion()
	; reset GlobalVariables
	FrameClearValues()
endIf
EndScript

Void Function FrameSetOnObject ();Useful for SDM windows
var
	int iLeft, int iTop, int iRight, int iBottom
GetObjectRect (iLeft, iRight, iTop, iBottom)
let GlobalFrameTop = iTop
let GlobalFrameLeft = iLeft
let GlobalFrameBottom = iBottom
let GlobalFrameRight = iRight
EndFunction

Void Function FrameSetOnWindow (handle CurrentWindow)
if (!CurrentWindow) then
	let CurrentWindow = GetCurrentWindow()
endIf
;For SDM Dialogs
If StringContains (GetWindowClass (CurrentWindow),cWcSdmDlg) then
	FrameSetOnObject ()
	Return
EndIf
let GlobalFrameTop = GetWindowTop (CurrentWindow)
let GlobalFrameLeft = GetWindowLeft (CurrentWindow)
let GlobalFrameBottom = GetWindowBottom (CurrentWindow)
let GlobalFrameRight = GetWindowRight (CurrentWindow)
EndFunction

Void Function FrameManagerRun (int nAction, int nMode, handle hMenu, string sMenuClass)
var
	HANDLE hRealWindow,
	string sRealName,
	string sClass,
	string sPrompt,
	int nPeriod,
	int nLength
if (	(GlobalFrameTop == VALUE_NOT_READY) || 
(GlobalFrameLeft == VALUE_NOT_READY) || 
(GlobalFrameBottom == VALUE_NOT_READY) || 
(GlobalFrameRight == VALUE_NOT_READY)) then
	return
endIf
If nMode then
	Let hRealWindow = hMenu; Handle of Menu window
	let sClass = sMenuClass;Class of the menu
	Let sRealName = cScNull;Do not pass real window name in for menus
Else
	let hRealWindow = GetTopLevelWindow (GetCurrentWindow())
	let sClass = GetWindowClass(hRealWindow)
	let sRealName = GetWindowName(hRealWindow)
EndIf
let nLength = StringLength(sRealName)
; Make sure that the last character of the RealName does not end with a single slash.
; If it does, then add another slash to it.  One slash alone, combined with the
; end quote, will make an escape sequence.
if (StringRight(sRealName, 1) == "\\" && StringRight(sRealName, 2) != "\\\\") then
	let sRealName = sRealName + "\\"
endIf
; Prompt Code
if (nAction == FRAMEVIEW_CreatePrompt) then
	let sPrompt = GetWindowName(GetCurrentWindow())
else
	let sPrompt = cScNull
EndIf
PcCursor ()
FrameViewer(nAction,
GlobalFrameParentTop, GlobalFrameParentLeft, GlobalFrameParentBottom, GlobalFrameParentRight,
GlobalFrameTop, GlobalFrameLeft, GlobalFrameBottom, GlobalFrameRight,
sRealName, sClass, sPrompt)
EndFunction

Script CreatePrompt()
var
	int nIsWinValid,
	int iShouldClass,
	int iWinType,
	int iTask
	Let nIsWinValid = PromptValidator ()
;Kill if creating prompt is not appropriate
If ! nIsWinValid then
	SayFormattedMessage (OT_ERROR, cMsg376_L);"Cannot create prompt"
	Return
EndIf
let iShouldClass = FALSE
if (GetFrameNameAtCursor()) then
	let iTask = FRAMEVIEW_ModifyPrompt
else
	let iTask = FRAMEVIEW_CreatePrompt
endif

if (iTask == FRAMEVIEW_CreatePrompt) then
	Let iWinType = GetWindowSubTypeCode (GetCurrentWindow ())
	If ! iWinType then
		Let iShouldClass = ExMessageBox (cMsgPromptDlg,cMsgPromptDlgName,MB_YESNOCANCEL|MB_DEFBUTTON1|MB_ICONASTERISK)
		If iShouldClass == IDCANCEL then
			Return
		EndIf
	Else
		Let iShouldClass = FALSE
	EndIf
	If iShouldClass != IDYES then
		Let iShouldClass = FALSE
	EndIf
endif

If ! iShouldClass then
	FrameSetOnWindow (GetCurrentWindow())
	SetParentDims()
	FrameManagerRun(iTask,0,0,cScNull)
	; reset GlobalVariables
	FrameClearValues()
Else
	PerformScript WindowClassReassign ()
EndIf
EndScript

Function SetParentDims ()
var
HANDLE hRealWindow

let hRealWindow = GetTopLevelWindow (GetCurrentWindow ())
let GlobalFrameParentLeft = GetWindowLeft (hRealWindow)
let GlobalFrameParentTop = GetWindowTop (hRealWindow)
let GlobalFrameParentRight = GetWindowRight (hRealWindow)
let GlobalFrameParentBottom = GetWindowBottom (hRealWindow)
EndFunction

Script FrameManager ()
FrameSetOnWindow (GetCurrentWindow())
SetParentDims()
if ((GlobalFrameBottom != VALUE_NOT_READY) && (GlobalFrameRight != VALUE_NOT_READY)) then
	FrameManagerRun(FRAMEVIEW_ShowActiveFrames, GlobalMenuMode,0,cScNull)
	; reset GlobalVariables
	FrameClearValues()
endIf
EndScript

Script KeyboardManager ()
	var
		string TheApp,
		string Runit,
		HANDLE CurrentWindow
	let TheApp = GetActiveConfiguration ()
	;RunIt = "JKey.exe -a [Application]"  ;;; space required after "-a"
	let Runit = "\"" + GetJawsDirectory () + "\\" + MGR_KEYBRD + "\"" + "  " + "\"" + TheApp + "\""
	Run (Runit)
EndScript

Script ScriptManager ()
	var
		string TheApp,
		string Runit,
		HANDLE CurrentWindow
	let TheApp = GetActiveConfiguration ()
	;RunIt = "JScript.exe -a [Application]"  ;;; space required after "-a"
	let Runit = "\"" + GetJawsDirectory () + "\\" + MGR_SCRIPT + "\"" + "  " + FLAG_APP + "\"" + TheApp + "\""
	Run (Runit)
EndScript

Script  ScriptManagerDefault()
	var
		string RunIt
	let RunIt = "\"" + GetJawsDirectory () + "\\" + MGR_SCRIPT + "\" default.jss"
	Run(RunIt)
EndScript

Script RunJAWSManager ()
	var
		string sClass,
		string strForeground,
		string strBackground,
		string strBrlForeground,
		string strBrlBackground,
		string sApp,
		string RunIt,
		string managersList,
		int bModifyFrame,
		int nMenuMode,
		int index
	If BrailleRunManagerHelper () then
		Return
	EndIf
	Let nMenuMode = GlobalMenuMode
	If InHJDialog () then
		SayFormattedMessage (OT_error, cMSG337_L, cMSG337_S)
		return
	endIf
	if (GetFrameNameAtCursor()) then
		let bModifyFrame = TRUE;
	else	
		let bModifyFrame = FALSE;
	endif
	let managersList = ConfigManItem +
		WindowClassItem +
		DictionManItem +
		FrameManItem +
		KeyManItem +
		ScriptManItem+
		GraphicsLabelerItem +
		CustomHighlightAssignItem+
		BrailleAddColorsItem;
	If PromptValidator () == TRUE then
		if (bModifyFrame) then
			Let ManagersList = ManagersList + ModifyPromptItem;
		else	
			Let ManagersList = ManagersList + CreatePromptItem;
		EndIf	
	EndIf
	let sClass = GetWindowClass (GetCurrentWindow ())
	;let sApp = GetAppFileName ()
	Let sApp = GetActiveConfiguration ()
	let strForeground = ColorToRGBString(GetColorText())
	let strBackground = ColorToRGBString(GetColorBackground())
	;No matter what, Get it at Braille Cursor
	;As the Braille cursor can be anywhere.
	SaveCursor ()
	BrailleCursor ()
	Let strBrlForeground = ColorToRGBString(GetColorText())
	Let strBrlBackground = ColorToRGBString(GetColorBackground())
	RestoreCursor ()
	let index = DlgSelectItemInList (ManagersList, RunManagerDialogTitle, TRUE);
	If (Index == 0) then
		Return
	endIf
	if (index == 1) then
		PerformScript ConfigManager ();
	elif (index == 2) then
		;PerformScript WindowClassReassign ();
		let RunIt = "\"" + GetJawsDirectory () + "\\" + MGR_CONFIG + "\"" + " " + FLAG_APP + "\"" + sApp + "\" " + FLAG_CLASS + "\"" + sClass + "\"" + " " + FLAG_CLASS_MODE
		Run (RunIt)
	elif (index == 3) then
		PerformScript DictionaryManager ();
	elif (index == 4) then
		PerformScript FrameManager ();
	elif (index == 5) then
		PerformScript KeyboardManager ();
	elif (index == 6) then
		PerformScript ScriptManager ();
	elif (index == 7) then
		PerformScript GraphicsLabeler ();
	ElIf (Index == 8) then
		Delay (2)
		DoCustomHighlightColors (strForeground, strBackground, sApp)
	ElIf (Index == 9) then ;Braille
		Delay (2)
		AddBrailleColors (strBrlForeground, strBrlBackground, sApp)
	elif (index == 10) then
		; There was a problem with calling the CreatePrompt under this circumstance.  For some reason
		; CreatePrompt fails to identify the existing frame after the selection dialog is used.  Since
		; we already tested for an existing frame, just call the Frame Manager run with the modify frame
		; flag.
		if (bModifyFrame) then
			FrameSetOnWindow (GetCurrentWindow())
			SetParentDims()
			FrameManagerRun(FRAMEVIEW_ModifyPrompt,nMenuMode,0,cScNull)
			; reset GlobalVariables
			FrameClearValues()
		else
			PerformScript CreatePrompt ();
		endif		
	endIf
EndScript

; ***
; Window event functions
; ***
Void Function ForegroundWindowChangedEvent (handle newWindow)
EndFunction

Void Function WindowCreatedEvent (handle hWindow, int nLeft, int nTop, int nRight, int nBottom)
; It is best to override this function in application specific script files.
; Any code placed here will be processed very frequently.
CheckForMSNSignIns (hWindow)
EndFunction

Function WindowDestroyedEvent (handle hWindow)
If (WindowClosed == true) then
	SayFormattedMessage (OT_JAWS_MESSAGE, cmsg40_L, cmsg40_S)
	let WindowClosed = false
endIf
EndFunction

Function WindowMinMaxEvent (handle hWindow, int nMinMaxRest, int nShow)
EndFunction

Function WindowResizedEvent (handle hWindow, int nLeft, int nTop, int nRight, int nBottom)
EndFunction

;***
;	The following section contains scripts to control the JAWS verbosity
;***

string function VerbosityLevelToggle(int iRetCurVal)
Var
	int Verbosity
if not iRetCurVal then
; update it
	VerbosityLevel ()
endIf
let Verbosity = GetVerbosity ()
if Verbosity == 0 then
	return cmsg12_L
elif Verbosity == 1 then
	return cmsg13_L
elif Verbosity == 2 then
	return cmsg14_L
endIf
EndFunction

Script SetVerbosityLevel ()
SayFormattedMessage (OT_STATUS, VerbosityLevelToggle (FALSE))
EndScript

string function BrailleVerbosity (int iRetCurVal)
var
int iMode
let iMode=GetJcfOption (OPT_BRL_verbosity)
if not iRetCurVal then
	if iMode==2 then
	let iMode=0
	else
	let iMode=iMode+1
	endIf
	SetJcfOption (OPT_BRL_verbosity, iMode)
endIf
;now return the value
if  iMode==0 then
	return cmsg225_S ; "Braille Verbosity Beginner"
elif iMode==1 then
	return cmsg223_S ; "Braille Verbosity Intermediate"
elif iMode==2 then
	return cmsg224_S ; "Braille Verbosity Advanced"
endIf
EndFunction

Script SetBrailleVerbosity ()
var
	string sList
Let sList = cStrBrailleList
If IsVirtualPcCursor () then
	Let sList = sList+cStrTableBrailleList
EndIf
DlgSelectFunctionToRun (sList, cStrBrailleDlgName, false)
EndScript

string function ScreenEchoToggle (int iRetCurVal)
if not iRetCurVal then
; update it
	ScreenEcho()
endIf
if GetScreenEcho() == 0 then
	return cmsg15_L ;"none"
elif GetScreenEcho() == 1 then
	return cmsg16_L ;"highlighted"
elif GetScreenEcho() == 2 then
	return cmsg17_L ;"all"
endIf
EndFunction

Script SetScreenEcho ()
SayFormattedMessage (OT_STATUS, ScreenEchoToggle (FALSE))
EndScript

Script AnsiCharsDecrement ()
var
	int SpeakAnsiChars
let SpeakAnsiChars = GetJcfOption (OPT_SPEAK_ANSI_CHARS)
If (SpeakAnsiChars == 0) then
	If (SetJcfOption (OPT_SPEAK_ANSI_CHARS, 4 ) == WAS_SUCCESSFUL)  then
		SayFormattedMessage (ot_status, cmsg68_L, cmsg68_S) ;"All Ansi"
	Else ; WAS_NOT_SUCCESSFUL
		SayFormattedMessage (ot_status, cmsg69_L, cmsg69_S) ;"Was not able to set change the j c f option"
	endIf
Else
	If (SetJcfOption (OPT_SPEAK_ANSI_CHARS, SpeakAnsiChars - 1 ) == WAS_SUCCESSFUL)  then
		If (SpeakAnsiChars - 1) == 0 then
			SayFormattedMessage (ot_status, cmsg70_L, cmsg70_S) ;"No Ansi"
		endIf
		If (SpeakAnsiChars - 1) == 1 then
			SayFormattedMessage (ot_status, cmsg71_L, cmsg71_S) ;"Some Ansi"
		endIf
		If (SpeakAnsiChars - 1) == 2 then
			SayFormattedMessage (ot_status, cmsg72_L, cmsg72_S) ;"More Ansi"
		endIf
		If (SpeakAnsiChars - 1) == 3 then
			SayFormattedMessage (ot_status, cmsg73_L, cmsg73_S) ;"Most Ansi"
		endIf
	Else ; WAS_NOT_SUCCESSFUL
		SayFormattedMessage (ot_status, cmsg69_L) ;"Was not able to set change the j c f option"
	endIf
endIf ; SpeakAnsiChars == 0
EndScript

string function AnsiCharsIncrement (int iRetCurVal)
var
	int iSpeakAnsiChars
let iSpeakAnsiChars = GetJcfOption (OPT_SPEAK_ANSI_CHARS)
if not iRetCurVal then
;update it
	If iSpeakAnsiChars == 4 then
		let iSpeakANSIChars=0
	else
		let iSpeakANSIChars=iSpeakANSIChars+1
	endIf
	SetJcfOption (OPT_SPEAK_ANSI_CHARS, iSpeakAnsiChars)
endIf
;now return the value
If iSpeakAnsiChars == 0 then
	return cmsg70_L ;"No Ansi"
elIf iSpeakAnsiChars== 1 then
			return cmsg71_L ;"Some Ansi"
elIf iSpeakAnsiChars==2 then
			return cmsg72_L ;"More Ansi"
elIf iSpeakAnsiChars == 3 then
			return cmsg73_L ;"Most Ansi"
elIf iSpeakAnsiChars == 4 then
	return cmsg68_L ;"All Ansi"
endIf
EndFunction

Script SetAnsiCharsIncrement ()
SayFormattedMessage (OT_STATUS, AnsiCharsIncrement (FALSE))
EndScript


string Function SpellModeToggle (int iRetCurVal)
var
	int iOption
Let iOption = GetDefaultJcfOption (OPT_SPELL_PHONETIC)
If ! iRetCurVal then
	;Update it
	Let iOption = (! iOption)
EndIf
SetDefaultJcfOption (OPT_SPELL_PHONETIC, iOption)
If ! iOption then 
	Return cMsgSpellStandard
Else
	Return cMsgSpellPhonetic
EndIf
EndFunction

script SpellMode ()
;Pass FALSE to update.
SayMessage (OT_STATUS, SpellModeToggle (FALSE))
EndScript

string function TypingEcho (int iRetCurVal)
Var
	Int iEcho
let iEcho =GetJCFOption (opt_typing_Echo)
if not iRetCurVal then
; update it
	If (iEcho == 3) Then
		let iEcho=0
	Else
		let iEcho=iEcho+1
	endIf
	SetJcfOption (Opt_Typing_Echo, iEcho)
endIf
; now return the value
If (iEcho == 0) Then
	return cmsg81_L ;"None"
ElIf (iEcho == 1) Then
	return cmsg82_L ;"Keys"
ElIf (iEcho == 2) Then
	return cmsg83_L ;"Words"
ElIf (iEcho == 3) then
	return cmsg361_L ; "Both characters and words"
endIf
EndFunction

Script SetTypingEcho ()
SayFormattedMessage (OT_STATUS, TypingEcho(FALSE))
EndScript

string function GraphicsVerbosity (int iRetCurVal)
var
int iMode
let iMode= GetJCFOption (OPT_INCLUDE_GRAPHICS)
if not iRetCurVal then
; update it
	If iMode== 2 Then
		let iMode=0
	else
		let iMode=iMode+1
	endIf
	SetJcfOption (OPT_INCLUDE_GRAPHICS, iMode)
endIf
;now return the value
If iMode== 0 Then
	return cmsg226_L ; none
ElIf iMode== 1 Then
	return cMSG227_L ; "Labeled"
ElIf iMode==2 Then
	return cmsg228_L ;"All graphics"
endIf
EndFunction

Script SetGraphicsBerbosity ()
SayFormattedMessage (OT_STATUS, GraphicsVerbosity (FALSE))
EndScript

string Function SetTableTitleReading (int iRetCurVal)
if ! iRetCurVal then
	If GITblHeaders == TBL_HEADER_BOTH then
		Let GITblHeaders=OFF;
	Else
		Let GITblHeaders=GITblHeaders+1
	EndIf
EndIf
If GITblHeaders == OFF then
	Return cmsg66_S
ElIf GITblHeaders == TBL_HEADER_ROW then
	Return cmsgRowTitles
ElIf GITblHeaders == TBL_HEADER_COL then
	Return cMsgColumnTitles
Else;Both
	Return cMsgBothTitles
EndIf
EndFunction

void Function JawsVerbosityCore (string sCustomItems)
var
	String list,
	int i
if InHJDialog () then
	SayFormattedMessage (OT_error, cMSG337_L, cMSG337_S)
	return
endIf
if (IsSpeechOff ()) then
	SayFormattedMessage (OT_STATUS, MuteSynthesizerToggle(FALSE))
	return
endIf
Let list = sCustomItems  ; app-specific stuff from the caller
If (IsVirtualPCCursor ()) Then
	UpdateVirtualGlobals ()
	let list = list + cStrDefaultHtmlList
endIf
Let list = list + cStrDefaultList
; remove any leading delimiters
Let i=0 ; just make sure this seemingly unnecesary loop terminates
while ((SubString (list, 1, 1) == "|") && i < 5)  ; leading delimiter is present
	Let list = StringChopLeft (list, 1); Get rid of leading delimiter
	Let i = i+1
EndWhile
DlgSelectFunctionToRun (list, AdjustJawsVerbosityDialogName, false)
EndFunction

Script AdjustJAWSVerbosity ()
JawsVerbosityCore (cScNull)
EndScript

string function PunctuationToggle (int iRetCurVal)
var
int nPunctuationLevel

let nPunctuationLevel = GetJCFOption (opt_punctuation)
if not iRetCurVal then
; update it
	If (nPunctuationLevel == 3) then
		let nPunctuationLevel=0
	Else
		let nPunctuationLevel=nPunctuationLevel+1
	endIf
	SetJCFOption (opt_punctuation, nPunctuationLevel )
endIf      
; now return the value
If (nPunctuationLevel == 0) then
	return cmsg15_L
elIf (nPunctuationLevel == 1) then
	return cmsg278_L
ElIf (nPunctuationLevel == 2) then
	return cmsg279_L
Elif (nPunctuationLevel == 3) then
	return cmsg280_L
endIf
EndFunction

Function SayExtendedHelpHotKey ()
var
	string sMessageLong,
	string sMessageShort,
	string sAppName
let sAppName = GetWindowName (GetAppMainWindow (GetCurrentWindow ()))
let sMessageLong = FormatString (cmsg213_L, sAppName)
let sMessageShort = FormatString (cmsg213_S, sAppName)
SayFormattedMessage (OT_APP_START, sMessageLong, sMessageShort)
EndFunction

String Function GetCorrespondingHelpFile (string strApp)
var
	string strHelpFile,
	int nPeriod
let nPeriod = StringContains (strApp, ".")
let strApp = SubString (strApp, 1, nPeriod)
let strHelpFile = GetJawsHelpDirectory ()
let strHelpFile = strHelpFile + "\\"
let strHelpFile = strHelpFile + strApp
let strHelpFile = strHelpFile + "hlp"
return strHelpFile
EndFunction

Void Function AppFileTopic (int iTopic)
var
	string strHelpFile
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
let strHelpFile = "JFW"
If iTopic then
	ShowHelpByID (strHelpFile, iTopic)
Else
	SayFormattedMessage (ot_error, cmsg201_L, cmsg201_S); "There is no jaws specific help for this application "
	ShowHelpByID (strHelpFile, 0);Kill Virtual Buffer and close help window ...
endIf
EndFunction

Void Function AppWillNotSpeakEvent (string strApp)
var
	string sMessage
let sMessage = FormatString (cmsg202_L, strApp)
SayFormattedMessage (ot_jaws_message, sMessage)
EndFunction

string function MuteSynthesizerToggle(int iRetCurVal)
if not iRetCurVal then
; update it
	if (IsSpeechOff ()) then
		SpeechOn()
	else
		SpeechOff()
	endIf
endIf
if (IsSpeechOff ()) then
	return cmsg203_L ;mute on
else
	return cmsg204_L ;mute off
endIf
EndFunction

string function SayAllBy (int iRetCurVal)
var
	int iSayAllMode,
	int iLinePause
let iSayAllMode=getJCFOption(OPT_SAY_ALL_MODE)
let iLinePause=getJCFOption(OPT_LINE_PAUSES)
if not iRetCurVal then
	; update it	
	if iLinePause==1 then
		let iLinePause=0
	ElIf iSayAllMode==2 then
		let iSayAllMode=0
		let iLinePause=1
	else
		let iSayAllMode=iSayAllMode+1
	EndIf
	SetJcfOption(OPT_SAY_ALL_MODE, iSayAllMode)
	SetJcfOption(OPT_LINE_PAUSES, iLinePause)
EndIf
;now return the value
if iSayAllMode==0 then
	if iLinePause==1 then
		return cMSG248_S
	else 
		return cmsg364_S 
	EndIf
elif iSayAllMode==1 then
	return cMSG249_S
ElIf iSayAllMode==2 then
	return cMSG250_S
endIf
EndFunction

string function SayAllSayCaps (int iRetCurVal)
var
	int iSayAllSayCaps
let iSayAllSayCaps=getJCFOption(OPT_SAY_ALL_SAY_CAPS)
if not iRetCurVal then
	; update it	
	If iSayAllSayCaps==1 then
		let iSayAllSayCaps=0
	else
		let iSayAllSayCaps=1
	EndIf
	SetJcfOption(OPT_SAY_ALL_SAY_CAPS, iSayAllSayCaps)
EndIf
;now return the value
if iSayAllSayCaps==0 then
	return cmsg251_L
elif iSayAllSayCaps==1 then
	return cmsg252_L
endIf
EndFunction

Script ListTaskTrayIcons ()
var
	int iTetherOption, ; Turn off TetherJawsToPC
	int iVPCOption,;Turn off Virtual PC Cursor
	int  nItems,
	int nIdx,
	int nButton,
	string strTip,
	string GraphicList
let iTetherOption = GetDefaultJCFOption (OPT_TETHER_JAWS_TO_PC)
Let iVPCOption = GetJcfOption (OPT_VIRTUAL_PC_CURSOR)
SetDefaultJcfOption (OPT_TETHER_JAWS_TO_PC, 0) ; Turn it off, so as to keep the Tether Option from firing
SetJcfOption (OPT_VIRTUAL_PC_CURSOR, 0)
if (MagGetState () > 0) Then
	MagSendKeyEvent (KI_TRACK_MOUSE_TOGGLE)
	; MagSetTrackingObjects (MTO_MOUSE, 0)
endIf
let nItems = SysTrayGetItemCount()
let nIdx = 1
if InHJDialog () then
	SayFormattedMessage (OT_error, cMSG337_L, cMSG337_S)
	SetDefaultJcfOption (OPT_TETHER_JAWS_TO_PC, iTetherOption)
	SetJcfOption (OPT_VIRTUAL_PC_CURSOR, iVPCOption)
	return
endIf
while (nIdx <= nItems)
	Let strTip = SysTrayGetItemToolTip(nIdx)
	let GraphicList = graphicList + LIST_ITEM_SEPARATOR + strTip
	let nIdx = nIdx+1
EndWhile
let nButton =DlgSysTray(GraphicList,nIdx)
if  (nIdx > 0 && nButton > 7000) then
	SaveCursor()
	SysTrayMoveToItem(nIdx)
	if  (nButton == iD_RightSingleClick) then
		RightMouseButton()
	elif(nButton == iD_LeftSingleClick) then
		LeftMouseButton()
	elif(nButton == iD_LeftDoubleClick) then
		LeftMouseButton()
		LeftMouseButton()
	endIf
endIf
if (MagGetState () > 0) Then
	MagSendKeyEvent (KI_TRACK_MOUSE_TOGGLE)
;	MagSetTrackingObjects (MTO_MOUSE, MTO_MOUSE)
endIf
Pause ()
SetDefaultJcfOption (OPT_TETHER_JAWS_TO_PC, iTetherOption)
SetJcfOption (OPT_VIRTUAL_PC_CURSOR, iVPCOption)
EndScript

void Function SayTreeViewLevel ()
var
	string sMessage,
	int iLevel,
	string sLevel
If (GetTreeViewLevel() != PreviousTreeviewLevel) then
	let iLevel = GetTreeviewLevel()
	let sLevel = IntToString (iLevel)
	let sMessage = FormatString (cmsg233_L, sLevel)
	SayFormattedMessage (OT_jaws_message, sMessage, sLevel) ; "level "
	let PreviousTreeViewLevel= iLevel
endIf
If ! IsPcCursor () then
	SayLine ()
	Return
EndIf
SayFormattedMessage (OT_LINE, GetObjectValue ())
SayFormattedMessage (OT_POSITION, PositionInGroup ())
EndFunction

Void Function TooltipEvent (handle hWnd, string strText)
let strLastTooltip = strText
SayFormattedMessage (ot_tool_tip, strLastToolTip)
EndFunction

; Auto Graphics labeler section
globals
	int g_AutoLabeledGraphics

String Function GetGraphicNameAtPoint (int iX, int iY)
SaveCursor ()
JAWSCursor ()
MoveTo (iX + 1, iY - 1)
If (GetCharacterAttributes () & ATTRIB_GRAPHIC) Then
	return GetCharacter () ; Use GetWord () if this fails
Else
	return ""
endIf
EndFunction

Function AutoGraphicsLabelerHelper(int nLeft,int nTop,int nRight,int nBottom)
var
	Int iX,
	Int iY,
	int nGraphicIdNoMouseOnIt,
	int nGraphicIdWithMouseOnIt,
	int nLoops,
	int nAttributes,
	String strLabel,
	String strGraphicName,
	String strTemp
;SaveCursor();No longer needed.
InvisibleCursor()
let iX = nLeft+(nRight-nLeft)/2
let iY = nTop+(nBottom-nTop)/2
MoveTo (iX, iY)
let nGraphicIdNoMouseOnIt = GetGraphicID()
JawsCursor()
RouteJawsToInvisible()
let nLoops  = 0
while (nLoops < 15 && strLastTooltip == "")
	delay(1)
	let nLoops = nLoops+1
EndWhile
If (strLastTooltip != "") then
	let strLabel = strLastTooltip
	let nGraphicIdWithMouseOnIt = GetGraphicID()
	if (nGraphicIdWithMouseOnIt) then
		let nAttributes = GetControlAttributes()
			if (nAttributes & CTRL_GRAYED) then
				let strLabel = strLabel + cScSpace +cmsgGrayedGraphic1_L
			endIf
			if (nAttributes & CTRL_PRESSED) then
				let strLabel = strLabel + cScSpace +cmsgPressedGraphic1_L
			endIf
			SetGraphicLabel(nGraphicIdWithMouseOnIt, strLabel, TRUE)
			if (nGraphicIdWithMouseOnIt != nGraphicIdNoMouseOnIt &&
			nGraphicIdNoMouseOnIt != 0) then
				SetGraphicLabel(nGraphicIdNoMouseOnIt,strLabel, TRUE)
			endIf
			let g_AutoLabeledGraphics = g_AutoLabeledGraphics+1
		endIf
	endIf
;RestoreCursor() ; No longer needed.
let strLastTooltip = ""
Delay(2)
if (IsKeyWaiting ())  then
	return 0
else
	return 1
endIf
EndFunction

Script AutoLabelGraphics ()
var
	int bProcessTooltipEvent,
	int nIncludeGraphics,
	string sMessageLong,
	string sMessageShort,
	string sLabeled
;cmsg242_L = "Starting auto graphic labeler"
SayFormattedMessage (ot_status, cmsg242_L, cmsg242_S)
Delay(2)
Refresh() 
Delay(10)
SaveCursor()
JawsCursor()
MoveTo(1,1)
let strLastTooltip = cScNull
let bProcessTooltipEvent = GetJcfOption (OPT_PROCESSTOOLTIPEVENT)
let nIncludeGraphics = GetJcfOption(OPT_INCLUDE_GRAPHICS)
SetJcfOption (OPT_PROCESSTOOLTIPEVENT, TRUE)
SetJcfOption (OPT_INCLUDE_GRAPHICS, 2)
let g_AutoLabeledGraphics = 0
GraphicsEnumerate(GetAppMainWindow(GetFocus()),"AutoGraphicsLabelerHelper")
SetJcfOption (OPT_PROCESSTOOLTIPEVENT, bProcessTooltipEvent)
SetJcfOption (OPT_INCLUDE_GRAPHICS, nIncludeGraphics)
RestoreCursor()
;cmsg243_L = "Auto labeler finished"
let sLabeled = IntToString (g_AutoLabeledGraphics)
let sMessageShort = FormatString (cmsg243_S, sLabeled)
let sMessageLong = FormatString (cmsg243_L, sLabeled)
SayFormattedMessage (ot_status, sMessageLong, sMessageShort)
EndScript

globals
	int g_AutoLabeledGraphics,
	string g_strGraphicsList,
	string g_strGraphicsListX,
	string g_strGraphicsListY

Function GraphicsListHelper(int nLeft,int nTop,int nRight,int nBottom)
SaveCursor()
InvisibleCursor()
MoveTo (nLeft,nBottom-1)
if (GetControlAttributes() && CTRL_GRAYED) then
;skip this graphic
	return TRUE
endIf
let g_strGraphicsList = g_strGraphicsList+LIST_ITEM_SEPARATOR+GetWord()
let g_strGraphicsListX = g_strGraphicsListX + LIST_ITEM_SEPARATOR+
IntToString(getCursorRow())
let g_strGraphicsListY = g_strGraphicsListY + LIST_ITEM_SEPARATOR+
IntToString(getCursorCol())
RestoreCursor()
return 1
EndFunction

Script GraphicsList ()
var
	int nIncludeGraphics,
	int nIndex,
	int nRowToClick,
	int nColToClick
Refresh() 
Delay(10)SaveCursor()
let nIncludeGraphics = GetJcfOption(OPT_INCLUDE_GRAPHICS)
SetJcfOption (OPT_INCLUDE_GRAPHICS, 1) ; labeld graphics only
let g_strGraphicsList = ""
let g_strGraphicsListX = ""
let g_strGraphicsListY = ""
GraphicsEnumerate(GetAppMainWindow(GetFocus()),"GraphicsListHelper")
; remove leading delimiters
let g_strGraphicsList =stringChopLeft(g_strGraphicsList,1)
let g_strGraphicsListX = stringChopLeft(g_strGraphicsListX,1)
let g_strGraphicsListY =stringChopLeft(g_strGraphicsListY,1)
SetJcfOption (OPT_INCLUDE_GRAPHICS, nIncludeGraphics)
if  (g_strGraphicsList) then
	let nIndex = DlgSelectItemInList (g_strGraphicsList,cMsgSelectGraphic, FALSE);
	;SayInteger(nIndex)
	if (nIndex == 0) then
		return
	endIf
	let nRowToClick =
	StringToInt(StringSegment(g_strGraphicsListX,LIST_ITEM_SEPARATOR,nIndex))
	let nColToClick =
	StringToInt(StringSegment(g_strGraphicsListY,LIST_ITEM_SEPARATOR,nIndex))
	SaveCursor()
	JawsCursor()
	MoveTo(nColToClick,nRowToClick)
	Delay(10)
	LeftMouseButton()
	;SayInteger(nColToClick)
	;SayInteger(nRowToClick)
Else
	SayFormattedMessage (OT_ERROR, cmsgNoGraphics1_L, cmsgNoGraphics1_S)
endIf
EndScript

Script SayPriorSentence ()
PriorSentence ()
delay(1)
SaySentence ()
EndScript


Script SayNextSentence ()
NextSentence ()
delay(1)
SaySentence ()
EndScript

Script SaySentence ()
SaySentence ()
EndScript

Script SayPriorParagraph ()
PriorParagraph ()
If SayAllInProgress () then
	Return
EndIf
if ! SayParagraph() then
	SayFormattedMessage (OT_error, cMSG276_L)
	SayFormattedMessage (OT_error, cMSG277_L, cmsgSilent)
endIf
EndScript

Script SayParagraph ()
if ! SayParagraph() then
	SayFormattedMessage (OT_error, cMSG276_L)
	SayFormattedMessage (OT_error, cMSG277_L, cmsgSilent)
endIf
EndScript

Script SayNextParagraph ()
NextParagraph ()
If SayAllInProgress () then
	Return
EndIf
if ! SayParagraph() then
	SayFormattedMessage (OT_error, cMSG276_L)
	SayFormattedMessage (OT_error, cMSG277_L, cmsgSilent)
endIf
EndScript

Script ControlBackSpace ()
var
	string sText1,
	string sText2
If IsVirtualPcCursor () then
	If UserBufferIsActive () then
		Return; Do not process unless so directed in app-specific script file
	EndIf
EndIf
InvisibleCursor ()
RouteInvisibleToPc ()
PriorWord ()
let sText1=GetWord()
PcCursor ()
TypeCurrentScriptKey ()
Pause()
InvisibleCursor()
let sText2=StringDiff(sText1,GetWord())
if !sText2 then
	SayMessage(ot_line,sText1)
else
	SayMessage(ot_line,sText2)
EndIf
PCCursor()
EndScript

Script SaySystemTime ()
If (IsSameScript ()) then
	SayUsingVoice (	VCTX_MESSAGE, SysGetDate(), ot_no_disable)
	return 
endIf 
SayUsingVoice (	VCTX_MESSAGE, SysGetTime(), ot_no_disable)
EndScript

Script Enter ()
SayCurrentScriptKeyLabel ()
enterKey()
EndScript

Script ShiftEnter ()
SayCurrentScriptKeyLabel ()
ShiftEnterKey()
EndScript

script ControlEnter ()
PerformScript ControlEnter ()
EndScript

script MoveToFirstTable ()
PerformScript MoveToFirstTable ()
EndScript

script MoveToNextTable ()
PerformScript MoveToNextTable ()
EndScript

script MoveToPriorTable ()
PerformScript MoveToPriorTable ()
EndScript

script MoveToLastTable ()
PerformScript MoveToLastTable ()
EndScript

Script Tab ()
SayCurrentScriptKeyLabel ()
If UserBufferIsActive () then
	UserBufferDeActivate ()
EndIf
TabKey ()
If GetWindowSubtypeCode (GetCurrentWindow ()) == WT_ComboBox && IsVirtualPCCursor () Then
	Say (GetLine (),OT_control_name)
endIf
EndScript

Script ShiftTab ()
SayCurrentScriptKeyLabel ()
If UserBufferIsActive () then
	UserBufferDeActivate ()
EndIf
ShiftTabKey ()
If GetWindowSubtypeCode (GetCurrentWindow ()) == WT_ComboBox &&  IsVirtualPCCursor () Then
	Say (GetLine (),OT_control_name)
endIf
EndScript

Script MoveToNextNonLinkText ()
NextNonLink ()
if !SayAllInProgress() then
	delay(1)
	sayline()
endIf
EndScript

Script MoveToPriorNonLinkText ()
PriorNonLink ()
if !SayAllInProgress() then
	delay(1)
	sayline()
endIf
EndScript

Script VirtualPCCursorToggle ()
if IsSameScript () then
	SetDefaultJCFOption (OPT_VIRTUAL_PC_CURSOR, GetJCFOption (OPT_VIRTUAL_PC_CURSOR))
	if GetJCFOption (OPT_VIRTUAL_PC_CURSOR)==0 then
		Refresh()
		SayFormattedMessage (OT_status, cMSG338_L, cMSG338_S) ;"The virtual cursor will be turned off for all applications"
		return
	else SayFormattedMessage (OT_status, cMSG339_L, cMSG339_S) ;"The virtual cursor will be turned on for all applications"
		Return
	endIf
endIf
if GetJCFOption (OPT_VIRTUAL_PC_CURSOR)==0 then
	SetJCFOption (OPT_VIRTUAL_PC_CURSOR, 1)
	SayFormattedMessage (ot_status, cMSG291_L, cMSG291_S)
else
	refresh()
	SetJCFOption (OPT_VIRTUAL_PC_CURSOR, 0)
	SayFormattedMessage (ot_status, cmsg292_L, cmsg292_S)
endIf
EndScript

; Scripts for the HTML Options Dialog
string function HTMLIncludeGraphicsToggle (int iRetCurVal)
var
	int iGraphicsLevel
let iGraphicsLevel = GetJCFOption (optIncludeGraphics)
if not iRetCurVal then
;update it
	If iGraphicsLevel == 2 then
		let iGraphicsLevel=0
		Else
		let iGraphicsLevel=iGraphicsLevel+1
		endIf
	SetJCFOption (optIncludeGraphics, iGraphicsLevel)
endIf
;now return the value
if (iGraphicsLevel == 0) then
	return cmsg334_S
		      elIf (iGraphicsLevel == 1) then
	return cmsg335_S
ElIf (iGraphicsLevel == 2) then
	return cmsg336_S
endIf
EndFunction

string function HTMLIncludeLinksToggle (int iRetCurVal)
var
	int iLinksLevel
let iLinksLevel = GetJCFOption (optIncludeGraphicLinks)
if not iRetCurVal then
;update it
	If (iLinksLevel == 2) then
	let iLinksLevel=0
	Else
	let iLinksLevel=iLinksLevel+1
	endIf
	SetJCFOption (optIncludeGraphicLinks, iLinksLevel)
endIf
;now return the value
if (iLinksLevel == 0) then
	return cmsg295_S
elIf (iLinksLevel == 1) then
	return cmsg296_S
ElIf (iLinksLevel == 2) then
	return cmsg297_S
endIf
EndFunction

string function HTMLIncludeImageMapLinksToggle (int iRetCurVal)
var
	int iImageMapLevel

let iImageMapLevel = GetJCFOption (optIncludeImageMapLinks)
if not iRetCurVal then
;update it
	If (iImageMapLevel == 2) then
		let iImageMapLevel =0
	Else
		let iImageMapLevel =iImageMapLevel +1
	endIf
	SetJCFOption (optIncludeImageMapLinks, iImageMapLevel)
endIf
;now return the value
if (iImageMapLevel == 0) then
	return cmsg298_S
elIf (iImageMapLevel == 1) then
	return cmsg299_S
ElIf (iImageMapLevel == 2) then
	return cmsg300_S
endIf
EndFunction

string function HTMLIdentifyLinkTypeToggle (int iRetCurVal)
var
	int iAnnounceLinkType
let iAnnounceLinkType = GetJCFOption (optIdentifyLinkType)
if not iRetCurVal then
;update it
	let iAnnounceLinkType =not iAnnounceLinkType
	SetJCFOption (optIdentifyLinkType, iAnnounceLinkType)
endIf
;now return the value
If iAnnounceLinkType  then
	return cmsg301_S
	else
	return cmsg302_S
endIf
EndFunction

string function HTMLIdentifySamePageLinksToggle (int iRetCurVal)
var
	int iSamePage

let iSamePage = GetJCFOption (optIdentifySamePageLinks)
if not iRetCurVal then 
;update it
	let iSamePage=not iSamePage

	SetJCFOption (optIdentifySamePageLinks, iSamePage)
endIf
;now return the value
If iSamePage  then
	return cmsg303_S
Else
	return cmsg304_S
endIf
EndFunction

string Function HTMLIncrementMaxLineLength (int iRetCurVal)
Var
int iLineLength

let iLineLength = GetJCFOption (optMaxLineLength)
if not iRetCurVal then
;update it
	If iLineLength < 245 Then
		let iLineLength=iLineLength + 10
	Else
		let iLineLength = 10
	endIf
	SetJCFOption (optMaxLineLength, iLineLength)
endIf
;now return the value
return FormatString (cmsg305_S, intToString(iLineLength))
EndFunction

string function HTMLDecrementMaxLineLength (int iRetCurVal)
Var
int iLineLength

let iLineLength = GetJCFOption (optMaxLineLength)
if not iRetCurVal then
;update it
	If iLineLength > 11 Then
		let iLineLength = iLineLength - 10
	Else
		let iLineLength = 254
	endIf
	SetJCFOption (optMaxLineLength, iLineLength)
endIf
;now return the value
return FormatString (cmsg305_S, intToString(iLineLength))
EndFunction

string function HTMLIncrementMaxBlockLength (int iRetCurVal)
Var
int iBlockLength
let iBlockLength = GetJCFOption (optTextBlockLength)
if not iRetCurVal then
;update it
	If iBlockLength < 145 Then
		let iBlockLength = iBlockLength + 10
	Else
		let iBlockLength = 10
	endIf
	SetJCFOption (optTextBlockLength, iBlockLength)
endIf
;now return the value
return FormatString (cmsg306_S, intToString(iBlockLength))
EndFunction

string Function HTMLDecrementMaxBlockLength (int iRetCurVal)
Var
	int iBlockLength

let iBlockLength = GetJCFOption (optTextBlockLength)
if not iRetCurVal then
;update it
	If iBlockLength > 11 Then
		let iBlockLength = iBlockLength - 10
	Else
		let iBlockLength = 154
	endIf
	SetJCFOption (optTextBlockLength, iBlockLength)
endIf
;now return the value
return FormatString (cmsg306_S, intToString(iBlockLength))
EndFunction

string function HTMLFrameIndicationToggle (int iRetCurVal)
var
int iFrameIdentify
let iFrameIdentify = GetJCFOption (optFrameIndication)
if not iRetCurVal then
	if iFrameIdentify==2 then
	let iFrameIdentify=0
	else
	let iFrameIdentify=iFrameIdentify+1
	endIf
	SetJCFOption (optFrameIndication, iFrameIdentify)
endIf
;now return the value
if iFrameIdentify == 0 then
	return cmsg307_S
elIf iFrameIdentify == 1 then
	return cmsg308_S
ElIf iFrameIdentify == 2 then
	return cmsg309_S
endIf
EndFunction

string function HTMLScreenFollowsVCursorToggle (int iRetCurVal)
var
	int iScreenFollowsVCursor
let iScreenFollowsVCursor = GetJCFOption (optScreenFollowsVCursor)
if not iRetCurVal then 
;update it
	let iScreenFollowsVCursor =not iScreenFollowsVCursor
	SetJCFOption (optScreenFollowsVCursor, iScreenFollowsVCursor)
endIf
;now return the value
If iScreenFollowsVCursor  then
	return cmsg310_S
else
	return cmsg311_S
endIf
EndFunction

string function HTMLSkipPastRepeatedTextToggle (int iRetCurVal)
var
int iSkipRepeatedText
let iSkipRepeatedText = GetJCFOption (optSkipPastRpeatedText)
if not iRetCurVal then
;update it
	let iSkipRepeatedText =not iSkipRepeatedText 
	SetJCFOption (optSkipPastRpeatedText, iSkipRepeatedText )
endIf
 ;now return the value
If iSkipRepeatedtext then
	return cmsg312_S
Else
	return cmsg313_S
endIf
EndFunction

string function HTMLTextLinkVerbosityToggle (int iRetCurVal)
var
int iLinkVerbosity
let iLinkVerbosity  = GetJCFOption (optLinkText)
if not iRetCurVal then
;update it
	If iLinkVerbosity == 4 then
		let iLinkVerbosity=0
	else
		let iLinkVerbosity=iLinkVerbosity+1
	endIf
	SetJCFOption (optLinkText, iLinkVerbosity)
endIf
;now return the value
if iLinkVerbosity == 0 then
	return cmsg328_S
elIf iLinkVerbosity == 1 then
	return cmsg329_S
ElIf iLinkVerbosity == 2 then
	return cmsg330_L
ElIf iLinkVerbosity == 3 then
	return cmsg330_S
ElIf iLinkVerbosity == 4 then
	Return cmsgCustomSearch;
endIf
EndFunction

string function HTMLButtonTextVerbosityToggle (int iRetCurVal)
var
int iButtonText
let iButtonText= GetJCFOption (optButtonText)
if not iRetCurVal then
;update it
	If iButtonText== 4 then
		let iButtonText=0
	else
		let iButtonText=iButtonText+1
	endIf
	SetJCFOption (optButtonText, iButtonText)
endIf
;now return the value
if iButtonText == 0 then
	return cmsg328_S
elIf iButtonText == 1 then
	return cmsg329_S
ElIf iButtonText == 2 then
	return cmsg328_L
ElIf iButtonText == 3 then
	return cmsgButtonValue_L
ElIf iButtonText == 4 then
	Return cmsg330_S;
endIf
EndFunction

string function HTMLGraphicReadingVerbosityToggle (int iRetCurVal)
var
int iVerbosity
let iVerbosity  = GetJCFOption (optGraphicRendering)
if not iRetCurVal then
;update it
	If iVerbosity == 4 then
		let iVerbosity=0
	else
		let iVerbosity=iVerbosity+1
	endIf
	SetJCFOption (optGraphicRendering, iVerbosity)
endIf
;now return the value
if iVerbosity == 0 then
	return cmsg328_S
elIf iVerbosity == 1 then
	return cmsg328_L
ElIf iVerbosity == 2 then
	return cmsg330_L
ElIf iVerbosity == 3 then
	return cmsg330_S
ElIf iVerbosity == 4 then
	Return cmsgCustomSearch;
endIf
EndFunction

string function HTMLIncrementLinesPerPageItem (int iRetCurVal)
Var
int iPageLength

let	 iPageLength = GetJCFOption (optLinesPerPage)
if not iRetCurVal then
;update it
	If (iPageLength < 145) Then
		let iPageLength = iPageLength + 10
	Else
		let iPageLength = 10
	endIf
	SetJCFOption (optLinesPerPage, iPageLength)
endIf
;now return the value
return FormatString (cmsg331_S, intToString(iPageLength))
EndFunction

string function HTMLDecrementLinesPerPageItem (int iRetCurVal)
Var
int iPageLength

let iPageLength = GetJCFOption (optLinesPerPage)
if not iRetCurVal then
;update it
	If (iPageLength > 11) Then
		let iPageLength = iPageLength - 10
	Else
		let iPageLength = 155
	endIf
	SetJCFOption (optLinesPerPage, iPageLength)
endIf
;now return the value
return FormatString (cmsg331_S, intToString(iPageLength))
EndFunction

string function HTMLIndicateTablesToggle(int iRetCurVal)
var
int iIndicateTables
let iIndicateTables = GetJCFOption (optTableIndication)
if not iRetCurVal then
;update it
let iIndicateTables=not iIndicateTables
	SetJCFOption (optTableIndication, iIndicateTables)
endIf
;now return the value
If iIndicateTables  then
	return cmsg332_S
Else
	return cmsg333_S
endIf
EndFunction

string function HTMLDetectTables (int iRetCurVal)
var
	int iTables
Let iTables = GetJCFOption (optTableDetection)
If ! iRetCurVal then
	;Update it
	Let iTables = (! iTables)
EndIf
SetJcfOption (optTableDetection, iTables)
If iTables then
	Return cmsg333_L
Else
	Return cmsg332_L
EndIf
EndFunction

string function HTMLIndicateHeadingsToggle(int iRetCurVal)
var
int iIndicateHeadings
let iIndicateHeadings= GetJCFOption (optHeadingIndication)
if not iRetCurVal then
;update it
	if (iIndicateHeadings==2) then
		let iIndicateHeadings=0
	else
		let iIndicateHeadings=iIndicateHeadings+1
	endIf
	SetJCFOption (optHeadingIndication, iIndicateHeadings)
endIf
;now return the value
If iIndicateHeadings==0 then
	return cmsgHeadings0
Elif iIndicateHeadings==1 then
	return cmsgHeadings1
Elif iIndicateHeadings==2 then 
	return cmsgHeadings2
endIf
EndFunction

string function HTMLIndicateBlockQuotes (int iRetCurVal)
var
	int iOption
Let iOption = GetJcfOption (optBlockQuoteIndication)
If ! iRetCurVal then
	;Update it
	Let iOption = (! iOption)
EndIf
SetJcfOption (optBlockQuoteIndication,iOption)
If iOption then
	Return cmsg332_S
Else
	Return cmsg333_S
EndIf
EndFunction

string function HTMLIndicateLists (int iRetCurVal)
var
	int iOption
Let iOption = GetJcfOption (optListIndication)
If ! iRetCurVal then
	;Update it
	Let iOption = (! iOption)
EndIf
SetJcfOption (optListIndication,iOption)
If iOption then
	Return cmsg332_S
Else
	Return cmsg333_S
EndIf
EndFunction

string function HTMLIndicateElementAccessKeys (int iRetCurVal)
var
	int iOption
Let iOption = GetJcfOption (optElementAccessKeys)
If ! iRetCurVal then
	;Update it
	Let iOption = (! iOption)
EndIf
SetJcfOption (optElementAccessKeys,iOption)
If iOption then
	Return cmsg332_S
Else
	Return cmsg333_S
EndIf
EndFunction

string function HTMLToggleIgnoreInlineFrames(int iRetCurVal)
var
	int iOption
Let iOption = GetJcfOption (optIgnoreInlineFrames)
If ! iRetCurVal then
	;Update it
	Let iOption = (! iOption)
EndIf
SetJcfOption (optIgnoreInlineFrames,iOption)
If iOption then
	Return cmsg332_S
Else
	Return cmsg333_S
EndIf
EndFunction

Script AdjustHTMLSettings ()
var
	string list
if InHJDialog () then
	SayFormattedMessage (OT_error, cMSG337_L, cMSG337_S)
	return
endIf
if (IsSpeechOff ()) then
	MuteSynthesizer()
	return
endIf
let list = GraphicsToggleItem + 
	LinksToggleItem + 
	ImageMapToggleItem + 
	LinkTypeToggleItem + 
	SamePageLinkToggleItem + 
	IncrementMaxLineLengthItem + 
	DecrementMaxLineLengthItem + 
	IncrementMaxBlockLengthItem +
	DecrementMaxBlockLengthItem +
	FrameIndicationToggleItem +
	ScreenFollowsVCursorToggleItem +
	SkipPastRepeatedTextToggleItem +
	TextLinksVerbosityItem +
	IncrementLinesPerPageItem + 
	DecrementLinesPerPageItem+
	IndicateHeadingsItem 
DlgSelectFunctionToRun (list, HTMLOptionsDialogName, false)
EndScript

Script SayCell ()
var
	Int row,
	int col,
	string sColHeader,
	string sRowHeader,
	string sMessage
GetCellCoordinates (col, row)
If col == 0 ||
Row == 0 then
	SayFormattedMessage (OT_error, cMSG314_L, cMSG314_S) ; Not in a Table
	Return;
EndIf
let sMessage = FormatString (cMSG320_L, IntToString (Row), IntToString (Col))
SayUsingVoice (VCTX_message,sMessage, ot_no_disable)
If Col <= 1 then
	Let sRowHeader = cScNull;
Else
	Let sRowHeader = GetRowHeader ()
EndIf
If Row <= 1 then
	Let sColHeader = cScNull
Else
	Let sColHeader= GetColumnHeader ()
EndIf
let sMessage = FormatString (cMSG321_L, sRowHeader, sColHeader)
SayFormattedMessage (ot_no_disable, sMessage)
SayCell()
EndScript

Script SayNextRow ()
var
	int iPrevNumOfCols,
	int iNumOfCols,
	string sColMessage
;Virtual Cursor only
If ! IsVirtualPcCursor () then
	SayCurrentScriptKeyLabel ()
	TypeCurrentScriptKey ()
	Return
EndIf
If ! InTable () then
	SayFormattedMessage (OT_error, cMSG314_L, cMSG314_S) ; Not in a table
	Return;
EndIf
Let iPrevNumOfCols = GetCurrentRowColumnCount ()
If ! DownCell () then
	SayFormattedMessage (OT_ERROR, cMsgLastRow_L, cMsgLastRow_S)
	Return
EndIf
If ! SayAllInProgress () then
	Let iNumOfCols = GetCurrentRowColumnCount ()
	If iNumOfCols != iPrevNumOfCols then
		If iNumOfCols != 1 then
			Let sColMessage = FormatString (cMsgTableColumnsChanged, IntToString (iNumOfCols))
		Else
			Let sColMessage = FormatString (cMsgTableColumnChanged, IntToString (iNumOfCols))
		EndIf
		SayUsingVoice (VCTX_MESSAGE, sColMessage, OT_JAWS_MESSAGE)
EndIf
	PerformScript ReadCurrentRow ()
Else;In SayAll
	StartOfRow ()
EndIf
EndScript

Script SayPriorRow ()
var
	int iPrevNumOfCols,
	int iNumOfCols,
	string sColMessage
;Virtual Cursor only
If ! IsVirtualPcCursor () then
	SayCurrentScriptKeyLabel ()
	TypeCurrentScriptKey ()
	Return
EndIf
If ! InTable () then
	SayFormattedMessage (OT_error, cMSG314_L, cMSG314_S) ; Not in a table
	Return;
EndIf
Let iPrevNumOfCols = GetCurrentRowColumnCount ()
If ! UpCell () then
	SayFormattedMessage (OT_ERROR, cMsgFirstRow_L, cMsgFirstRow_S)
	Return
EndIf
If ! SayAllInProgress () then
	Let iNumOfCols = GetCurrentRowColumnCount ()
	If iNumOfCols != iPrevNumOfCols then
		If iNumOfCols != 1 then
			Let sColMessage = FormatString (cMsgTableColumnsChanged, IntToString (iNumOfCols))
		Else
			Let sColMessage = FormatString (cMsgTableColumnChanged, IntToString (iNumOfCols))
		EndIf
		SayUsingVoice (VCTX_MESSAGE, sColMessage, OT_JAWS_MESSAGE)
	EndIf
	PerformScript ReadCurrentRow ()
Else;In SayAll
	StartOfRow ()
EndIf
EndScript

Script NextCell ()
var
	Int row,
	int col,
	string sMessage
if NextCell() then 
	GetCellCoordinates (col, row)
	If Row > 1 &&
	(GITblHeaders == TBL_HEADER_BOTH ||
	GITblHeaders == TBL_HEADER_COL) then
		SayUsingVoice (VCTX_MESSAGE,GetColumnHeader(),OT_NO_DISABLE)
	EndIf
	SayCell()
	let sMessage = FormatString (cmsg322_L, IntToString (Col))
	SayUsingVoice (VCTX_message, sMessage, ot_jaws_message)
ElIf InTable () then
	SayUsingVoice (VCTX_message, cMSG327_L, OT_jaws_message)
	SayCell()
else
	SayFormattedMessage (OT_error, cMSG314_L, cMSG314_S) ; Not in a table
endIf 
EndScript

script MoveToEndOfRow ()
If ! InTable () then
	SayFormattedMessage (OT_ERROR, cMSG314_L);Not in table
	Return;
EndIf
If EndOfRow () then
	SayUsingVoice (VCTX_message, cMSG327_L, OT_jaws_message);End of row
	SayCell()
else
	SayUsingVoice (VCTX_message, cMsgEndOfRowFailed, OT_jaws_message)
endIf 
EndScript

Script PriorCell ()
var
	Int row,
	int col,
	string sMessage
if PriorCell() then
	GetCellCoordinates (col, row)
	If Row > 1 &&
	(GITblHeaders == TBL_HEADER_BOTH ||
	GITblHeaders == TBL_HEADER_COL) then
		SayUsingVoice (VCTX_MESSAGE,GetColumnHeader(),OT_NO_DISABLE)
	EndIf
	SayCell()
	let sMessage = FormatString (cmsg322_L, IntToString (Col))
	SayUsingVoice (VCTX_message, sMessage, ot_jaws_message)
ElIf InTable () then
	SayUsingVoice (VCTX_message, cMSG326_L, OT_jaws_message)
	SayCell()
else
	SayFormattedMessage (OT_error, cMSG314_L, cMSG314_S) ; Not in a table
endIf 
EndScript

script MoveToStartOfRow ()
If ! InTable () then
	SayFormattedMessage (OT_ERROR, cMSG314_L, cMSG314_S)
	Return;
EndIf
If StartOfRow () then
	SayUsingVoice (VCTX_message, cMSG326_L, OT_jaws_message)
	SayCell()
else
	SayUsingVoice (VCTX_message, cMsgStartOfRowFailed, OT_jaws_message)
endIf 
EndScript

Script UpCell ()
var
	Int row,
	int col,
	int iPrevNumOfCols,
	int iNumOfCols,
	string sColMessage,
	string sMessage
Let iPrevNumOfCols = GetCurrentRowColumnCount ()
if UpCell() then
	Let iNumOfCols = GetCurrentRowColumnCount ()
	If iNumOfCols != iPrevNumOfCols then
		If iNumOfCols != 1 then
			Let sColMessage = FormatString (cMsgTableColumnsChanged, IntToString (iNumOfCols))
		Else
			Let sColMessage = FormatString (cMsgTableColumnChanged, IntToString (iNumOfCols))
		EndIf
		SayUsingVoice (VCTX_MESSAGE, sColMessage, OT_JAWS_MESSAGE)
	EndIf
	GetCellCoordinates (col, row)
	If Col> 1 &&
	(GITblHeaders == TBL_HEADER_BOTH ||
	GITblHeaders == TBL_HEADER_ROW) then
		SayUsingVoice (VCTX_MESSAGE,GetRowHeader(),OT_NO_DISABLE)
	EndIf
	SayCell()
	let sMessage = FormatString (cmsg323_L, IntToString (Row))
	SayUsingVoice (VCTX_message, sMessage, ot_jaws_message)
ElIf InTable () then
	SayUsingVoice (VCTX_message, cMSG324_L, OT_jaws_message)
	SayCell()
else
	SayFormattedMessage (OT_error, cMSG314_L, cMSG314_S) ; Not in a table
endIf 
EndScript

script MoveToTopOfColumn ()
var
	int iPrevNumOfCols,
	int iNumOfCols,
	string sColMessage
If ! InTable () then
	SayFormattedMessage (OT_error, cMSG314_L, cMSG314_S) ; Not in a table
	Return
EndIf
Let iPrevNumOfCols = GetCurrentRowColumnCount ()
If TopOfColumn () then
	Let iNumOfCols = GetCurrentRowColumnCount ()
	If iNumOfCols != iPrevNumOfCols then
		If iNumOfCols != 1 then
			Let sColMessage = FormatString (cMsgTableColumnsChanged, IntToString (iNumOfCols))
		Else
			Let sColMessage = FormatString (cMsgTableColumnChanged, IntToString (iNumOfCols))
		EndIf
		SayUsingVoice (VCTX_MESSAGE, sColMessage, OT_jaws_MESSAGE)
	EndIf
	SayUsingVoice (VCTX_message, cMSG324_L, OT_jaws_message); Top Of Column
	SayCell()
else
	SayFormattedMessage (OT_error, cMsgTopOfColumnFailed, cMSG314_S) ; Not in a table
endIf 
EndScript

Script DownCell ()
var
	Int row,
	int col,
	int iPrevNumOfCols,
	int iNumOfCols,
	string sColMessage,
	string sMessage
Let iPrevNumOfCols = GetCurrentRowColumnCount ()
if DownCell() then
	Let iNumOfCols = GetCurrentRowColumnCount ()
	If iNumOfCols != iPrevNumOfCols then
		If iNumOfCols != 1 then
			Let sColMessage = FormatString (cMsgTableColumnsChanged, IntToString (iNumOfCols))
		Else
			Let sColMessage = FormatString (cMsgTableColumnChanged, IntToString (iNumOfCols))
		EndIf
		SayUsingVoice (VCTX_MESSAGE, sColMessage, OT_JAWS_MESSAGE)
	EndIf
	GetCellCoordinates (col, row)
	If Col > 1 &&
	(GITblHeaders == TBL_HEADER_BOTH ||
	GITblHeaders == TBL_HEADER_ROW) then
		SayUsingVoice (VCTX_MESSAGE,GetRowHeader(),OT_NO_DISABLE)
	EndIf
	SayCell()
	let sMessage = FormatString (cmsg323_L, IntToString (Row))
	SayUsingVoice (VCTX_message, sMessage, ot_jaws_message)
ElIf InTable () then
	SayUsingVoice (VCTX_message, cMSG325_L, OT_jaws_message)
	SayCell()
else
	SayFormattedMessage (OT_error, cMSG314_L, cMSG314_S) ; Not in a table
endIf 
EndScript

script MoveToBottomOfColumn ()
var
	int iPrevNumOfCols,
	int iNumOfCols,
	string sColMessage
If ! InTable () then
	SayFormattedMessage (OT_error, cMSG314_L, cMSG314_S) ; Not in a form
	Return;
EndIf
Let iPrevNumOfCols = GetCurrentRowColumnCount ()
If BottomOfColumn () then
	Let iNumOfCols = GetCurrentRowColumnCount ()
	If iNumOfCols != iPrevNumOfCols then
		If iNumOfCols != 1 then
			Let sColMessage = FormatString (cMsgTableColumnsChanged, IntToString (iNumOfCols))
		Else
			Let sColMessage = FormatString (cMsgTableColumnChanged, IntToString (iNumOfCols))
		EndIf
		SayUsingVoice (VCTX_MESSAGE, sColMessage, OT_jaws_MESSAGE)
	EndIf
	SayUsingVoice (VCTX_message, cMSG325_L, OT_jaws_message); Bottom of column
	SayCell()
else
	SayFormattedMessage (OT_error, cMsgBottomOfColumnFailed, cMSG314_S) ; Not in a table
endIf 
EndScript

Script FirstCellInTable ()
var
	Int row,
	int col,
	int iPrevNumOfCols,
	int iNumOfCols,
	string sColMessage,
	string sMessage
SayCurrentScriptKeyLabel ()
Let iPrevNumOfCols = GetCurrentRowColumnCount ()
FirstCell ()
GetCellCoordinates (col, row)
If Row == 0 || Col == 0 then
	SayFormattedMessage (OT_ERROR, cMSG314_L, cMSG314_S); "Not in a table"
	Return
endIf
Let iNumOfCols = GetCurrentRowColumnCount ()
If iNumOfCols != iPrevNumOfCols then
	If iNumOfCols != 1 then
		Let sColMessage = FormatString (cMsgTableColumnsChanged, IntToString (iNumOfCols))
	Else
		Let sColMessage = FormatString (cMsgTableColumnChanged, IntToString (iNumOfCols))
	EndIf
	SayUsingVoice (VCTX_MESSAGE, sColMessage, OT_jaws_MESSAGE)
EndIf
SayCell ()
let sMessage = FormatString (cMSG320_L, IntToString (Row), IntToString (Col))
SayUsingVoice (VCTX_message,sMessage, ot_position)
let sMessage = FormatString (cMSG321_L, GetRowHeader (), GetColumnHeader ())
SayFormattedMessage (ot_position, sMessage)
EndScript

Script LastCellInTable ()
var
	Int row,
	int col,
	int iPrevNumOfCols,
	int iNumOfCols,
	string sColMessage,
	string sMessage
SayCurrentScriptKeyLabel ()
Let iPrevNumOfCols = GetCurrentRowColumnCount ()
lastCell ()
Let iNumOfCols = GetCurrentRowColumnCount ()
If iNumOfCols != iPrevNumOfCols then
	If iNumOfCols != 1 then
		Let sColMessage = FormatString (cMsgTableColumnsChanged, IntToString (iNumOfCols))
	Else
		Let sColMessage = FormatString (cMsgTableColumnChanged, IntToString (iNumOfCols))
	EndIf
	SayUsingVoice (VCTX_MESSAGE, sColMessage, OT_jaws_MESSAGE)
EndIf
GetCellCoordinates (col, row)
If Row == 0 || Col == 0 then
	SayFormattedMessage (OT_ERROR, cMSG314_L, cMSG314_S); "Not in a table"
	Return
endIf
SayCell ()
let sMessage = FormatString (cMSG320_L, IntToString (Row), IntToString (Col))
SayUsingVoice (VCTX_message,sMessage, ot_position)
let sMessage = FormatString (cMSG321_L, GetRowHeader (), GetColumnHeader ())
SayFormattedMessage (ot_position, sMessage)
EndScript

Script RestrictCurrentCursor ()
var
	int nCurrent
if (IsPCCursor()) then
	SayFormattedMessage (ot_error, cmsgRestrict1_L, cmsgRestrict1_S)
	return
endIf
let nCurrent = getRestriction()
if (nCurrent == RestrictNone) then
	let nCurrent = RestrictAppWindow
elif (nCurrent == RestrictAppWindow) then
	let nCurrent = RestrictWindow
elif (nCurrent == RestrictWindow)  then
	Let nCurrent = RestrictRect
ElIf (nCurrent == RestrictRect) then
	let nCurrent = RestrictNone
endIf
SetRestriction(nCurrent)
Say(GetRestrictionName(nCurrent),ot_status)
EndScript

Script RestrictBrailleCursor ()
var
	int nCurrent
let nCurrent = GetBrailleRestriction()
if (nCurrent == RestrictNone) then
	let nCurrent = RestrictAppWindow
elif (nCurrent == RestrictAppWindow) then
	let nCurrent = RestrictWindow
elif (nCurrent == RestrictWindow)  then
	Let nCurrent = RestrictRect
ElIf (nCurrent == RestrictRect) then
	let nCurrent = RestrictNone
endIf
SetBrailleRestriction (nCurrent)
SayFormattedMessage (OT_STATUS, cmsgBraille1_L, cmsgBraille1_S); "Braille Cursor"
Say(GetRestrictionName(nCurrent),ot_status)
EndScript

Int Function IsHJTrackEngine ()
Var
	Int bSpeechInUse,
	Int bBrailleInUse,
	Handle hwndMAGicUI
let hwndMAGicUI = FindTopLevelWindow ("JFWUI60", "")
if (hwndMAGicUI == 0) Then
	return 0
Else
	let bSpeechInUse = SpeechInUse ()
	let bBrailleInUse = BrailleInUse ()
	If (bSpeechInUse == FALSE && bBrailleInUse == FALSE) Then
		return 1
	endIf
endIf
return 0
EndFunction

Void Function ResetVoiceSettings ()
if globalVoiceChanges then
	if globalVoiceChanges & V_RATE then
		SetAllVoicesToGlobals (V_RATE)
	endIf
	if globalVoiceChanges & V_VOLUME then
		SetAllVoicesToGlobals (V_VOLUME)
	endIf
	if globalVoiceChanges & V_Pitch then
		SetAllVoicesToGlobals (V_PITCH)
	endIf
	;NullAllGlobalSettings ()
	let globalVoiceChanges = 0
	let globalVoiceName = ""
endIf
EndFunction

Void Function SetVoiceGlobalSettings (int iSetting, string ContextName, int CurrentSetting)
If GlobalVoiceName == "" then
	let GlobalVoiceChanges = true
	let GlobalVoiceName = ContextName
	If iSetting == V_RATE then
		If ! (GlobalVoiceChanges & V_RATE) then
			let globalVoiceChanges = (globalVoiceChanges | V_RATE)
			InitializeGlobalVoiceSettings (V_RATE)
			Return
		endIf
	ElIf iSetting == V_VOLUME then
		If ! (GlobalVoiceChanges & V_VOLUME) then
			let globalVoiceChanges = globalVoiceChanges | V_VOLUME
			InitializeGlobalVoiceSettings (V_VOLUME)
			Return
		endIf
	ElIf iSetting == V_PITCH then
		If ! (GlobalVoiceChanges & V_PITCH) then
			let globalVoiceChanges = globalVoiceChanges | V_PITCH
			InitializeGlobalVoiceSettings (V_PITCH)
			Return
		endIf
	endIf
endIf
EndFunction

Int Function GetSettingInformation (int Setting, string ContextName, 
	Int ByRef MinSetting, Int ByRef MaxSetting)
; Helper function to grab current voice parameter setting
var
	int Information
If Setting == V_RATE then
	let Information = GetVoiceRate (ContextName)
	GetSynthRateRange (MinSetting, MaxSetting)
ElIf Setting == V_Volume then
	let Information = GetVoiceVolume (ContextName)
	GetVoiceVolumeRange (MinSetting, MaxSetting)
ElIf Setting == V_Pitch then
	let Information = GetVoicePitch (ContextName)
	GetSynthPitchRange (MinSetting, MaxSetting)
endIf
;If GlobalVoiceName == "" then
If ! GlobalVoiceChanges then
	SetVoiceGlobalSettings (Setting, ContextName, Information)
endIf
Return Information
EndFunction

Void Function NullAllGlobalSettings (int iParamToSet)
If iParamToSet == V_RATE then
	let GlobalPcRate = 0
	let GlobalJawsRate = 0
	let GlobalKeyboardRate = 0
	let GlobalMessageRate = 0
ElIf iParamToSet == V_VOLUME then
	let GlobalPcVolume = 0
	let GlobalJawsVolume = 0
	let GlobalKeyboardVolume = 0
	let GlobalMessageVolume = 0
ElIf iParamToSet == V_PITCH then
	let GlobalPcPitch = 0
	let GlobalJawsPitch = 0
	let GlobalKeyboardPitch = 0
	let GlobalMessagePitch = 0
endIf
EndFunction

Void Function InitializeGlobalVoiceSettings (int iParamToSet)
If iParamToSet == V_RATE then
	let GlobalPcRate = GetVoiceRate (VCTX_PCCURSOR)
	let GlobalJawsRate = GetVoiceRate (VCTX_JAWSCURSOR)
	let GlobalKeyboardRate = GetVoiceRate (VCTX_KEYBOARD)
	let GlobalMessageRate = GetVoiceRate (VCTX_MESSAGE)
ElIf iParamToSet == V_VOLUME then
	let GlobalPcVolume = GetVoiceVolume (VCTX_PCCURSOR)
	let GlobalJawsVolume = GetVoiceVolume (VCTX_JAWSCURSOR)
	let GlobalKeyboardVolume = GetVoiceVolume (VCTX_KEYBOARD)
	let GlobalMessageVolume = GetVoiceVolume (VCTX_MESSAGE)
ElIf iParamToSet == V_PITCH then
	let GlobalPcPitch = GetVoicePitch (VCTX_PCCURSOR)
	let GlobalJawsPitch = GetVoicePitch (VCTX_JAWSCURSOR)
	let GlobalKeyboardPitch = GetVoicePitch (VCTX_KEYBOARD)
	let GlobalMessagePitch = GetVoicePitch (VCTX_MESSAGE)
endIf
EndFunction

Void Function SetAllVoicesToGlobals (int iParamSet)
If iParamSet == V_RATE then
	SetVoiceRate (VCTX_PCCURSOR, GlobalPCRate)
	SetVoiceRate (VCTX_JAWSCURSOR, GlobalJawsRate)
	SetVoiceRate (VCTX_KEYBOARD, GlobalKeyboardRate)
	SetVoiceRate (VCTX_MESSAGE, GlobalMessageRate)
ElIf iParamSet == V_VOLUME then
	SetVoiceVolume (VCTX_PCCURSOR, GlobalPcVolume)
	SetVoiceVolume (VCTX_JAWSCURSOR, GlobalJawsVolume)
	SetVoiceVolume (VCTX_KEYBOARD, GlobalKeyboardVolume)
	SetVoiceVolume (VCTX_MESSAGE, GlobalMessageVolume)
ElIf iParamSet == V_PITCH then
	SetVoicePitch (VCTX_PCCURSOR, GlobalPcPitch)
	SetVoicePitch (VCTX_JAWSCURSOR, GlobalJawsPitch)
	SetVoicePitch (VCTX_KEYBOARD, GlobalKeyboardPitch)
	SetVoicePitch (VCTX_MESSAGE, GlobalMessagePitch)
endIf
EndFunction

Void Function SetVoiceSetting (int ParameterToSet, int Setting, string ContextName, 
int UpOrDown, int InSayAll)
;Thanks to Andres for the fix that got rid of the annoying repetitions
If ParameterToSet == V_PITCH then
	SetVoicePitch (VCTX_GLOBAL, Setting)
	If ! InSayAll then
		If UpOrDown == V_Down then
			SayFormattedMessage (OT_STATUS, cmsg354_L); "Lower"
		ElIf UpOrDown == V_UP then
			SayFormattedMessage (OT_STATUS, cmsg355_L); "Higher"
		endIf
	endIf
ElIf ParameterToSet == V_RATE then
	SetVoiceRate (VCTX_GLOBAL, Setting)
	If ! InSayAll then
		If UpOrDown == V_DOWN then
			SayFormattedMessage (OT_STATUS, cmsg356_L); "Slower"
		ElIf UpOrDown == V_Up then
			SayFormattedMessage (OT_STATUS, cmsg357_L); "Faster", cmsgSilent)
		endIf
	endIf
ElIf ParameterToSet == V_Volume then
	SetVoiceVolume (VCTX_GLOBAL, Setting)
	If ! InSayAll then
		If UpOrDown == V_DOWN then
			SayFormattedMessage (OT_STATUS, cmsg358_L); "Softer"
		ElIf UpOrDown == V_UP then
			SayFormattedMessage (OT_STATUS, cmsg359_L); "Louder"
		endIf
	endIf
endIf
EndFunction

Void Function ChangeVoiceSetting (int iSetting, int iDirection, int InSayAll)
var
	string contextName,
	int CurrentSetting,
	int minSetting,
	int maxSetting,
	int increment
If IsJAWSCursor () then
	let contextName = VCTX_JAWSCURSOR
else
	let contextName = VCTX_PCCURSOR
endIf
let CurrentSetting = GetSettingInformation (iSetting, ContextName, MinSetting, MaxSetting)
If iDirection == V_Down then
	let increment = (maxSetting-minSetting)/20 ; for 10% increments, divide by 20 for 5% increments
	if increment <= 0 then
		let increment = 1 ; for those synthesizers with a short range
	endIf
	let CurrentSetting = max(minSetting,currentSetting-increment) ; keeps the current value within range
ElIf iDirection == V_Up then
let increment = (maxSetting-minSetting)/20
if increment <= 0 then
	let increment = 1 ; for those synthesizers with a short range
endIf
let currentSetting = min(maxSetting,currentSetting+increment)
endIf
SetVoiceSetting (iSetting, CurrentSetting, ContextName, iDirection, InSayAll)
EndFunction

Script DecreaseVoiceRate ()
ChangeVoiceSetting (V_RATE, V_DOWN, False)
EndScript

Script DecreaseVoiceRateSayAll ()
ChangeVoiceSetting (V_RATE, V_DOWN, true)
EndScript

Script IncreaseVoiceRate ()
ChangeVoiceSetting (V_RATE, V_UP, false)
EndScript

Script IncreaseVoiceRateSayall ()
ChangeVoiceSetting (V_RATE, V_UP, true)
EndScript

Script DecreaseVoiceVolume ()
ChangeVoiceSetting (V_VOLUME, V_DOWN, false)
EndScript

Script DecreaseVoiceVolumeSayAll ()
ChangeVoiceSetting (V_VOLUME, V_DOWN, true)
EndScript

Script IncreaseVoiceVolume ()
ChangeVoiceSetting (V_VOLUME, V_UP, false)
EndScript

Script IncreaseVoiceVolumeSayAll ()
ChangeVoiceSetting (V_VOLUME, V_UP, true)
EndScript

Script DecreaseVoicePitch ()
ChangeVoiceSetting (V_PITCH, V_DOWN, false)
EndScript

Script DecreaseVoicePitchSayAll ()
ChangeVoiceSetting (V_PITCH, V_DOWN, true)
EndScript

Script IncreaseVoicePitch ()
ChangeVoiceSetting (V_PITCH, V_UP, false)
EndScript

Script IncreaseVoicePitchSayAll ()
ChangeVoiceSetting (V_PITCH, V_UP, true)
EndScript

Script RestoreVoiceSettings ()
ResetVoiceSettings ()
SayFormattedMessage (OT_STATUS, cmsg360_L, cmsg360_S); "Voice Settings Restored"
EndScript

Script SayAll ()
;If ! IsPcCursor () ||
;IsVirtualPcCursor () ||
;!GlobalMenuMode ||
;(CaretVisible () && 
;! (GetWindowSubTypeCode (GetFocus ()) == WT_EDITCOMBO)) then
If !GlobalMenuMode then
	SayAll()
Else
	PerformScript SayLine ()
EndIf
EndScript

Void Function SayAllStoppedEvent ()
; Insert code here to be run every time SayAll stops.
;For Virtual Cursor, should heading scripts be used ...
VirtualSayAllStops ()
EndFunction

function DialogListHelper (handle ByRef hwnd, string ByRef sList, string ByRef sControlsList, int ByRef iIndex)
var
	handle hNull,
	int iWinType,
	string sWinType,
	string sTemp
While (hwnd != hNull)
	let iWinType = GetWindowSubTypeCode (hwnd)
	While (hwnd != hNull &&
		(!IsWindowVisible (hwnd) || iWinType == wt_static || iWinType == wt_unknown || iWinType == wt_tabcontrol || iWinType == wt_dialog || iWinType == wt_groupbox || iWinType == wt_scrollbar || iWinType == wt_toolbar))
		let hwnd = GetNextWindow (hwnd)
		let iWinType = GetWindowSubTypeCode (hwnd)
	EndWhile
	If (hwnd != hNull) then
		let sWinType = GetWindowType (hwnd)
		If (iWinType == wt_edit || iWinType == wt_listbox || iWinType == wt_listview || iWinType == wt_combobox) then
			let sTemp = GetWindowText (GetPriorWindow (hwnd), false)
		else
			let sTemp = GetWindowText (hwnd, false)
		endIf
		let sList = sList+sTemp+" "+sWinType+LIST_ITEM_SEPARATOR
		let sControlsList = sControlsList+IntToString (hwnd)+LIST_ITEM_SEPARATOR
		let iIndex = iIndex+1
		let hwnd = GetNextWindow (hwnd)
	endIf
EndWhile
;remove trailing delimiters
let sList =stringChopRight(sList,1)
let sControlsList =stringChopRight(sControlsList,1)
EndFunction

Void Function DialogList ()
var
	handle hwnd,
	handle hTemp,
	string sList,
	string sTemp,
	string sControlsList,
	int iIndex,
	int iButton
If !(DialogActive ()) then
	SayFormattedMessage (ot_error, cmsg34_L) ; "Not in a dialog box",
	return
endIf
let hwnd = GetRealWindow (GetFocus ())
let hwnd = GetFirstChild (hwnd)
If (IsMultiPageDialog ()) then
	let hTemp = GetFirstChild (hwnd)
	DialogListHelper (hTemp, sList, sControlsList, iIndex)
	DialogListHelper (hwnd, sList, sControlsList, iIndex)
else
	DialogListHelper (hwnd, sList, sControlsList, iIndex)
endIf
let sList = StringLeft (sList, StringLength (sList)-1)
let sControlsList = StringLeft (sControlsList, StringLength (sControlsList)-1)
let iButton = DlgSelectControls (sList, iIndex, cmsgListOfControls1_L, bt_LeftSingleClick|bt_MoveTo, bt_MoveTo)
If (iIndex == 0) then
	return
endIf
let sTemp = StringSegment (sControlsList, LIST_ITEM_SEPARATOR, iIndex)
let hwnd = StringToHandle (sTemp)
If (iButton == iD_MoveTo) then
	SetFocus (hwnd)
	return
ElIf (iButton == iD_LeftSingleClick) then
	SaveCursor ()
	SpeechOff ()
	JawsCursor ()
	MoveToWindow (hwnd)
	Delay (1)
	LeftMouseButton ()
	SpeechOn ()
	RestoreCursor ()
	return
endIf
EndFunction

Void function DialogPageChangedEvent(HANDLE hwndNewPage,HANDLE hwndOldPage)
SayWindowTypeAndText(hwndNewPage)
If BrailleInUse () then
	RefreshBraille ()
endIf
EndFunction
; For those keystrokes on Braille displays which  perform the function NextDocumentWindow and PreviousDocumentWindow

Script NextDocumentWindow ()
If UserBufferIsActive () then
	UserBufferDeActivate ()
EndIf
TypeKey(cks15)
; Handle the special case in which the user calls the NextDocumentWindow script when focus 
; is positioned on the Tab Control.  In this special case FocusChangedEvent is not called 
; and as a result JAWS does not announce the page change.
If (IsPCCursor()) Then
	Pause ()
	Delay(1)
	If (GetObjectTypeCode ()==WT_TABCONTROL) Then
		; SayWindowTypeAndText(GetFocus())
		SayFocusedObject ()
	EndIf
EndIf
EndScript

Script PreviousDocumentWindow ()
If UserBufferIsActive () then
	UserBufferDeActivate ()
EndIf
TypeKey(cks16)
; Handle the special case in which the user calls the NextDocumentWindow script when focus 
; is positioned on the Tab Control.  In this special case FocusChangedEvent is not called 
; and as a result JAWS does not announce the page change.
If (IsPCCursor()) Then
	Pause ()
	Delay(1)
	If (GetObjectTypeCode ()==WT_TABCONTROL) Then
		; SayWindowTypeAndText(GetFocus())
		SayFocusedObject ()
	EndIf
EndIf
EndScript

; SelectAllItems and UnselectAllButCurrent
; For those braille displays which still use these scripts

Script SelectAllItems ()
TypeKey(cks17)
EndScript

Script UnselectAllButCurrent ()
TypeKey(cks18)
EndScript

; *****
; Following scripts for 
; JAWS and MAGIc

Script MagSayNextLine ()
TypeCurrentScriptKey ()
EndScript

Script MagSayPriorLine ()
TypeCurrentScriptKey ()
EndScript

Script MagSayPriorCharacter ()
TypeCurrentScriptKey ()
EndScript

Script MagSayNextCharacter ()
TypeCurrentScriptKey ()
EndScript

Script MagSelectNextCharacter ()
TypeCurrentScriptKey ()
EndScript

Script MagSelectPriorCharacter ()
TypeCurrentScriptKey ()
EndScript

Script LowerMagicViewMagLevel ()
TypeCurrentScriptKey ()
EndScript

Script RaiseMagicViewMagLevel ()
TypeCurrentScriptKey ()
EndScript

; MAG Selection scripts
Script MagSelectToEndOfLine ()
TypeCurrentScriptKey ()
EndScript

Script MagSelectFromStartOfLine ()
TypeCurrentScriptKey ()
EndScript

Script SayToPunctuation()
SayToPunctuation()
EndScript

void function ScreenStabilizedEvent(handle hwndLastScreenWrite)
; override this event in Application specific script files to process information when the screen 
;becomes stable after a series of writes. You can determine where the last write occured by 
;checking the handle passed to this event. You can thus ignore triggers caused by writing to 
;windows for which you are not interested.
endFunction

void function tutorMessageEvent(handle hwndFocus, int nMenuMode)
var
	handle hWinSwitch,
	int iTutorSpeak,
	int iAccessKeySpeak,
	int iObjType,
	string sCustomTutor
;Keepp alt+tab from over-talking
let hWinSwitch=findTopLevelWindow(cwn1,cscNull)
if (hWinSwitch && isWindowVisible(hWinSwitch)) then
	Return
EndIf
Let iTutorSpeak = ShouldItemSpeak (OT_TUTOR)
Let iAccessKeySpeak = ShouldItemSpeak (OT_ACCESS_KEY)
let iObjType=getWindowSubtypeCode(hwndFocus)
If ! iObjType then
	Let iObjType = GetObjectSubTypeCode ()
EndIf
If nMenuMode > 0 || 
iObjType == WT_CONTEXTMENU ||
iObjType == WT_STARTMENU then
	If nMenuMode != GlobalPrevTutorMenuMode then
		If iTutorSpeak == TUTOR_ALL then
			SayTutorialHelp(iObjType,false)
		EndIf
		Let GlobalPrevTutorMenuMode = GlobalMenuMode; Accurately monitor the state of the menu
	EndIf
	If iAccessKeySpeak == ACCESS_KEY_ALL ||
	iAccessKeySpeak == ACCESS_KEY_MENUS then
		SayTutorialHelpHotKey(hwndFocus,false)
	EndIf
	;Keep the access key from speaking twice
	; This occurs when moving from the System Menu option to the next or previous option:
	;For example, File or Help
	UnScheduleFunction(GlobalHelperFunc)
	Return
Else; Speak it, but not twice during the menus.
	Let sCustomTutor = GetFrameTutorMessage ()
	;If sCustomTutor > cScNull then
	If iTutorSpeak == TUTOR_CUSTOM_ONLY then
		SayMessage (OT_TUTOR, sCustomTutor)
	Else
		SayTutorialHelp(iObjType,false)
	EndIf
EndIf
If iAccessKeySpeak == ACCESS_KEY_ALL ||
iAccessKeySpeak == ACCESS_KEY_DIALOGS then
	SayTutorialHelpHotKey(hwndFocus,false)
EndIf
Let GlobalPrevTutorMenuMode = GlobalMenuMode; Accurately monitor the state of the menu
endFunction

Script SelectASynthesizer ()
var
	int iIndex,;For position in list
	int iSynthX,; Gather information on the specific synthesizer
	string strPath,
	string strKeyName,
	string strPortInfo,
	string strTemp,
	string strListText
Let iSynthX=1;Set up for first synthesizer read
Let strPath=(GetJAWSDirectory()+FILE_SYNTH);Constant already contains the backslashes.
Let strKeyName = hKey_SynthX+(IntToString (iSynthX))+hKey_Name
Let strTemp = IniReadString (Section_Synth, strKeyName, cScNull, strPath)
If ! strTemp then
	Return
EndIf
Let strListText = strTemp
Let strKeyName = hKey_SynthX+(IntToString (iSynthX))+hKey_Port
Let strPortInfo = IniReadString (Section_Synth, strKeyName, cScNull, strPath)
If strPortInfo > cScNull then
	Let strPortInfo = StringSegment (strPortInfo, cScColon, 1); No need to display the port info, 9600,n,8,1,x
	Let strListText = strListText+SynthListItemExtraText +strPortInfo
EndIf
Let iSynthX = iSynthX+1
Let strKeyName = hKey_SynthX+(IntToString (iSynthX))+hKey_Name
Let strTemp = IniReadString (Section_Synth, strKeyName, cScNull, strPath)
While (strTemp > cScNull)
	Let strListText = strListText + LIST_ITEM_SEPARATOR + strTemp
	Let strKeyName = hKey_SynthX+(IntToString (iSynthX))+hKey_Port
	Let strPortInfo = IniReadString (Section_Synth, strKeyName, cScNull, strPath)
	If strPortInfo > cScNull then
		Let strPortInfo = StringSegment (strPortInfo, cScColon, 1); No need to display the port info, 9600,n,8,1,x
		Let strListText = strListText+SynthListItemExtraText +strPortInfo
	EndIf
	Let iSynthX = iSynthX+1
	Let strKeyName = hKey_SynthX+(IntToString (iSynthX))+hKey_Name
	Let strTemp = IniReadString (Section_Synth, strKeyName, cScNull, strPath)
EndWhile
Let iIndex = dlgSelectItemInList (strListText, SynthDialogName, TRUE)
If iIndex > 0 then
	Let strTemp = hKey_SynthX+(IntToString (iIndex))
	SetSynth (strTemp)
EndIf
EndScript

Script MagicKey()
	PerformScript JAWSKey()
EndScript

Script JAWSKey()
var
	int iDown,
	int iOn,
	int bToggleKey,
	string strKey,
	string strName
if (IsSameScript()) then
	TypeCurrentScriptKey()
	let bToggleKey = TRUE;
	let strName = GetCurrentScriptKeyName()
	Let strKey = strName
	if (IsSameKey(strName, cks20)) then
		let strName = hKey_Caps
	elif (IsSameKey(strName, cks21)) then
		let strName = hKey_Scroll
	elif (IsSameKey(strName, cks22)) then
		let strName = hKey_Numlock
	else
		let bToggleKey = FALSE
	endif	

	;Now read in the value of the label for the corresponding key.
	;The label can or can not exist, removal of such should still read the state.
	;This is already a feature of JAWS, hence we will format it accordingly.
	
	;We used to only speak this string when there was some typing echo.  Now, according to
	;Track# 14875, we now speak this string unconditionally.
	;if (GetJcfOption (OPT_TYPING_ECHO) > 0) then
		Let strName = (IniReadString (SECTION_Labels, strName, cScNull, DefaultJcfFile))
		Let strName = (StringChopLeft (strName, 2))
		if ((bToggleKey == TRUE) && (GetKeyState(strKey, iDown, iOn))) then
			if (iOn) then
			Let strName = (FormatString (cmsgMagKeyState, strName, cmsg67_S))
			else
			Let strName = (FormatString (cmsgMagKeyState, strName, cmsg66_S))
			endif	
		endif
		SayMessage (OT_NO_DISABLE, strName)
	;endif
endif
EndScript

Void Function BrailleSelectTextClearValues ()
BrailleSelectTextClearValues ()
EndFunction

;Freedom Scientific NoteTaker Scripts

Script FSLeftRockerDown ()
PerformScript FSLeftRockerDown ()
EndScript

Script FSLeftRockerUp ()
PerformScript FSLeftRockerUp ()
EndScript

Script FSRightRockerDown ()
PerformScript FSRightRockerDown ()
EndScript

Script FSRightRockerUp ()
PerformScript FSRightRockerUp ()
EndScript

Script WhizWheelsOnOff ()
If WhizWheelsShutdown() then
	SayFormattedMessage (OT_NO_DISABLE, cMsgWheelsOn)
Else
	SayFormattedMessage (OT_NO_DISABLE, cMsgWheelsOff)
EndIf
EndScript

Script PressLeftWhizWheel ()
PerformScript PressLeftWhizWheel ()
EndScript

			Script LeftWhizWheelUp ()
PerformScript LeftWhizWheelUp ()
EndScript

Script LeftWhizWheelDown ()
PerformScript LeftWhizWheelDown ()
EndScript

Script PressRightWhizWheel ()
PerformScript PressRightWhizWheel ()
EndScript

Script RightWhizWheelUp ()
PerformScript RightWhizWheelUp ()
EndScript

Script RightWhizWheelDown ()
PerformScript RightWhizWheelDown ()
EndScript

Script RightFocusWhizWheelDown ()
PerformScript RightFocusWhizWheelDown ()
EndScript

Script RightFocusWhizWheelUp ()
PerformScript RightFocusWhizWheelUp ()
EndScript

Script LeftFocusWhizWheelUp ()
PerformScript LeftFocusWhizWheelUp ()
EndScript

Script LeftFocusWhizWheelDown ()
PerformScript LeftFocusWhizWheelDown ()
EndScript

		 Script PressRightFocusWheel ()
PerformScript PressRightFocusWheel ()
EndScript

Script PressLeftFocusWheel ()
PerformScript PressLeftFocusWheel ()
EndScript

script FocusGDBHelpMessage ()
;Provides general information about the use of these buttons
;Located between the advance bars of the Focus Braille displays
;From Freedom Scientific
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
SayFormattedMessage (OT_USER_BUFFER, cMsgFocusGDB)
AddHotKeyLinks ()
EndScript

void Function FrameMoveHelper (string sFrameName)
var
	string sFrameSpeak
JawsCursor ()
MoveToFrame (sFrameName)
;Now format sFrame for speaking ...
Let sFrameSpeak = (FormatString (cMsgJAWSToFrame, sFrameName))
SayFormattedMessage (OT_SMART_HELP, sFrameSpeak)
EndFunction

int function FramesListHelper (string sFrameName, int iTopLeft, int iTopRight, int iBLeft, int iBRight)
Let gstrFrameList = gstrFrameList + LIST_ITEM_SEPARATOR + sFrameName
Return TRUE;
EndFunction

int Function ShowFrameTextHelper (string sFrameName, int iTopLeft, int iTopRight, int iBLeft, int iBRight)
var
	string sFuncTitle,
	string sFuncText;for the embedded  function
Let sFuncTitle = StringMixedCaseToMultiword(sFrameName)
Let sFuncText = FormatString (cFuncFrame, sFrameName)
UserBufferAddText(sFuncTitle,sFuncText,sFuncTitle,
cFont_Aerial,14,ATTRIB_UNDERLINE,RGBStringToColor(cColor_Blue),RGBStringToColor(cColor_White),TRUE)
;Now add the frame text separately.
UserBufferAddText (GetTextInFrame(sFrameName,TRUE)+cScBufferNewLine,
cScNull,cScNull,cFont_Aerial,
12,0,RGBStringToColor(cColor_Black),RGBStringToColor(cColor_White),TRUE)
Return TRUE;
EndFunction

Script ShowFrameText()
If UserBufferIsActive () then
	SayFormattedMessage (OT_STATUS, cmsgVirtualViewer)
	Return
EndIf
UserBufferClear ()
FramesEnumerate ("ShowFrameTextHelper")
If UserBufferGetLength () <= 2 then
	SayFormattedMessage (OT_ERROR, cMsgNoFrames);
	Return
EndIf
UserBufferActivate ()
JAWSTopOfFile ()
SayAll ()
EndScript

Script SelectAFrame ()
var
	int index,
	string sFrame
FramesEnumerate ("FramesListHelper")
If gstrFrameList == cscNull then
	SayFormattedMessage (OT_ERROR, cMsgNoFrames)
	Return
EndIf
Let gstrFrameList = StringChopLeft (gstrFrameList, 1)
Let Index = dlgSelectItemInList (gstrFrameList,cwn15,TRUE)
Delay (2)
If index == 0 then
	Let gstrFrameList = cScNull
	Return
EndIf
Let sFrame = StringSegment (gstrFrameList, LIST_ITEM_SEPARATOR, index)
FrameMoveHelper (sFrame)
Let gstrFrameList = cScNull
EndScript

void Function ForegroundIconicEvent(HANDLE hwndForeground)
; This event is triggered when an application that is minimized receives 
; focus.  When this happens, Say title (insert+T) reports "No window has focus."
; A call to MinimizeAllApps() from this event will set focus to the desktop.
; This implementation has not been sufficiently tested and therefore is
; disabled in this release.
; MinimizeAllApps()
EndFunction

Script SayBatteryLevel ()
; By: S. Dawes 
; Created: 2001/10/26.
; Purpose:  I wrote this script, because, I felt that there was a need for the 
; :  laptop user to have a quick and easy way to monitor the battery level.
; Assumption:  This script is assuming that your battery monitor has the string
; :  "remain" contained within it.  If not, determine a unique string
; :  to rely upon for this script to work.
; :  To make this change, change the value of LTBattery in the Let statement below.
;
; Variables:  STIndex  ->  used to contain the number of entries on the system tray.
; :  STItem   ->  The description of the entry being evaluated on the system tray.
; :  LTBattery  ->  Set to a unique string taken from the battery 
; entry found on the system tray.
;
var 
	int Index,
	int iFound,
	String STItem
; Get the number of items on the system tray.
Let Index = SysTrayGetItemCount ()
; Now start at the end of the list, and look for the laptop battery. 
While (Index >= 1)
	Let STItem = SysTrayGetItemToolTip (Index)
	If StringContains (STItem, cScBatteryIcon) then 
		SayMessage (ot_status, STItem )
		Let Index = 0
		Let iFound = TRUE;
	Else
		Let Index = Index - 1
	EndIf
EndWhile
If ! iFound then
	SayFormattedMessage (OT_ERROR, cMsgBatteryNotFound)
EndIf
EndScript

void function HelpBalloonEvent(handle hwnd, string sText)
; Windows XP Help Balloons
Say(sText,ot_help_balloon)
endFunction

Script FocusToFirstField ()
PerformScript FocusToFirstField ()
EndScript

Script FocusToNextField ()
PerformScript FocusToNextField ()
EndScript

Script FocusToPriorField ()
PerformScript FocusToPriorField ()
EndScript

Script FocusToLastField ()
PerformScript FocusToLastField ()
EndScript

		 Script SelectALink ()
PerformScript SelectALink ()
EndScript

	 ;Heading Scripts
Script MoveToNextHeading()
PerformScript MoveToNextHeading()
EndScript

Script MoveToPriorHeading()
PerformScript MoveToPriorHeading()
EndScript

Script MoveToFirstHeading()
PerformScript MoveToFirstHeading()
EndScript

Script MoveToLastHeading()
PerformScript MoveToLastHeading()
EndScript

Script MoveToNextHeadingLevelN()
PerformScript MoveToNextHeadingLevelN()
EndScript

Script MoveToPriorHeadingLevelN()
PerformScript MoveToPriorHeadingLevelN()
EndScript

Script MoveToFirstHeadingLevelN()
PerformScript MoveToFirstHeadingLevelN()
EndScript

Script moveToLastHeadingLevelN()
PerformScript moveToLastHeadingLevelN()
EndScript

Script SelectAHeading()
PerformScript SelectAHeading()
EndScript


Script ViewSysTrayItems ()
; BY: Stephen Dawes 
Var
	int iMax,
	int index,
	string strTemp,
	String strMessage
; Initialize the necessary variables
; Get the number of items on the system tray.
Let iMax = SysTrayGetItemCount ()
;Must give user error message if no items found in system tray
If ! iMax then
	SayFormattedMessage (OT_ERROR, cMsgNoSysTrayItems)
EndIf
; Index must start as 1, as 0 would return no item.
Let index = 1
; The SysTrayGetItemToolTip function returns the bubble help that would be displayed if the user
; were to hover over the icon with the mouse.
While (index <= iMax)
	Let strTemp = strTemp + cScBufferNewLine+;Adding NewLine so each item is on separate line.
	cScSpace+cScSpace+(SysTrayGetItemToolTip (index))
	Let index = (index+1)
EndWhile
;Now put items in string for Virtual Viewer
Let strMessage = FormatString (cmsgSysTrayItems,strTemp)
;Standard Virtual Viewer posting:
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
SayMessage (OT_USER_BUFFER, strMessage)
EndScript

Script MuteSynthesizer ()
	 ;MuteSynthesizerToggle is passed false so the function will update.
	 SayFormattedMessage (ot_status, MuteSynthesizerToggle (false))
EndScript

script ReadCurrentRow()
if (not InTable()) then
	SayFormattedMessage (OT_ERROR, cMSG314_L, cMSG314_S); "Not in a table"
	return
endIf
Say(GetRowText(cscNull,cscNull,cmsgBlank1), OT_NO_DISABLE)
endScript

script ReadFromCurrentCell()
var
int nCurCol,
int nCurRow

if (not InTable()) then
	SayFormattedMessage (OT_ERROR, cMSG314_L, cMSG314_S); "Not in a table"
	return
endIf
GetCellCoordinates(nCurCol,nCurRow)
Say(GetRowText(cscNull,cscNull,cmsgBlank1,nCurCol,0),OT_NO_DISABLE)
endScript

script ReadToCurrentCell()
var
int nCurCol,
int nCurRow

if (not InTable()) then
	SayFormattedMessage (OT_ERROR, cMSG314_L, cMSG314_S); "Not in a table"
	return
endIf
GetCellCoordinates(nCurCol,nCurRow)
Say(GetRowText(cscNull,cscNull,cmsgBlank1,0,nCurCol),OT_NO_DISABLE)
endScript

script ReadCurrentColumn()
if (not InTable()) then
	SayFormattedMessage (OT_ERROR, cMSG314_L, cMSG314_S); "Not in a table"
	return
endIf
Say(GetColumnText(cscNull, cscNull, cmsgBlank1), OT_NO_DISABLE)
endScript

script ReadToBottomOfColumn()
var
int nCurCol,
int nCurRow
if (not InTable()) then
	SayFormattedMessage (OT_ERROR, cMSG314_L, cMSG314_S); "Not in a table"
	return
endIf
GetCellCoordinates(nCurCol,nCurRow)
Say(GetColumnText(cscNull,cscNull,cmsgBlank1,nCurRow,0),OT_NO_DISABLE)
endScript

script ReadFromTopOfColumn()
var
int nCurCol,
int nCurRow

if (not InTable()) then
	SayFormattedMessage (OT_ERROR, cMSG314_L, cMSG314_S); "Not in a table"
	return
endIf
GetCellCoordinates(nCurCol,nCurRow)
Say(GetColumnText(cscNull,cscNull,cmsgBlank1,0,nCurRow),OT_NO_DISABLE)
endScript

script SelectHTMLElement()
var
string sMsgLong,
string sMsgShort,
string sElementDescription

if not IsVirtualPCCursor() then
	SayFormattedMessage(ot_error, cmsgFeatureRequiresVirtualCursor_L, cmsgFeatureRequiresVirtualCursor_S)
	return
endIf
let sElementDescription=GetElementDescription()
Let sElementDescription = (StringLower (sElementDescription))
If (sElementDescription == TAG_TABLE ||
sElementDescription == TAG_LIST_ORDERED ||
sElementDescription == TAG_LIST_DEFINITION) then
	;let sMsgLong=FormatString(cmsgSelectHTMLElement_L, GetLine ())
	;let sMsgShort=FormatString(cmsgSelectHTMLElement_S, GetLine ())
	;SayFormattedMessage(OT_SELECT, sMsgLong, sMsgShort)
	SelectHierarchicalElement()
	Return
EndIf
;let sMsgLong=FormatString(cmsgSelectHTMLElement_L,cScNull)
;let sMsgShort=FormatString(cmsgSelectHTMLElement_S,cScNull)
;SayFormattedMessage(OT_SELECT, sMsgLong, sMsgShort)
SelectHierarchicalElement()
;SayFormattedMessage (OT_SELECTED_ITEM, GetSelectedText ())
EndScript

script StepToEndOfElement ()
if not IsVirtualPCCursor() then
	SayFormattedMessage(ot_error, cmsgFeatureRequiresVirtualCursor_L, cmsgFeatureRequiresVirtualCursor_S)
	return
endIf
;Enter TRUE for first parameter
; default  second parameter is 0 which means use internal logic to determine number of levels 
StepOutOfCurrentElement (TRUE) 
If SayAllInProgress () then
	Return
EndIf
SayLine ()
EndScript

Script StepToStartOfElement ()
if not IsVirtualPCCursor() then
	SayFormattedMessage(ot_error, cmsgFeatureRequiresVirtualCursor_L, cmsgFeatureRequiresVirtualCursor_S)
	return
endIf
;Enter FALSE for first parameter to go backward
; default  second parameter is 0 which means use internal logic to determine number of levels 
StepOutOfCurrentElement (FALSE)
If SayAllInProgress () then
	Return
EndIf
SayLine ()
EndScript

script MoveToFirstSameElement ()
PerformScript MoveToFirstSameElement ()
EndScript

script MoveToNextSameElement ()
PerformScript MoveToNextSameElement ()
EndScript

Script MoveToPriorSameElement ()
PerformScript MoveToPriorSameElement ()
EndScript

Script MoveToLastSameElement ()
PerformScript MoveToLastSameElement ()
 EndScript

Script MoveToNextDifferentElement ()
PerformScript MoveToNextDifferentElement ()
EndScript

Script MoveToPriorDifferentElement ()
PerformScript MoveToPriorDifferentElement ()
EndScript

Script BrailleToggleTableHeaders ()
BrailleToggleTableHeaders ()
EndScript

Script BrailleToggleTableReading ()
BrailleToggleTableReading ()
EndScript

Script DisplayBasicElementInfo ()
PerformScript DisplayBasicElementInfo ()
EndScript

Script DisplayAdvancedElementInfo ()
PerformScript DisplayAdvancedElementInfo ()
EndScript

Script IEFind ()
PerformScript IEFind ()
EndScript

int function PointNeedsMarking(int x, int y)
;This function is only called if the OPT_BRL_CHECK_EXT_MARKING jcf option is on.
;This must then return true if the character at the supplied point needs 
;marking on the display
return PointNeedsMarking (x, y)
endFunction

Script ToggleKeyboardLogging()
var int bEnabled
let bEnabled = ToggleKeyboardLogging()
if (bEnabled) then
	SayFormattedMessage(OT_STATUS, cmsgKeyboardLoggingEnabled_L, cmsgKeyboardLoggingEnabled_S)
else
	SayFormattedMessage(OT_STATUS, cmsgKeyboardLoggingDisabled_L, cmsgKeyboardLoggingDisabled_S)
Endif
EndScript

Script SwitchInputLanguage ()
	var string strLang,
			string strLong

	TypeCurrentScriptKey()
	Pause ()
	let strLang=GetInputLanguage()
	let strLong = FormatString (cKeyboardLayout_L, strLang)
	SayFormattedMessage(OT_STATUS, strLong, strLang)
EndScript


void function PageRefreshPrewarning(int nSeconds, string sURL)
var
string sSeconds
let sSeconds=intToString(nSeconds)

SayFormattedMessage(OT_SMART_HELP, formatString(cmsgPageRefreshPrewarning_L,sSeconds), formatString(cmsgPageRefreshPrewarning_S,sSeconds))
endFunction

void function QuickKeyNavigationModeChanged(int bEnabled)
if SayAllInProgress() ||
UserBufferIsActive () then
	return;
endIf
;if bEnabled then
;	SayFormattedMessage(OT_JAWS_MESSAGE, cmsgNavigationModeOn_L, cmsgNavigationModeOn_S) 
;else
;	SayFormattedMessage(OT_JAWS_MESSAGE, cmsgNavigationModeOff_L, cmsgNavigationModeOff_S) 
;endIf
endFunction

Script NavigationModeToggle ()
PerformScript NavigationModeToggle ()
EndScript

script VirtualizeWindow()
var
string sText,
handle hwnd,
int tlx,
int tly,
int brx,
int bry

let hwnd=GetRealWindow(GetCurrentWindow())
let tlx=GetWindowLeft(hwnd)
let tly=getWindowTop(hwnd)
let brx=GetWindowRight(hwnd)
let bry=getWindowBottom(hwnd)
let sText=GetTextInRect(tlx,tly,brx,bry,0,IgnoreColor,IgnoreColor,1)
if (sText!=cscNull) then
	SayFormattedMessage(ot_JAWS_Message,msgVirtualizeWindow_L,msgVirtualizeWindow_S)
	UserBufferClear()
	UserBufferAddText(sText)
	UserBufferActivate()
sayLine()
else
	SayFormattedMessage(OT_ERROR,msgNoTextToVirtualize_L,msgNoTextToVirtualize_S)
endIf
endScript

string function ToggleSayCaps (int iRetCurVal)
var
	int iSayCaps
let iSayCaps=getJCFOption(OPT_SAY_CAPS)
if not iRetCurVal then
	; update it	
	If iSayCaps==3 then
		let iSayCaps=0
	else
		let iSayCaps=iSayCaps+1
	EndIf
	SetJcfOption(OPT_SAY_CAPS, iSayCaps)
EndIf
;now return the value
if iSayCaps==0 then
	return cmsgSayCaps0
elif iSayCaps==1 then
	return cmsgSayCaps1
elif iSayCaps==2 then
	return cmsgSayCaps2
elif iSayCaps==3 then
	return cmsgSayCaps3
endIf
EndFunction

string function ToggleExpandAbbreviations(int iRetCurVal)
var
	int iExpandAbbreviations
let iExpandAbbreviations=getJCFOption(optExpandAbbreviations)
if not iRetCurVal then
	; update it	
	let iExpandAbbreviations=!iExpandAbbreviations
	SetJcfOption(optExpandAbbreviations, iExpandAbbreviations)
EndIf
;now return the value
if iExpandAbbreviations then
	return cmsgExpandAbbreviationsOn
else
	return cmsgExpandAbbreviationsOff
endIf
EndFunction

string function ToggleExpandAcronyms(int iRetCurVal)
var
	int iExpandAcronyms
let iExpandAcronyms=getJCFOption(optExpandAcronyms)
if not iRetCurVal then
	; update it	
	let iExpandAcronyms=!iExpandAcronyms
	SetJcfOption(optExpandAcronyms, iExpandAcronyms)
EndIf
;now return the value
if iExpandAcronyms then
	return cmsgExpandAcronymsOn
else
	return cmsgExpandAcronymsOff
endIf
EndFunction

string function ToggleUseVirtualInfoInFormsMode(int iRetCurVal)
var
	int iSetting
let iSetting=getJCFOption(OPT_USE_VIRTUAL_INFO_IN_FORMS_MODE)
if not iRetCurVal then
	; update it	
	let iSetting=!iSetting
	SetJcfOption(OPT_USE_VIRTUAL_INFO_IN_FORMS_MODE, iSetting)
EndIf
;now return the value
if iSetting then
	return cmsgUseVirtualInfoInFormsModeOn
else
	return cmsgUseVirtualInfoInFormsModeOff
endIf
EndFunction

Script SetPunctuationLevel ()
SayFormattedMessage (OT_STATUS, PunctuationToggle (false))
EndScript

Script BrailleSelectBlock ()
SelectFromBrailleToPCCursor ()
EndScript






;%%
Script kod ()
var
int kod
let kod = GetWindowSubtypeCode (GetCurrentWindow ()) 
sayinteger (kod)
EndScript




Script MnogoslovieGrafiki ()
var
	int currentSetting
let currentSetting = GetDefaultJCFOption (OPT_INCLUDE_GRAPHICS)
If (currentSetting == 2) Then
	SetDefaultJcfOption (OPT_INCLUDE_GRAPHICS, 0)
SayString (" ")
ElIf (currentSetting == 0) Then
	SetDefaultJcfOption (OPT_INCLUDE_GRAPHICS, 1)
SayString (" ")	
ElIf (currentSetting == 1) Then
	SetDefaultJcfOption (OPT_INCLUDE_GRAPHICS, 2)
	SayString (" ")
endIf
EndScript




Script kopirovanie ()
CopyToClipboard (GetLine ())
SayString ("")
SayLine ()
EndScript




Script VyhodIzJaws ()
run ("c:\\jaws451\\Jfwkill.exe")
EndScript




Script DictionaryOnOff  ()
if GetJCFOption (OPT_DICTIONARY) then
SayString (" ")
SetJCFOption (OPT_DICTIONARY,off)
 else SetJCFOption (OPT_DICTIONARY,on)
SayString(" ")
 EndIf
EndScript




Script MaximizeWindow ()
var
  int StepsCounter

SpeechOff ()
SaveCursor ()

If (FindGraphic (GetCurrentWindow (), "", S_TOP, S_UNRESTRICTED) == 1) then
  LeftMouseButton ()
Else
  PCCursor ()
  {alt+space}
  let StepsCounter= 0
  While ((GetWord () != "") && (StepsCounter < 10))
    PriorLine ()
    let StepsCounter= StepsCounter +1
    Pause ()
  EndWhile
  If StepsCounter < 10 then
    {enter}
  Else
    {escape}
  EndIf
EndIf
SpeechOn ()
SayString ("")
SpeechOff ()
Pause ()
SpeechOn ()

RestoreCursor ()

EndScript




Script MinimizeWindow ()
var
  int StepsCounter

SpeechOff ()
SaveCursor ()

If (FindGraphic (GetCurrentWindow (), "", S_TOP, S_UNRESTRICTED) == 1) then
  LeftMouseButton ()
Else
  PCCursor ()
  {alt+space}
  let StepsCounter= 0
  While ((GetWord () != "") && (StepsCounter < 10))
    PriorLine ()
    let StepsCounter= StepsCounter +1
    Pause ()
  EndWhile
  If StepsCounter < 10 then
    {enter}
  else
    {escape}
  EndIf
EndIf

SpeechOn ()
SayString ("")
RestoreCursor ()

EndScript




Script SetEloqSynth ()
let globalSelectSynth=Eloq
SetSynth("Eloq")
SetDefaultJCFOption (Opt_Dictionary, 0)
Say("Hello",OT_string)
EndScript



Script SetSPMSynth ()
let globalSelectSynth=SPM
SetSynth("nospeech")
pause()
SetSynth("SPMVS")
SetDefaultJCFOption (Opt_Dictionary, 1)
Say("",OT_string)
EndScript


Script SetUkrSpmVSSynth ()
SetSynth("nospeech")
pause()

SetSynth("Ukrainian")
SetDefaultJCFOption (Opt_Dictionary, 1)
Say("",OT_string)


EndScript


Script setviknorussiansynth ()
SetSynth("Vikno")
SetDefaultJCFOption (Opt_Dictionary, 0)
pause()
pause()
;pause()
;pause()
Say("   ", OT_String)
EndScript

Script SetViknoUkrainianSynth ()
let globalSelectSynth=Digalo
SetSynth("Ukraine")
SetDefaultJCFOption (Opt_Dictionary, 0)
pause()
pause()
;pause()
;pause()
Say("", OT_String)
EndScript

Script SetSakramentSynth ()
let globalSelectSynth=TTS3000
SetSynth("Sakrament")
SetDefaultJCFOption (Opt_Dictionary, 0)
Say("", OT_string);
EndScript


Script setlhsynth ()
let globalSelectSynth=TTS3000
SetSynth("L&H")
SetDefaultJCFOption (Opt_Dictionary, 0)
Say("", OT_string);
EndScript



Script setdigalocorerus ()
let globalSelectSynth=Digalo
SetSynth("Digalo")
SetDefaultJCFOption (Opt_Dictionary, 0)
Say(" ", OT_String)
EndScript



Script SetNoSpeech  ()
let globalSelectSynth=NoSpeech
SetSynth("nospeech")
EndScript






Script SpeakTextFormattingOnOff  ()
if GetJCFOption (OPT_FORMAT_AND_TEXT )
then setJCFOption (OPT_FORMAT_AND_TEXT, off)
SayString ("")
else setJCFOption (OPT_FORMAT_AND_TEXT, on)
SayString ("")
endif

EndScript




Script SpeakAttributesOnOff  ()
if GetJCFOption (OPT_FORMAT_AND_TEXT )
then
if GetJCFOption (OPT_FORMAT_ATTRIBUTES )
then SetJCFOption (OPT_FORMAT_ATTRIBUTES, off)
SayString ("")
else SetJCFOption (OPT_FORMAT_ATTRIBUTES, on)
SayString ("")
endif
else SayString ("")
endif
EndScript



Script SpeakFontOnOff  ()
if GetJCFOption (OPT_FORMAT_AND_TEXT )
then
if GetJCFOption (OPT_FORMAT_FONT )
then SetJCFOption (OPT_FORMAT_FONT , off)
SayString ("")
else SetJCFOption (OPT_FORMAT_FONT , on)
SayString ("")
endif
else SayString ("")
endif
EndScript



Script SpeakPointSizeOnOff  ()
if GetJCFOption (OPT_FORMAT_AND_TEXT )
then
if GetJCFOption (OPT_FORMAT_POINTSIZE)
then SetJCFOption (OPT_FORMAT_POINTSIZE, off)
SayString ("")
else SetJCFOption (OPT_FORMAT_POINTSIZE, on)
SayString ("")
endif
else SayString ("")
endif
EndScript




Script SpeakCapitalizationOnOff  ()
if GetJCFOption (OPT_FORMAT_AND_TEXT )
then
if GetJCFOption (OPT_FORMAT_CAPITALIZATION)
then SetJCFOption (OPT_FORMAT_CAPITALIZATION, off)
SayString ("")
else SetJCFOption (OPT_FORMAT_CAPITALIZATION, on)
SayString ("")
endif
else SayString ("")
endif
EndScript













int function IncreaseSPMVSRate ()
var
int B,
string SPMIni 
let SPMIni=GetJawsDirectory () + "\\SPMVS.Ini"
Let B = IniReadInteger ("parameters", "speed", 0, SPMIni) 
if B < 300 then
let B=B+25
IniWriteInteger ("parameters", "speed", B, SPMIni)
SetSynth ("SPMVS")
return B; 
 else  return -1
endif
EndFunction

int function DecreaseSPMVSRate()
var
int B,
string SPMIni 
let SPMIni=GetJawsDirectory () + "\\SPMVS.Ini"
Let B = IniReadInteger ("parameters", "speed", 0, SPMIni) 
if B > 0 then
let B=B-25
IniWriteInteger ("parameters", "speed", B, SPMIni)
SetSynth ("SPMVS")
return B 
 else  return -1
endif
EndFunction

script SayIncreaseSPMVSRate ()
var 
int N
let N = IncreaseSPMVSRate ()
If N >= 0 then
SayInteger(N)
else SayString("")
endif
EndScript

script SayDecreaseSPMVSRate ()
var 
int N
let N=DecreaseSPMVSRate ()
If N >= 0 then
SayInteger(N)
else SayString("")
endif
EndScript

int function IncreaseSPMVSVolume ()
var
int B,
string SPMIni 
let SPMIni=GetJawsDirectory () + "\\SPMVS.Ini"
Let B = IniReadInteger ("parameters", "Volume", 0, SPMIni) 
if B < 100 then
let B=B+5
IniWriteInteger ("parameters", "Volume", B, SPMIni)
SetSynth ("SPMVS")
return B; 
 else  return -1
endif
EndFunction

int function DecreaseSPMVSVolume ()
var
int B,
string SPMIni 
let SPMIni=GetJawsDirectory () + "\\SPMVS.Ini"
Let B = IniReadInteger ("parameters", "Volume", 0, SPMIni) 
if B > 0 then
let B=B-5
IniWriteInteger ("parameters", "Volume", B, SPMIni)
SetSynth ("SPMVS")
return B 
 else  return -1
endif
EndFunction

Script sayincreasespmvsvolume ()
var 
int N
let N = IncreaseSPMVSVolume ()
If N >= 0 then
SayInteger(N)
else SayString("")
endif
EndScript

Script saydecreasespmvsvolume ()
var 
int N
let N = DecreaseSPMVSVolume ()
If N >= 0 then
SayInteger(N)

else SayString("")
endif
EndScript



Script gromche ()

run ("gromko.exe +10");
SayString("")
EndScript


Script tishe ()

run ("gromko.exe -10");
SayString("")

EndScript

